commit f245f3049d8bb09c5177b4e1c19ab8f5552549b4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 13:23:26 2009 +0100

    [release] 1.0.0

 configure.ac |    9 ++++-----
 1 files changed, 4 insertions(+), 5 deletions(-)

commit 93ecd6d0c43bbdf5bba61134394c76da192d97f5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 12:20:07 2009 +0100

    Update the NEWS

 NEWS |   26 ++++++++++++++++++++++++++
 1 files changed, 26 insertions(+), 0 deletions(-)

commit 77fdd7494e9ccaced094ce825022518dd50d1eaa
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 13:57:07 2009 +0100

    Fix compiler warnings when COGL debug level=minimum

 clutter/cogl/common/cogl-debug.c  |    2 +-
 clutter/pango/cogl-pango-render.c |    4 +++-
 2 files changed, 4 insertions(+), 2 deletions(-)

commit 85b69237a9e0d2eb42634d9f837bc6544379f258
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 12:19:44 2009 +0100

    [docs] Point the TODO to Bugzilla

 TODO |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

commit c6830791673d31b74dfb87d6bda472de040dc3f8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 12:19:26 2009 +0100

    [docs] Update requirements and release notes

 README |   80 +++++++++++++++++++++++++++++++++++++++++++++++++--------------
 1 files changed, 62 insertions(+), 18 deletions(-)

commit a5d6b233086faa03512975763b286c7ea44b7fec
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 13:43:52 2009 +0100

    [units] Add binding-friendly initializers
    
    We should follow the convention for boxed types initializers of:
    
      <type_name>_from_<another_type> (boxed, value)
    
    For ClutterUnits as well; so:
    
      clutter_units_pixels -> clutter_units_from_pixels
      clutter_units_em     -> clutter_units_from_em
      ...
    
    We should still keep the short-hand version as a macro, though.

 clutter/clutter-units.c                    |   36 +++++++++---------
 clutter/clutter-units.h                    |   55 ++++++++++++++++------------
 doc/reference/clutter/clutter-sections.txt |   15 +++++---
 tests/conform/test-clutter-units.c         |    8 ++--
 4 files changed, 63 insertions(+), 51 deletions(-)

commit 57baa2f0bcd37269f029351736681396739263bd
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 13:20:32 2009 +0100

    [animation] Fix variable use
    
    Instead of using the proper typed variables we were overwriting
    the gpointer for the Interval's final value.

 clutter/clutter-animation.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit f4ad3761c48f0cd04c04e4de334c5492eae010cc
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jul 28 12:03:55 2009 +0100

    [win32] Remove the call to clutter_redraw in clutter_stage_win32_show
    
    Since commit 7b811f8b this is done in clutter_stage_show so there is
    no need for it in the backends.

 clutter/win32/clutter-stage-win32.c |   10 +---------
 1 files changed, 1 insertions(+), 9 deletions(-)

commit df586eb507adeed9b83e53c667e706cd1807601a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jul 28 12:00:49 2009 +0100

    [win32] Move the show/hide to be implementations of the interface
    
    This makes clutter_stage_win32_show/hide be implementations of
    ClutterStageWindowIface rather than overriding the methods in
    ClutterActor. This reflects the changes in e4ff24bc for the X11
    backend.

 clutter/win32/clutter-stage-win32.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit c0cf6146343e852d3ebbca79e701d53bcddaa2d5
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jul 28 11:58:34 2009 +0100

    [build/mingw] Update Cairo version to 1.8.6 in mingw-cross-compile.sh
    
    The Pango 1.22 binaries require Cairo 1.8.0 to get
    cairo_show_text_glyphs.

 build/mingw/mingw-cross-compile.sh |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit a1cef026c5eff04f1233d2e9b096987716987cb9
Author: Ole André Vadla Ravnås <ole.andre.ravnas@tandberg.com>
Date:   Tue Jul 7 20:02:25 2009 +0200

    Avoid near/far identifier names.
    
    Leads to conflict with system headers on Windows, where macros named
    "near" and "far" are defined.

 clutter/cogl/common/cogl-matrix.c |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

commit 05883af1f6362b3ad5a762e70412f20aaf608bf9
Author: Ole André Vadla Ravnås <oleavr@gmail.com>
Date:   Wed Jul 1 16:29:12 2009 +0200

    Remove unused variable to fix compiler warning.

 clutter/json/json-object.c |    2 --
 1 files changed, 0 insertions(+), 2 deletions(-)

commit 01578512706fb4bd46d99574a8282cd4d25f7bad
Author: Ole André Vadla Ravnås <oleavr@gmail.com>
Date:   Wed Jul 1 16:27:11 2009 +0200

    Call glClientActiveTexture() through COGL context.
    
    Fixes build issues on systems with OpenGL header older than 1.3.

 clutter/cogl/common/cogl.c        |    4 ++++
 clutter/cogl/gl/cogl-primitives.c |    2 ++
 2 files changed, 6 insertions(+), 0 deletions(-)

commit f61f66c6fe18ad4e8c07379c19cdd3e1bff216b6
Author: Ole André Vadla Ravnås <ole.andre.ravnas@tandberg.com>
Date:   Tue Jun 16 22:29:21 2009 +0200

    Avoid C99 to fix compilation with compilers like MSVC.

 clutter/cogl/common/cogl-blend-string.c |   20 ++++++++++----------
 clutter/cogl/common/cogl-primitives.c   |    8 ++++++--
 clutter/cogl/common/cogl.c              |    4 +++-
 3 files changed, 19 insertions(+), 13 deletions(-)

commit ab5a10768c225230aad25299d129269c88df1e54
Author: Ole André Vadla Ravnås <oleavr@gmail.com>
Date:   Mon May 18 17:30:36 2009 +0200

    Initialize pixel data before glReadPixels().

 clutter/clutter-main.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 9cf8410b0fba4d7cb508968830ee095d92cf5d74
Author: Haakon Sporsheim <haakon.sporsheim@gmail.com>
Date:   Tue Mar 31 14:45:45 2009 +0200

    Reposition variable declarations to avoid C99.

 tests/interactive/test-cogl-vertex-buffer.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

commit 94a571ea76ee20b93a8db04e980d08bf283ed34b
Author: Haakon Sporsheim <haakon.sporsheim@gmail.com>
Date:   Tue Mar 31 14:44:46 2009 +0200

    Add MSVC preprocessor guards in test-clutter-cairo-flowers.c

 tests/interactive/test-clutter-cairo-flowers.c |    7 ++++++-
 1 files changed, 6 insertions(+), 1 deletions(-)

commit fa4a37072ed3113862802b1a97be6dfb74abcdd2
Author: Haakon Sporsheim <haakon.sporsheim@gmail.com>
Date:   Tue Mar 31 14:43:12 2009 +0200

    Add white_color a variable on the stack.

 tests/interactive/test-scale.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

commit fe416fb745fe4293e889d5179707051c959af921
Author: Haakon Sporsheim <haakon.sporsheim@gmail.com>
Date:   Tue Mar 31 14:41:44 2009 +0200

    Add int dummy; to empty struct TestConformSimpleFixture definition.

 tests/conform/test-conform-common.h |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit f852ade82379c6241683df741448be6146bb76ce
Author: Haakon Sporsheim <haakon.sporsheim@gmail.com>
Date:   Tue Mar 31 14:39:46 2009 +0200

    Remove config.h inclusion.

 tests/interactive/test-fbo.c    |    1 -
 tests/interactive/test-shader.c |    1 -
 2 files changed, 0 insertions(+), 2 deletions(-)

commit e4eed92177e6720b9713227ca4b1ecd0f5ce8c0b
Author: Haakon Sporsheim <haakon.sporsheim@gmail.com>
Date:   Tue Mar 31 14:37:07 2009 +0200

    Reposition variable declarations to avoid C99.

 clutter/cogl/common/cogl-material.c |    3 ++-
 clutter/cogl/common/cogl-matrix.c   |    6 ++++--
 2 files changed, 6 insertions(+), 3 deletions(-)

commit dbc9c16259e55e3715dcd2c0286c13597a45d71d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jul 28 10:39:18 2009 +0100

    Remove the MSVC build files
    
    These are hopelessly out of date so they just cause more trouble than
    they're worth.
    
    Anyone interested in building with MSVC would be better off starting
    from the build files available as part of the OAH project which is
    located here:
    
    https://launchpad.net/oah

 build/msvc_2k5/README                  |   62 ---
 build/msvc_2k5/clutter-version.h       |   27 --
 build/msvc_2k5/clutter.sln             |  131 ------
 build/msvc_2k5/clutter.vcproj          |  772 --------------------------------
 build/msvc_2k5/test-actors.vcproj      |  201 ---------
 build/msvc_2k5/test-behave.vcproj      |  201 ---------
 build/msvc_2k5/test-boxes.vcproj       |  177 --------
 build/msvc_2k5/test-depth.vcproj       |  201 ---------
 build/msvc_2k5/test-entry.vcproj       |  177 --------
 build/msvc_2k5/test-events.vcproj      |  177 --------
 build/msvc_2k5/test-offscreen.vcproj   |  177 --------
 build/msvc_2k5/test-perspective.vcproj |  177 --------
 build/msvc_2k5/test-project.vcproj     |  177 --------
 build/msvc_2k5/test-rotate.vcproj      |  201 ---------
 build/msvc_2k5/test-scale.vcproj       |  177 --------
 build/msvc_2k5/test-score.vcproj       |  177 --------
 build/msvc_2k5/test-script.vcproj      |  201 ---------
 build/msvc_2k5/test-text.vcproj        |  183 --------
 build/msvc_2k5/test-textures.vcproj    |  177 --------
 build/msvc_2k5/test-threads.vcproj     |  177 --------
 build/msvc_2k5/test-timeline.vcproj    |  177 --------
 build/msvc_2k5/version.rc              |   48 --
 22 files changed, 0 insertions(+), 4175 deletions(-)

commit fa3728126fe39e7a885184a2b69a93ac2ea34aa8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 28 11:25:11 2009 +0100

    [animation] Force the final state inside ::completed
    
    In case we are skipping too many frames, we should force the animation
    instance to apply the final state of the animated interval inside the
    ::completed signal handler.

 clutter/clutter-animation.c |   18 +++++++++++++++++-
 1 files changed, 17 insertions(+), 1 deletions(-)

commit a8eb5bd461369979d75d40a1a6d17aa43141643e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 17:24:35 2009 +0100

    [build] Generate ChangeLog from the Git import

 Makefile.am |    5 +++--
 1 files changed, 3 insertions(+), 2 deletions(-)

commit 76140c5f521a8912786c292a2699b48a7b873d16
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 16:51:14 2009 +0100

    [build] Use API_VERSION, not MAJORMINOR
    
    The correct macro for Clutter's API version is CLUTTER_API_VERSION,
    not CLUTTER_MAJORMINOR anymore.

 doc/reference/clutter/Makefile.am |    2 +-
 doc/reference/cogl/Makefile.am    |    2 +-
 tests/conform/Makefile.am         |    2 +-
 tests/interactive/Makefile.am     |    2 +-
 tests/micro-bench/Makefile.am     |    3 ++-
 5 files changed, 6 insertions(+), 5 deletions(-)

commit 42ea471e330bbff217e7d5c199885e3991a47e06
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 16:10:07 2009 +0100

    Remove explicit size of the Vertex arrays
    
    The Vertex arrays passed to some ClutterActor methods should not
    have the size. Albeit being technically correct, it's not a good
    practice.

 clutter/clutter-actor.c |    6 +++---
 clutter/clutter-actor.h |    4 ++--
 2 files changed, 5 insertions(+), 5 deletions(-)

commit fe0e7f9f74358d8333135e51d9c3937ce7e59967
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 15:42:31 2009 +0100

    [stage] Add a warning for :offscreen usage
    
    The Stage:offscreen property hasn't been tested for ages, and it
    should really just use a FBO, not indirect rendering on a X Pixmap
    only on X11. There are better ways anyway to get the current
    contents of ClutterStage as a buffer anyway.
    
    We might remove it at any later date, or actually make it work
    properly.

 clutter/clutter-stage.c |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit 6e6d0a5ea611a99438ae455c1f485e882f621863
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 15:08:03 2009 +0100

    [glx] Explicitly set the depth size for GLX visuals
    
    When requesting a GLX visual from the X server we should explicitly
    set the GL_DEPTH_SIZE and the GL_ALPHA_SIZE bits, otherwise some
    functionality might just not work, or work unreliably.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1723

 clutter/glx/clutter-backend-glx.c |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit 88e77b25dfeeead3b4d54d2b24ab9056459c6ee9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 15:01:52 2009 +0100

    Convert gint to GLints in the Shader types wrapper
    
    The GValue wrappers for ClutterShader types should always store
    values using GL types (GLfloat, GLint) internally, but give and
    take generic C types (float, int) to the Clutter side.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1359

 clutter/clutter-shader-types.c |   14 +++++++-------
 1 files changed, 7 insertions(+), 7 deletions(-)

commit ad7dcc989648791e8fec1bb45711c9f71671dfe0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 12:04:40 2009 +0100

    [color] Fix HLS to RGB colorspace conversion
    
    The HLS to RGB conversion in case the S value is zero is:
    
      R = G = B = luminance
    
    ClutterColor uses a byte (0 to 255) for the R, G and B channels
    encoding, while luminance is expressed using a floating point value
    in the closed interval [0, 1]; thus the case above becomes:
    
      R = G = B = (luminance * 255)
    
    The clutter_color_from_hls() code is missing the final step of
    de-normalizing the luminance value, and so it breaks the roundtrip
    colorspace conversion between RGB and HLS.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1695

 clutter/clutter-color.c |   14 +++++---------
 1 files changed, 5 insertions(+), 9 deletions(-)

commit db2fda9c430beed64309c1881a44917933863bd0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 27 11:46:26 2009 +0100

    [tests] Add RGB<->HLS roundtrip test unit
    
    The ClutterColor conformance test should have a unit for verifying
    the RGB<->HLS conversion code, especially the ability to roundtrip
    between the two colorspaces.

 tests/conform/test-color.c        |   69 +++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c |    1 +
 2 files changed, 70 insertions(+), 0 deletions(-)

commit 894fe4ba93f37f46c4a999022714ccb224a35703
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Wed Jul 22 15:38:44 2009 -0400

    Always create the Damage object for ClutterX11TexturePixmap auto updates
    
    If clutter_x11_texture_set_window() was called after
    clutter_x11_texture_pixmap_set_automatic(), then the Damage object would
    not be properly created so updates to the window were ignored.
    
    Refactor creation of the damage object to a separate function, and
    call it from clutter_x11_texture_set_window() and clutter_x11_texture_set_pixmap()
    as appropriate. Addition and removal of the filter function is made
    conditional on priv->damage to make free_damage_resources() cleanly
    idempotent.
    
    See: http://bugzilla.gnome.org/show_bug.cgi?id=587189 for the original
    bug report.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1710
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/x11/clutter-x11-texture-pixmap.c |   74 ++++++++++++++++++++++--------
 1 files changed, 54 insertions(+), 20 deletions(-)

commit 2c2f31b1be57380d4368f6da1d0a4529a5a7f8c1
Author: Michael Mortensen <michael@f3k.org>
Date:   Sun Jul 26 20:13:36 2009 +0100

    [osx] Update events to floating point coordinates
    
    The event translation code should be using the float type for
    coordinates.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1725
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/osx/clutter-event-osx.c |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

commit 13f32cb3b91d5087297a3e17ee97ce46154f9243
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jul 26 20:10:42 2009 +0100

    [osx] Implement StageWindow::show/::hide
    
    Instead of using the Actor class ::show and ::hide virtual function,
    use the StageWindow interface API.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1724

 clutter/osx/clutter-stage-osx.c |   29 +++++++++++++----------------
 1 files changed, 13 insertions(+), 16 deletions(-)

commit e860d939f9d9611dcf5b8c6e70272b6318a4ba94
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jul 23 19:04:27 2009 +0100

    [text] Allow key navigation by word
    
    When pressing Ctrl with the left and right arrow keys we should
    skip to (or select until) the previous and next word, respectively.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1713

 clutter/clutter-text.c |   92 +++++++++++++++++++++++++++++++++++-------------
 1 files changed, 67 insertions(+), 25 deletions(-)

commit 6a1506bd5f920430de6a6e2f035fef9da2557714
Author: Geoff Gustafson <geoff@linux.intel.com>
Date:   Thu Jul 23 18:21:10 2009 +0100

    [text] Queue a redraw when the selection is cleared
    
    If you select all the text in a ClutterText, there is an invisible
    cursor position either at the beginning or end. If it's at the beginning,
    the bug is that left arrow won't clear the selection. If it's at the end,
    the bug is that the right arrow won't.
    
    Here are the ways to reproduce it:
    
    a. Ctrl-A selects all and moves the hidden cursor position to the left.
    b. For single line: End, Shift-Home does the same.
    c. Or manually moving to the end and doing Shift-Left Arrow to the
       beginning.
    
    These all put it in the state where right arrow will properly clear
    selection and move to cursor position 1, but left arrow fails to clear
    the selection.
    
    For b and c above, the opposite will give you the end case where right
    arrow doesn't work.
    
    Anyway, it turns out clear_selection is getting called, it just doesn't
    show up because it's not doing a queue_redraw. So the attached patch
    seems to fix things.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-text.c |    6 +++++-
 1 files changed, 5 insertions(+), 1 deletions(-)

commit 29d8d60487878f5bc87caee08cadc15789875e4d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 16:35:50 2009 +0100

    [docs] Fix wrong XML elements

 .../clutter/clutter-animation-tutorial.xml         |    2 +-
 doc/reference/clutter/creating-behaviours.xml      |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 2e38730eb1c16040503ab39625648f35e8ecffb5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 14:13:31 2009 +0100

    [docs] Update the Actor subclassing documentation
    
    Mention map/unmap and fix the examples code.
    
    Update the Container virtual functions.

 doc/reference/clutter/subclassing-ClutterActor.xml |   56 ++++++++++++--------
 1 files changed, 34 insertions(+), 22 deletions(-)

commit ea436a20b31eef70af60beb5366e1ccad1261c4a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 14:11:28 2009 +0100

    [build] Use per-target flags and libraries
    
    AM_LDFLAGS is ignored by the LDFLAGS target, and it's also not the right
    place to put the libraries used by the linker.
    
    Thanks to Vincent Untz for spotting this.

 tests/interactive/Makefile.am |   10 ++++------
 1 files changed, 4 insertions(+), 6 deletions(-)

commit ed005685c9351b23795d40bb91cb862b92641f2b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 11:51:20 2009 +0100

    [docs] Update the "creating new behaviours" chapter
    
    The signature of the ::alpha_notify virtual function has been
    changed with the switch to float ClutterAlpha.

 doc/reference/clutter/creating-behaviours.xml |   47 +++++++++----------------
 1 files changed, 17 insertions(+), 30 deletions(-)

commit c87fea6cf1f3e3015bf2c505f0d140682b714e99
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 11:50:08 2009 +0100

    [docs] Update the building instructions
    
    New configure script command line switches have been added since
    the last time we updated the documentation.

 doc/reference/clutter/building-clutter.xml |   70 +++++++++++++++++++++++++---
 1 files changed, 63 insertions(+), 7 deletions(-)

commit 78773ab6fe96923a70e09b903db188ac5ad90f9a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 11:29:52 2009 +0100

    [docs] Update the animations tutorial
    
    Bring the Animation framework introduction/tutorial up to the 1.0
    API for timelines and animations.

 .../clutter/clutter-animation-tutorial.xml         |  742 +++++++++-----------
 1 files changed, 321 insertions(+), 421 deletions(-)

commit fdfd208c044609a9215f09a91026fe6f02773a3a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 09:22:34 2009 +0100

    Fix copy-and-paste errors in the deprecation macros
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1704

 clutter/clutter-deprecated.h |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

commit 605927db5b9d9ddb8677458b94ad2ca6d058f355
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 21 09:20:09 2009 +0100

    [docs] Fix typo in the effects migration guide
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1706

 doc/reference/clutter/migrating-ClutterEffect.xml |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit eff857bc7f21dcfd2b8cae5f4ede1f673c24ffd1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 20 20:59:18 2009 +0100

    [docs] Improve the Units to and from string conversion
    
    Make sure to document the conversion to and from strings for ClutterUnits,
    with negative examples and with the behaviour for fractionary bits.

 clutter/clutter-units.c |   22 ++++++++++++++++++----
 1 files changed, 18 insertions(+), 4 deletions(-)

commit b1d98c25f4d70bc355e2b4d66c2496ab58b9b60c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 20 12:49:35 2009 +0100

    [doc] Miscellaneous documentation fixes
    
    Remove private symbols, and add missing public ones.

 clutter/cogl/cogl-material.h               |   79 +++++++++++++++-------------
 clutter/cogl/cogl-types.h                  |   16 ++++++
 clutter/cogl/cogl.h.in                     |   31 ++++++-----
 doc/reference/clutter/clutter-sections.txt |    1 -
 doc/reference/cogl/Makefile.am             |    7 +++
 doc/reference/cogl/cogl-sections.txt       |   22 +-------
 6 files changed, 83 insertions(+), 73 deletions(-)

commit cdb239756b8c369566ae2c45b3562d2a838674cc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 20 12:47:53 2009 +0100

    [cogl] Make the blend string error domain public
    
    The error domain and codes must present in a publicly installed header
    otherwise they won't be usable to match a GError.

 clutter/cogl/cogl-types.h               |   11 +++++++++++
 clutter/cogl/common/cogl-blend-string.c |    2 +-
 clutter/cogl/common/cogl-blend-string.h |   13 -------------
 3 files changed, 12 insertions(+), 14 deletions(-)

commit e1e8c76ad7d7391fcf2ee79d730ee96fa8528c10
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 20 11:45:47 2009 +0100

    [gitignore] Add test-materials

 .gitignore |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 56ef6727b5807c245e3eaf434653007efce70fda
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jul 14 13:47:35 2009 +0100

    Allow disabling motion event throttling
    
    It might be desirable for some applications and/or platforms to get
    every motion event that was delivered to Clutter from the windowing
    backend. By adding a per-stage flag we can bypass the throttling
    done when processing the events.
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1665

 clutter/clutter-stage.c                    |   76 +++++++++++++++++++++++----
 clutter/clutter-stage.h                    |    8 ++-
 doc/reference/clutter/clutter-sections.txt |    2 +
 3 files changed, 71 insertions(+), 15 deletions(-)

commit f7850b516c1481f7a63c68a2e0c2b9959bdd67a6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jul 18 19:40:29 2009 +0100

    [docs] Move the releasing process to a separate file
    
    The documentation on how to release Clutter should be in a separate
    file from the documentation on how to hack on Clutter.

 HACKING   |   38 --------------------------------------
 RELEASING |   56 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 56 insertions(+), 38 deletions(-)

commit da37e1e27db84135a6349460f68159f16cd02e0c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun Jul 19 10:08:32 2009 +0100

    [doc] Remove references to cogl_vertex_buffer_delete_indices
    
    These referencese were left over from before indices got CoglHandles to
    uniquely identify them.  cogl_handle_unref can be used to delete indices
    now.

 clutter/cogl/cogl-vertex-buffer.h    |   14 --------------
 doc/reference/cogl/cogl-sections.txt |    1 -
 2 files changed, 0 insertions(+), 15 deletions(-)

commit dc0b1cddf5bc0195c78b0ab15a8dc54c7aa49913
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jul 18 16:59:54 2009 +0100

    [cogl/gles] Fix missing symbols in CoglContext
    
    Keep the CoglContext in sync between GL and GLES backends. We ought
    to find a way to have a generic context, though, and have backend
    specific sections.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1698

 clutter/cogl/gles/cogl-context.h |   11 +++++++----
 1 files changed, 7 insertions(+), 4 deletions(-)

commit a11b912dea3f3ad9d51d4600c6aac1b69dc004a9
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri Jul 17 15:15:03 2009 -0400

    Fix parallel build of introspection
    
    We need to explicitly force order so that ClutterJson.gir and Cogl.gir
    are present in the parent directory before we try to build Clutter.typelib.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1700
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/Makefile.am |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit 7654ef10abfc5f207603ecd9012c810adb62a52a
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri Jul 17 15:10:06 2009 -0400

    Fix building introspection when dolt is not in use
    
    On some platforms (anything but Linux, and on obscure Linux
    architectures) dolt isn't used, so $(top_builddir)/doltlibtool
    won't exist. $(top_builddir)/libtool will always be generated
    even if dolt is used, so just use that unconditionally. We don't
    need the extra speed when linking the single program for
    introspection.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1699
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/Makefile.am      |    2 +-
 clutter/cogl/Makefile.am |    2 +-
 clutter/json/Makefile.am |    2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 8ca87ea60f5f522f98a58da86b8dc69e8a0b79de
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jul 17 17:51:26 2009 +0100

    Post-release bump to 0.9.9

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 3dc3d46967aea8714b23ed31cb51e2085a8b78e7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jul 17 17:32:45 2009 +0100

    [release] 0.9.8

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 6b30b76b6845cc100e16fd5ada7ed12f784b40c3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jul 17 17:32:20 2009 +0100

    Update NEWS file

 NEWS |   38 ++++++++++++++++++++++++++++++++++++++
 1 files changed, 38 insertions(+), 0 deletions(-)

commit f0ec828188519e69944509584c4e925f572720ec
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 13 17:27:01 2009 +0100

    Fix comments inside configure.ac

 configure.ac |    8 +++++---
 1 files changed, 5 insertions(+), 3 deletions(-)

commit 7b811f8be4be0529b50a24397cee86e8ecf02f3a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jul 17 12:43:52 2009 +0100

    [stage] Force an allocation before showing the stage
    
    A lot of applications change the size of the stage from the default
    before the stage is initially shown. The size change won't take affect
    until the first allocation run. However we want the window to be at
    the correct size when we first map it so we should force an allocation
    run before showing the stage.
    
    There was an explicit call to XResizeWindow in
    clutter_stage_x11_show. This is not needed anymore because
    XResizeWindow will already have been called by the allocate method.

 clutter/clutter-stage.c         |    4 ++++
 clutter/x11/clutter-stage-x11.c |   15 ---------------
 2 files changed, 4 insertions(+), 15 deletions(-)

commit 8f9f6aaf4178266b38709bb7f7d6f118cc2d6de2
Author: Marcos <marcos.e.carranza@intel.com>
Date:   Mon Jul 13 17:04:05 2009 +0100

    [win32] Compilation fixes
    
    Remove the usage of the old CLUTTER_UNITS_* macros and put back a
    missing ';'.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/win32/clutter-stage-win32.c |   14 +++++++-------
 1 files changed, 7 insertions(+), 7 deletions(-)

commit 7a8895944b373a99023bc21998a48079debcc544
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 13 16:56:47 2009 +0100

    [osx] Enable motion event dispatch
    
    By default NSWindow does not listen to mousemoved events and hence the
    default behaviour for Actors using the "motion-event" signal  differs
    from backend to backend.
    
    Using setAcceptsMouseMovedEvents seems to fix it; unfortunately, I
    cannot verify it, but since nobody is currently working on the Quartz
    backend I guess it cannot get more broken than how currently is.
    
    Thanks to: Michael <michael@f3k.org>
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1687

 clutter/osx/clutter-stage-osx.c |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit d59b9333a19842e559f9f161d26d0c1d623eafa2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 13 16:53:06 2009 +0100

    [osx] Remove old units macros
    
    Remove the usage of CLUTTER_UNITS_* macros and at least get the
    chance to make the OSX backend compile.
    
    Hopefully, since I can't currently test it.

 clutter/osx/clutter-stage-osx.c |   24 ++++++++++++------------
 1 files changed, 12 insertions(+), 12 deletions(-)

commit af5e432ba9bf56ccd376d52e73e0e23d5bc9b37c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 13 16:18:27 2009 +0100

    [actor] Allow querying whether we are painted by a Clone
    
    It would be useful inside a custom actor's paint function to be able to
    tell if this is a primary paint call, or if we are in fact painting on
    behalf of a clone.
    
    In Mutter we have an optimization not to paint occluded windows; this is
    desirable for the windows per se, to conserve bandwith to the card, but
    if something like an application switcher is using clones of these windows,
    they will not get painted either; currently we have no way of
    differentiating between the two.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1685

 clutter/clutter-actor.c                    |   32 ++++++++++++++++++++++++++++
 clutter/clutter-actor.h                    |    2 +
 doc/reference/clutter/clutter-sections.txt |    1 +
 3 files changed, 35 insertions(+), 0 deletions(-)

commit 43d394ebae027e5af963d5f3f459ed57bbc9617f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 13 16:16:38 2009 +0100

    Remove unused TEXTURE_IN_CLONE_PAINT private flag
    
    The CLUTTER_TEXTURE_IN_CLONE_PAINT was used with the old CloneTexture
    actor; now that we have ClutterClone nothing sets the private flag
    anymore, and the flag itself is not needed.

 clutter/clutter-private.h |    9 ++++-----
 clutter/clutter-texture.c |    7 -------
 2 files changed, 4 insertions(+), 12 deletions(-)

commit 13f31d83190be1a0e47c1aedf0570f8e6ad8f0b8
Author: Xu Li <xu.li@intel.com>
Date:   Mon Jul 13 16:06:13 2009 +0800

    [x11] update_wm_hints after unsetting WITHDRAWN
    
    Updating the WM hints on the stage window shortcircuits if the stage
    is in WITHDRAWN state, so we need to move the update_wm_hints() call
    after the flag has been unset.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/x11/clutter-stage-x11.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit 07453a5861073fabdf64fe394c1caa71fc39d45c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jul 13 15:31:38 2009 +0100

    [glx] Make the wait_for_vblank function private
    
    Nobody should be using the function to wait for the vblank outside
    of the GLX backend.

 clutter/glx/clutter-backend-glx.c |  120 ++++++++++++++++++------------------
 clutter/glx/clutter-backend-glx.h |   10 +--
 2 files changed, 63 insertions(+), 67 deletions(-)

commit 5425a6e311e12da044687ac17ce387b939b71547
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 15:47:57 2009 -0400

    Call glFinish() before manually waiting for VBLANK
    
    If we manually wait for the VBLANK with:
    
      - SGI_video_sync
      - Direct usage of the DRM ioctl
    
    Then we should call glFinish() first, or otherwise the swap-buffers
    may be delayed by pending drawing and cause a tear.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1636
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/glx/clutter-backend-glx.c |   31 +++++++++++++++++++++++++++----
 1 files changed, 27 insertions(+), 4 deletions(-)

commit b08bbcccad7fffc4b7c829f963c3130a34ed8ae9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jul 12 01:43:41 2009 +0100

    [tests] Remove test-perspective
    
    The perspective test was used essentially to determine whether the
    perspective set up in COGL worked correctly. The perspective code
    has been changed a lot since Clutter 0.3: we rely on client-side
    matrices and we use floating point; so, all the conditions the test
    was supposed to verify do not exist anymore.

 tests/interactive/Makefile.am        |    1 -
 tests/interactive/test-perspective.c |   51 ----------------------------------
 2 files changed, 0 insertions(+), 52 deletions(-)

commit ea56a5e7a802a46f9ad6fe12480e16dc587c09b2
Author: Evan Martin <martine@danga.com>
Date:   Sun Jul 12 01:38:40 2009 +0100

    [docs] Fix typos and remove mentions of SVN
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 HACKING                  |    3 ++-
 clutter/cogl/cogl-path.h |    2 +-
 tests/README             |    2 +-
 3 files changed, 4 insertions(+), 3 deletions(-)

commit efc16a4d90c48d41376769bca93cd2091d40665c
Author: Jakub Higersberger <ramarren@gmail.com>
Date:   Fri Jul 3 14:51:17 2009 +0200

    Use correct signal detail
    
    The Animation should connect to the notify::alpha signal, not to
    the non-existing notify::value signal.
    
    Fixes bugs:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1674
      http://bugzilla.openedhand.com/show_bug.cgi?id=1688
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-animation.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 5a554bf063a3b673bd7f30d9a92be218e4e810c7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jul 12 01:27:31 2009 +0100

    Small code clean up
    
    Make ClutterTexture slightly more similar to the rest of the code base.

 clutter/clutter-texture.c |   38 ++++++++++++++++++++++++--------------
 1 files changed, 24 insertions(+), 14 deletions(-)

commit 1920b03381e9b44aab9f6a5a64e8bb4c0cec1b20
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jul 7 16:16:56 2009 +0100

    [cogl] Fix more brokeness with _cogl_material_equal
    
    commit e2c4a2a9f83 fixed one thing but broke many others things :-/
    hopfully this fixes that.
    
    It turned out that the journal was mistakenly setting the OVERRIDE_LAYER0
    flush option for all entries, but some other logic errors were also
    uncovered in _cogl_material_equal.

 clutter/cogl/common/cogl-material.c   |   73 ++++++++++++++++++++++++---------
 clutter/cogl/common/cogl-primitives.c |    7 ++-
 2 files changed, 58 insertions(+), 22 deletions(-)

commit 8fb3a48ae2b6c9a87f17a874fad12d8f1199c29e
Author: pippin <pippin@localhost.localdomain>
Date:   Thu Jul 9 15:45:08 2009 -0400

    serialize upload of asyncronously loaded textures
    
    Rate limit the uploading of textures to stop if it uses more than 5ms
    during one master clock iteration.

 clutter/clutter-texture.c |   74 +++++++++++++++++++++++++++++++++++++++-----
 1 files changed, 65 insertions(+), 9 deletions(-)

commit 211bf798544f76af7fe9e7c9893f66a0f84e02b0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jul 9 20:03:01 2009 +0100

    ensure next iteration
    
    Added an internal clutter function, _clutter_master_clock_ensure_next_iteration
    that ensures another iteration of the master clock, can be called from repaint
    functions as well as other threads.

 clutter/clutter-master-clock.c |   23 +++++++++++++++++++++++
 clutter/clutter-master-clock.h |   15 ++++++++-------
 2 files changed, 31 insertions(+), 7 deletions(-)

commit e2c4a2a9f8324a3a17104a15034a40279b4910bb
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat Jul 4 00:15:49 2009 +0100

    [cogl] Fix drawing with sliced textures using material layer0 overrides
    
    To help us handle sliced textures; When flushing materials there is an
    override option that can be given to replace the texture name for layer0
    so we may iterate the slices without needing to modify the material
    in use.
    
    Since improving the journal's ability to batch state changes we added a
    _cogl_material_equals function that is used by the journal to compare
    materials and identify when a state change is required, but this wasn't
    correctly considering the layer0 override resulting in false positives that
    meant the journal wouldn't update the GL state and the first texture name
    was used for all slices.

 clutter/cogl/common/cogl-material-private.h |    3 +-
 clutter/cogl/common/cogl-material.c         |  208 ++++++++++++++++++---------
 clutter/cogl/common/cogl-primitives.c       |    3 +-
 3 files changed, 144 insertions(+), 70 deletions(-)

commit df4429462fa495e44d3a8431ab27771426f7ba42
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jul 3 00:34:10 2009 +0100

    [cogl matrix stack] Create a client side matrix stack for the projection matrix
    
    The cost of glGetFloatv with Mesa is still representing a majority of our
    time in OpenGL for some applications, and the last thing left using this is
    the current-matrix API when getting the projection matrix.
    
    This adds a matrix stack for the projection matrix, so all getting, setting
    and modification of the projection matrix is now managed by Cogl and it's only
    when we come to draw that we flush changes to the matrix to OpenGL.
    
    This also brings us closer to being able to drop internal use of the
    deprecated OpenGL matrix functions, re: commit 54159f5a1d02

 clutter/cogl/common/cogl-current-matrix.c |  105 +++++++++++++++++-----------
 clutter/cogl/common/cogl-current-matrix.h |    2 +
 clutter/cogl/common/cogl-matrix-stack.c   |    8 +--
 clutter/cogl/common/cogl-matrix.c         |    1 +
 clutter/cogl/common/cogl-primitives.c     |   10 ++-
 clutter/cogl/common/cogl-vertex-buffer.c  |    4 +-
 clutter/cogl/common/cogl.c                |    7 +-
 clutter/cogl/gl/cogl-context.h            |    1 +
 clutter/cogl/gl/cogl-primitives.c         |    6 +-
 9 files changed, 85 insertions(+), 59 deletions(-)

commit c3cc553c4991100b456e96ea14fc17c85311d6e2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jul 2 14:21:16 2009 +0100

    Add more (allow-none) annotations

 clutter/clutter-actor.c |   91 ++++++++++++++++++++++++++++-------------------
 1 files changed, 54 insertions(+), 37 deletions(-)

commit f1044a279c45e8f4f48cc81a5c1c0fa720835d1d
Author: Colin Walters <walters@verbum.org>
Date:   Thu Jul 2 13:15:42 2009 +0100

    Use the (allow-none) annotation for clutter_init*
    
    We accept NULL for some parameters in the initialization functions.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-main.c |   18 ++++++++++--------
 1 files changed, 10 insertions(+), 8 deletions(-)

commit d1232509a21a7ce05aa8c85b2c14872ffc4df5cb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jul 1 15:59:13 2009 +0100

    Post-release bump to 0.9.7

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 9ce88d86b484bcc4a15decfb95b97294e4cce292
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jul 1 15:28:33 2009 +0100

    [release] 0.9.6

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit a373bbb819462b6baa62f0ecfff9716c8dbc8fa8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jul 1 14:56:13 2009 +0100

    [docs] Update the NEWS and README files

 NEWS   |   40 ++++++++++++++++++++++++++++++++++++++++
 README |    5 +++++
 2 files changed, 45 insertions(+), 0 deletions(-)

commit 45c85c4213c85d0dbbbe0e7eb8f93e290d5ffff2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jul 1 15:15:52 2009 +0100

    [actor] Remove the unused get_allocation_coords()
    
    The clutter_actor_get_allocation_coords() is not used, and since
    the switch to floats in the Actor's API, it returns exactly what
    the get_allocation_box() returns.

 clutter/clutter-actor.c      |   62 +++++++-----------------------------------
 clutter/clutter-actor.h      |    5 ---
 clutter/clutter-deprecated.h |    2 +
 3 files changed, 12 insertions(+), 57 deletions(-)

commit 37bd35f592e13dfa8ded884fcf668409dec119f3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jul 1 13:59:13 2009 +0100

    [actor] Allow changing the transformations matrix
    
    Currently, the transformation matrix for an actor is constructed
    from scenegraph-related accessors. An actor, though, can call COGL
    API to add new transformations inside the paint() implementation,
    for instance:
    
      static void
      my_foo_paint (ClutterActor *a)
      {
        ...
        cogl_translate (-scroll_x, -scroll_y, 0);
        ...
      }
    
    Unfortunately these transformations will be completely ignored by
    the scenegraph machinery; for instance, getting the actor-relative
    coordinates from event coordinates is going to break badly because
    of this.
    
    In order to make the scenegraph aware of the potential of additional
    transformations, we need a ::apply_transform() virtual function. This
    vfunc will pass a CoglMatrix which can be used to apply additional
    operations:
    
      static void
      my_foo_apply_transform (ClutterActor *a, CoglMatrix *m)
      {
        CLUTTER_ACTOR_CLASS (my_foo_parent_class)->apply_transform (a, m);
        ...
        cogl_matrix_translate (m, -scroll_x, -scroll_y, 0);
        ...
      }
    
    The ::paint() implementation will be called with the actor already
    using the newly applied transformation matrix, as expected:
    
      static void
      my_foo_paint (ClutterActor *a)
      {
        ...
      }
    
    The ::apply_transform() implementations *must* chain up, so that the
    various transformations of each class are preserved. The default
    implementation inside ClutterActor applies all the transformations
    defined by the scenegraph-related accessors.
    
    Actors performing transformations inside the paint() function will
    continue to work as previously.

 clutter/clutter-actor.c                    |  104 ++++++++++++++++++++--------
 clutter/clutter-actor.h                    |   15 ++++-
 doc/reference/clutter/clutter-sections.txt |    1 +
 3 files changed, 89 insertions(+), 31 deletions(-)

commit 0414daf0fb64433cb168799bfec79d5996b05ddf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jul 1 12:34:54 2009 +0100

    Split the typdef to avoid confusing scanners
    
    Scanners like gtk-doc and g-ir-scanner get confused by:
    
      typedef struct _Foo {
        ...
      } Foo;
    
    And expect instead:
    
      typedef struct _Foo Foo;
    
      struct _Foo {
        ...
      };
    
    CoglMatrix definition should be changed to avoid the former type.

 clutter/cogl/cogl-matrix.h |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

commit 250b775926da40a5e4b96565b413c4a2c57d4a8d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 25 14:41:25 2009 +0100

    [x11] Fix the race between resize and glViewport calls
    
    The race we were experiencing in the X11 backends is apparently
    back after the fix in commit 00a3c698.
    
    This time, just delaying the setting of the SYNC_MATRICES flag
    is not enough, so we can resume the use of a STAGE_IN_RESIZE
    private flag.
    
    This should also fix bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1668

 clutter/clutter-main.c          |    7 +++++--
 clutter/clutter-private.h       |    3 ++-
 clutter/x11/clutter-event-x11.c |    6 ++++--
 clutter/x11/clutter-stage-x11.c |   35 +++++++++++++++++++++++++++--------
 4 files changed, 38 insertions(+), 13 deletions(-)

commit 3726213291ad513e09ec7e8b3776cc2d2b9d9cb9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 25 14:39:57 2009 +0100

    Add debug notes for calls to glViewport()
    
    In order to validate the sequence of:
    
            XResizeWindow
            ConfigureNotify
            glViewport
    
    that should happen on X11 we need to add debug annotations to the
    calls to glViewport() done through COGL.

 clutter/cogl/common/cogl.c |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 3bab7871030d8ad6be6dc730e5902d256dea28a2
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jul 1 12:57:30 2009 +0100

    [cogl] cache the viewport width and height
    
    This avoids some calls to glGetFloatv, which have at least proven to be very
    in-efficient in mesa at this point in time, since it always updates all derived
    state even when it may not relate to the state being requested.

 clutter/cogl/common/cogl.c     |   30 ++++++++++++++++--------------
 clutter/cogl/gl/cogl-context.c |    3 +++
 clutter/cogl/gl/cogl-context.h |    3 +++
 clutter/cogl/gl/cogl-fbo.c     |    2 +-
 4 files changed, 23 insertions(+), 15 deletions(-)

commit 358d7c30dcb6e50b8dc1208d7b602b74cc198f10
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jun 19 12:15:12 2009 +0100

    [cogl] Ensure well defined semantics for COGL_INVALID_HANDLE material layers
    
    Fixes and adds a unit test for creating and drawing using materials with
    COGL_INVALID_HANDLE texture layers.
    
    This may be valid if for example the user has set a texture combine string
    that only references a constant color.
    
    _cogl_material_flush_layers_gl_state will bind the fallback texture for any
    COGL_INVALID_HANDLE layer, later though we could explicitly check when the
    current blend mode does't actually reference a texture source in which case
    binding the fallback texture is redundant.
    
    This tests drawing using cogl_rectangle, cogl_polygon and
    cogl_vertex_buffer_draw.

 clutter/cogl/common/cogl-material.c      |    8 +-
 clutter/cogl/common/cogl-primitives.c    |   35 +++++-
 clutter/cogl/common/cogl-vertex-buffer.c |   10 ++-
 tests/conform/Makefile.am                |    1 +
 tests/conform/test-conform-main.c        |    1 +
 tests/conform/test-materials.c           |  195 ++++++++++++++++++++++++++++++
 6 files changed, 240 insertions(+), 10 deletions(-)

commit fce406f1b88794d35d8fb0c04c6bf690b990bd0d
Merge: 04bb789 33400c0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jun 30 17:17:30 2009 +0100

    Merge branch 'cogl-journal-batching'
    
    [cogl] Improve ability to break out into raw OpenGL via begin/end mechanism
    Adds a cogl_flush() to give developers breaking into raw GL a fighting chance
    [cogl-material] Be more carefull about flushing in cogl_material_remove_layer
    Revert "[rectangle] Avoid modifying materials mid scene"
    Revert "[actor] Avoid modifying materials mid-scene to improve journal batching"
    [cogl-vertex-buffer] Disable unused client tex coord arrays
    [cogl] disable all client tex coord arrays in _cogl_add_path_to_stencil_buffer
    [cogl] flush matrices in _cogl_add_path_to_stencil_buffer
    [journal] Don't resize a singlton VBO; create and destroy a VBO each flush
    [cogl] avoid using the journal in _cogl_add_path_to_stencil_buffer
    [pango-display-list] Use the Cogl journal for short runs of text
    [material] _cogl_material_equal: catch the simplest case of matching handles
    [material] avoid flushing the journal when just changing the color
    [cogl journal] Perform software modelview transform on logged quads.
    [Cogl journal] use G_UNLIKLEY around runtime debugging conditions
    [cogl journal] Adds a --cogl-debug=batching option to trace batching
    [Cogl journal] Adds a --cogl-debug=journal option for tracing the journal
    [cogl] Adds a debug option for disabling use of VBOs --cogl-debug=disable-vbos
    [cogl] Force Cogl to always use the client side matrix stack
    [cogl-debug] Adds a "client-side-matrices" Cogl debug option
    [cogl-color] Adds a cogl_color_equal() function
    [cogl material] optimize logging of material colors in the journal
    [rectangle] Avoid modifying materials mid scene
    [actor] Avoid modifying materials mid-scene to improve journal batching
    [journal] Always pad our vertex data as if at least 2 layers are enabled
    [cogl] Improving Cogl journal to minimize driver overheads + GPU state changes
    
    The Cogl journal is a mechanism Cogl uses to batch geometry resulting from
    any of the cogl_rectangle* functions before sending it to OpenGL.  This aims
    to improve the Cogl journal so that it can reduce the number of state
    changes and draw calls we issue to the OpenGL driver and hopfully improve
    performance.
    
    Previously each call to any of the cogl_rectangle* functions would imply an
    immediate GL draw call, as well as a corresponding modelview change;
    material state changes and gl{Vertex,Color,TexCoord}Pointer calls.  Now
    though we have tried to open the scope for batching up as much as possible
    so we only have to flush the geometry either before calling glXSwapBuffers,
    or when we change state that isn't tracked by the journal.
    
    As a basic example, it's now possible for us to batch typical picking
    renders into a single draw call for the whole scene.
    
    Some key points about this change:
    - We now perform transformations of quads in software (except for long runs of
      text which continue to use VBOs)
        * It might seem surprising at first, but when you consider that so many
          Clutter actors are little more than textured quads and each actor
          typically implies a modelview matrix change; the costs involved in
          setting up the GPU with the new modelview can easily out weigh the cost
          of simply transforming 4 vertices.
    - We always use Cogl's own client side matrix API now.
        * We found the performance of querying the OpenGL driver for matrix state
          was often worse than using the client matrix code, and also - discussing
          with Mesa developers - agreed that since khronos has essentially
          deprecated the GL matrix API (by removing it from OpenGL 3 and
          OpenGL-ES 2) it was appropriate to take full responsibility for all our
          matrix manipulation.
    - Developers should avoid modifying materials mid-scene.
        * With the exception of material color changes, if you try and modify a
          material that is referenced in the journal we will currently force a
          journal flush. Note: you can assume that re-setting the same value for
          a material property won't require a flush though.
    - Several new --cogl-debug options have been added
        * "disable-batching" can be used to identify bugs in the way that the
          journal does its batching; of could this shouldn't ever be needed :-)
        * "disable-vbos" can be used to test the VBO fallback paths where we
          simply use malloc()'d buffers instead.
        * "batching" lets you get an overview of how the journal is batching
          your geometry and may help you identify ways to improve your
          application performance.
        * "journal" lets you trace all the geometry as it gets logged in the
          journal, and all the geometry as its flushed from the journal.
          Obviously an inconsistency can identify a bug, but the numbers may
          help you verify application logic too.
        * "disable-software-transform" as implied will instead use the driver
          /GPU to transform quads by the modelview matrix.
        Although committed separately a --clutter-debug=nop-picking option was
        also added that lets you remove picking from the equation, which can
        sometimes help make problem analysis more deterministic.

commit 33400c0aae58468107be8a9e4572a37dd890ec81
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 29 22:32:05 2009 +0100

    [cogl] Improve ability to break out into raw OpenGL via begin/end mechanism
    
    Although we wouldn't recommend developers try and interleve OpenGL drawing
    with Cogl drawing - we would prefer patches that improve Cogl to avoid this
    if possible - we are providing a simple mechanism that will at least give
    developers a fighting chance if they find it necissary.
    
    Note: we aren't helping developers change OpenGL state to modify the
    behaviour of Cogl drawing functions - it's unlikley that can ever be
    reliably supported - but if they are trying to do something like:
    
       - setup some OpenGL state.
       - draw using OpenGL (e.g. glDrawArrays() )
       - reset modified OpenGL state.
       - continue using Cogl to draw
    
    They should surround their blocks of raw OpenGL with cogl_begin_gl() and
    cogl_end_gl():
    
       cogl_begin_gl ();
       - setup some OpenGL state.
       - draw using OpenGL (e.g. glDrawArrays() )
       - reset modified OpenGL state.
       cogl_end_gl ();
       - continue using Cogl to draw
    
    Again; we aren't supporting code like this:
       - setup some OpenGL state.
       - use Cogl to draw
       - reset modified OpenGL state.
    When the internals of Cogl evolves, this is very liable to break.
    
    cogl_begin_gl() will flush all internally batched Cogl primitives, and emit
    all internal Cogl state to OpenGL as if it were going to draw something
    itself.
    
    The result is that the OpenGL modelview matrix will be setup; the state
    corresponding to the current source material will be setup and other world
    state such as backface culling, depth and fogging enabledness will be also
    be sent to OpenGL.
    
    Note: no special material state is flushed, so if developers want Cogl to setup
    a simplified material state it is the their responsibility to set a simple
    source material before calling cogl_begin_gl. E.g. by calling
    cogl_set_source_color4ub().
    
    Note: It is the developers responsibility to restore any OpenGL state that they
    modify to how it was after calling cogl_begin_gl() if they don't do this then
    the result of further Cogl calls is undefined.

 clutter/cogl/cogl.h.in               |   79 ++++++++++++++++++++++++++++++++++
 clutter/cogl/common/cogl.c           |   75 ++++++++++++++++++++++++++++++++
 clutter/cogl/gl/cogl-context.c       |    2 +
 clutter/cogl/gl/cogl-context.h       |    2 +
 doc/reference/cogl/cogl-sections.txt |    2 +
 5 files changed, 160 insertions(+), 0 deletions(-)

commit 6d9498da7cbe180ddc4b68ae3a48985631db46a0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 29 17:10:34 2009 +0100

    Adds a cogl_flush() to give developers breaking into raw GL a fighting chance
    
    This function should only need to be called in exceptional circumstances
    since Cogl can normally determine internally when a flush is necessary.
    
    As an optimization Cogl drawing functions may batch up primitives
    internally, so if you are trying to use raw GL outside of Cogl you stand a
    better chance of being successful if you ask Cogl to flush any batched
    geometry before making your state changes.
    
    cogl_flush() ensures that the underlying driver is issued all the commands
    necessary to draw the batched primitives.  It provides no guarantees about
    when the driver will complete the rendering.
    
    This provides no guarantees about the GL state upon returning and to avoid
    confusing Cogl you should aim to restore any changes you make before
    resuming use of Cogl.
    
    If you are making state changes with the intention of affecting Cogl drawing
    primitives you are 100% on your own since you stand a good chance of
    conflicting with Cogl internals.  For example clutter-gst which currently
    uses direct GL calls to bind ARBfp programs will very likely break when Cogl
    starts to use ARBfb programs internally for the material API, but for now it
    can use cogl_flush() to at least ensure that the ARBfp program isn't applied
    to additional primitives.
    
    This does not provide a robust generalized solution supporting safe use of
    raw GL, its use is very much discouraged.

 clutter/clutter-main.c                  |    2 +-
 clutter/cogl/cogl.h.in                  |   42 ++++++++++++++++++++----------
 clutter/cogl/common/cogl.c              |    4 +-
 clutter/eglnative/clutter-backend-egl.c |    2 +-
 clutter/eglx/clutter-backend-egl.c      |    2 +-
 clutter/fruity/clutter-backend-fruity.c |    2 +-
 clutter/glx/clutter-backend-glx.c       |    2 +-
 clutter/osx/clutter-stage-osx.c         |    2 +-
 clutter/sdl/clutter-backend-sdl.c       |    2 +-
 clutter/win32/clutter-backend-win32.c   |    2 +-
 doc/reference/cogl/cogl-sections.txt    |    3 ++
 11 files changed, 41 insertions(+), 24 deletions(-)

commit 87f99e214a6f60c06cc34f844e02ecb0f63c953f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 24 18:34:06 2009 +0100

    [cogl-material] Be more carefull about flushing in cogl_material_remove_layer
    
    Previously we would call _cogl_material_pre_change_notify unconditionally, but
    now we wait until we really know we are removing a layer before notifying the
    change, which will require a journal flush.
    
    Since the convenience functions cogl_set_source_color4ub and
    cogl_set_source_texture share a single material, cogl_set_source_color4ub
    always calls cogl_material_remove_layer.  Often this is a NOP though and
    shouldn't require a journal flush.
    
    This gets performance back to where it was before reverting the per-actor
    material commits.

 clutter/cogl/common/cogl-material.c |   12 +++++++++---
 1 files changed, 9 insertions(+), 3 deletions(-)

commit 6ee8e1565475d75d343682e4d4eed2f68e0c26eb
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 24 18:24:58 2009 +0100

    Revert "[rectangle] Avoid modifying materials mid scene"
    
    This reverts commit 8cf42ea8ac5c05f6b443c453f9c6c2a3cd75acfa.
    
    Since the journal puts material colors in the vertex array accumulated for
    drawing we don't need to flush the journal simply due to color changes which
    means using cogl_set_source_color4ub is no longer a concern.

 clutter/clutter-rectangle.c |   89 ++++++++++++++++--------------------------
 1 files changed, 34 insertions(+), 55 deletions(-)

commit 5ffbe052480cb06e44f1a317ac729553ddd2dc96
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 24 18:20:45 2009 +0100

    Revert "[actor] Avoid modifying materials mid-scene to improve journal batching"
    
    This reverts commit 85243da382025bd516937c76a61b8381f6e74689.
    
    Since the journal puts material colors in the vertex array accumulated for
    drawing we don't need to flush the journal simply due to color changes
    which means using cogl_set_source_color4ub is no longer a concern.

 clutter/clutter-actor.c |   14 ++++----------
 1 files changed, 4 insertions(+), 10 deletions(-)

commit 8b67916cc1e2aed7861214205fc0d68c0c6d67f1
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 24 18:10:50 2009 +0100

    [cogl-vertex-buffer] Disable unused client tex coord arrays
    
    Before any cogl vertex buffer drawing we call
    enable_state_for_drawing_buffer which sets up the GL state, but we weren't
    disabling unsed client texture coord arrays.

 clutter/cogl/common/cogl-vertex-buffer.c |    7 +++++++
 1 files changed, 7 insertions(+), 0 deletions(-)

commit 8873c6a11a4668e737e4dc75d1d2a2c14904482f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 22 01:29:39 2009 +0100

    [cogl] disable all client tex coord arrays in _cogl_add_path_to_stencil_buffer
    
    After flushing the journal an unknown number of client side texture arrays
    may be left enabled. Disable them all before using glDrawArrays.

 clutter/cogl/gl/cogl-primitives.c |    8 ++++++++
 1 files changed, 8 insertions(+), 0 deletions(-)

commit ca0a0e9dac23219709a1c365a070ea9d4d517909
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 22 00:49:20 2009 +0100

    [cogl] flush matrices in _cogl_add_path_to_stencil_buffer
    
    Before calling glRectf we need to ensure we flush the modelview and
    projection matrices.

 clutter/cogl/gl/cogl-primitives.c |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit f386b1f002f111210e87e6f72eb1795ad2befc1e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 22 00:11:41 2009 +0100

    [journal] Don't resize a singlton VBO; create and destroy a VBO each flush
    
    This simplifies the vertex data uploading in the journal, and could improve
    performance.  Modifying a VBO mid-scene could reqire synchronizing with the
    GPU or some form of shadowing/copying to avoid modifying data that the GPU
    is currently processing; the buffer was also being marked as GL_STATIC_DRAW
    which could have made things worse.
    
    Now we simply create a GL_STATIC_DRAW VBO for each flush and and delete it
    when we are finished.

 clutter/cogl/common/cogl-primitives.c |   40 ++++++++++-----------------------
 1 files changed, 12 insertions(+), 28 deletions(-)

commit 7b7787b050a1dd245dea396335ddf96662c6a570
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 22 00:05:02 2009 +0100

    [cogl] avoid using the journal in _cogl_add_path_to_stencil_buffer
    
    Using cogl_rectangle (and thus the journal) in
    _cogl_add_path_to_stencil_buffer means we have to consider all the state
    that the journal may change in case it may interfer with the direct GL calls
    used.  This has proven to be error prone and in this case the journal is an
    unnecissary overhead.  We now simply call glRectf instead of using
    cogl_rectangle.

 clutter/cogl/gl/cogl-primitives.c |   16 ++++++----------
 1 files changed, 6 insertions(+), 10 deletions(-)

commit 6562f3224a558b224b9076fe794547bfc9bb2af5
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 23:35:49 2009 +0100

    [pango-display-list] Use the Cogl journal for short runs of text
    
    For small runs of text like icon labels, we can get better performance
    going through the Cogl journal since text may then be batched together
    with other geometry.
    
    For larger runs of text though we still use VBOs since the cost of logging
    the quads becomes too expensive, including the software transform which
    isn't at all optimized at this point.  VBOs also have the further advantage
    of avoiding repeated validation of vertices by the driver and repeated
    mapping of data into the GPU so long as the text doesn't change.
    
    Currently the threshold is 100 vertices/25 quads. This number was plucked
    out of thin air and should be tuned later.
    
    With this change I see ~180% fps improvment for test-text. (x61s + i965 +
    Mesa 7.6-devel)

 clutter/pango/cogl-pango-display-list.c |   33 +++++++++++++++++++++++++++++++
 1 files changed, 33 insertions(+), 0 deletions(-)

commit 6ac3b5a564608862fdf4e9b8887b882ebe497f4b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 23:31:40 2009 +0100

    [material] _cogl_material_equal: catch the simplest case of matching handles
    
    We were missing the simplest test of all: are the two CoglHandles equal and
    are the flush option flags for each material equal?  This should improve
    batching for some common cases.

 clutter/cogl/common/cogl-material.c |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit 9afa52f056b58bbd35274fec3fe21ff483949321
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 23:31:11 2009 +0100

    [material] avoid flushing the journal when just changing the color
    
    Whenever we modify a material we call _cogl_material_pre_change_notify which
    checks to see if the material is referenced by the journal and if so flushes
    if before we modify the material.
    
    Since the journal logs material colors directly into a vertex array (to
    avoid us repeatedly calling glColor) then we know we never need to flush
    the journal when material colors change.

 clutter/cogl/common/cogl-material.c |   80 ++++++++++++++++++++++------------
 1 files changed, 52 insertions(+), 28 deletions(-)

commit efbf483d8cdd448b20ddcfedc518509f907b2ac6
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 01:31:36 2009 +0100

    [cogl journal] Perform software modelview transform on logged quads.
    
    Since most Clutter actors aren't much more than textured quads; flushing the
    journal typically involves lots of 'change modelview; draw quad' sequences.
    
    The amount of overhead involved in uploading a new modelview and queuing
    that primitive is huge in comparison to simply transforming 4 vertices by
    the current modelview when logging quads.  (Note if your GPU supports HW
    vertex transform, then it still does the projective and viewport transforms)
    
    At the same time a --cogl-debug=disable-software-transform option has been
    added for comparison and debugging.
    
    This change allows typical pick scenes to be batched into a single draw call
    and I'm seeing test-pick run over 200% faster with this.  (i965 + Mesa
    7.6-devel)

 clutter/cogl/cogl-debug.h             |    3 +-
 clutter/cogl/common/cogl-debug.c      |    3 +-
 clutter/cogl/common/cogl-primitives.c |  158 ++++++++++++++++++++++++---------
 3 files changed, 120 insertions(+), 44 deletions(-)

commit 612a1e2dea5599a30e3c922dee288d72e890c415
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 01:30:24 2009 +0100

    [Cogl journal] use G_UNLIKLEY around runtime debugging conditions
    
    May as well improve the branch prediction around runtime debugging code.

 clutter/cogl/common/cogl-primitives.c |   16 ++++++++--------
 1 files changed, 8 insertions(+), 8 deletions(-)

commit 7d1876fd261f5039e25d468e0cc7dcbf63229912
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jun 11 11:54:01 2009 +0100

    [cogl journal] Adds a --cogl-debug=batching option to trace batching
    
    Enabling this option makes Cogl trace how the journal is managing to batch
    your rectangles.  The journal staggers how it emmits state to the GL driver
    and the batches will normally get smaller for each stage, but ideally you
    don't want to be in a situation where Cogl is only able to draw one quad per
    modelview change and draw call.
    
    E.g. this is a fairly ideal example:
    BATCHING: journal len = 101
    BATCHING:  vbo offset batch len = 101
    BATCHING:   material batch len = 101
    BATCHING:    modelview batch len = 101
    
    This isn't:
    BATCHING: journal len = 1
    BATCHING:  vbo offset batch len = 1
    BATCHING:   material batch len = 1
    BATCHING:    modelview batch len = 1
    BATCHING: journal len = 1
    BATCHING:  vbo offset batch len = 1
    BATCHING:   material batch len = 1
    BATCHING:    modelview batch len = 1
    <repeat>

 clutter/cogl/cogl-debug.h             |    5 +++--
 clutter/cogl/common/cogl-debug.c      |    3 ++-
 clutter/cogl/common/cogl-primitives.c |   17 ++++++++++++-----
 3 files changed, 17 insertions(+), 8 deletions(-)

commit d03e6cfb2c1ea47fdcf8db7d471666bd380c93aa
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 01:59:28 2009 +0100

    [Cogl journal] Adds a --cogl-debug=journal option for tracing the journal
    
    When this option is used Cogl will print a trace of all quads that get
    logged into the journal, and a trace of quads as they get flushed.
    
    If you are seeing a bug with the geometry being drawn by Cogl this may give
    some clues by letting you sanity check the numbers being logged vs the
    numbers being emitted.

 clutter/cogl/cogl-debug.h             |    3 +-
 clutter/cogl/common/cogl-debug.c      |    3 +-
 clutter/cogl/common/cogl-primitives.c |   36 +++++++++++++++++++++-----------
 3 files changed, 27 insertions(+), 15 deletions(-)

commit 3ea7816499996c3bb918b27c6f44c987b90d2e9c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 01:46:06 2009 +0100

    [cogl] Adds a debug option for disabling use of VBOs --cogl-debug=disable-vbos
    
    For testing the VBO fallback paths it helps to be able to disable the
    COGL_FEATURE_VBOS feature flag.  When VBOs aren't available Cogl should use
    client side malloc()'d buffers instead.

 clutter/cogl/cogl-debug.h        |    3 ++-
 clutter/cogl/common/cogl-debug.c |    3 ++-
 clutter/cogl/common/cogl.c       |    3 +++
 3 files changed, 7 insertions(+), 2 deletions(-)

commit 54159f5a1d029dbfff19711f5397fc9b99556ed4
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 01:37:39 2009 +0100

    [cogl] Force Cogl to always use the client side matrix stack
    
    Previously we only used the Cogl matrix stack API for indirect contexts, but
    it's too costly to keep on requesting modelview matrices from GL (for
    logging in the journal) even for direct rendering.
    
    I also experimented with a patch for mesa to improve performance and
    discussed this with upstream, but we agreed to consider the GL matrix API
    essentially deprecated.  (For reference the GLES 2 and GL 3 specs have
    removed the matrix APIs)

 clutter/cogl/common/cogl-current-matrix.c |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit 713af6535de11f27e1da9c1e233e8402d2864ab9
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jun 5 13:50:00 2009 +0100

    [cogl-debug] Adds a "client-side-matrices" Cogl debug option
    
    This allows us to force Cogl to use the client side matrix stack even when
    direct rendering.

 clutter/cogl/cogl-debug.h                 |    3 ++-
 clutter/cogl/common/cogl-current-matrix.c |    3 ++-
 clutter/cogl/common/cogl-debug.c          |    3 ++-
 3 files changed, 6 insertions(+), 3 deletions(-)

commit a8be68c83cb97a8bafc93f5304e177e1b265bca1
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jun 5 12:58:31 2009 +0100

    [cogl-color] Adds a cogl_color_equal() function
    
    CoglColors shouldn't be compared using memcmp since they may contain
    uninitialized padding bytes.
    
    The prototype is also suitable for passing to g_hash_table_new as the
    key_equal_func.
    
    _cogl_pango_display_list_add_texture now uses this instead of memcmp.

 clutter/cogl/cogl-color.h               |   16 ++++++++++++++++
 clutter/cogl/common/cogl-color.c        |   15 +++++++++++++++
 clutter/pango/cogl-pango-display-list.c |    3 +--
 3 files changed, 32 insertions(+), 2 deletions(-)

commit aca1bf4329481cedfd8ffa65591338662c6d626a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jun 4 14:23:16 2009 +0100

    [cogl material] optimize logging of material colors in the journal
    
    We now put the color of materials into the vertex array used by the journal
    instead of calling glColor() but the number of requests for the material
    color were quite expensive so we have changed the material color to
    internally be byte components instead of floats to avoid repeat conversions
    and added _cogl_material_get_colorubv as a fast-path for the journal to
    copy data into the vertex array.

 clutter/cogl/common/cogl-material-private.h |   21 +++--------
 clutter/cogl/common/cogl-material.c         |   51 ++++++++++++++++-----------
 clutter/cogl/common/cogl-primitives.c       |   26 ++++++--------
 clutter/cogl/gles/cogl-gles2-wrapper.c      |    7 ++++
 clutter/cogl/gles/cogl-gles2-wrapper.h      |    2 +
 5 files changed, 56 insertions(+), 51 deletions(-)

commit 938452f1b1109e7c8daff8f49c4f0a45a13be25f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jun 5 13:03:14 2009 +0100

    [rectangle] Avoid modifying materials mid scene
    
    To improve batching of geometry in the Cogl journal we need to avoid modifying
    materials midscene.
    
    Currently cogl_set_source_color and cogl_set_source_texture simply modify a
    single shared material. In the future we can improve this so they use a pool
    of materials that gets recycled as the journal is flushed, but for now we
    give all ClutterRectangles their own private materials for painting with.

 clutter/clutter-rectangle.c |   89 ++++++++++++++++++++++++++----------------
 1 files changed, 55 insertions(+), 34 deletions(-)

commit dc1ca79398e343d06918cf1c38b72771f476f0a6
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 18:36:27 2009 +0100

    [actor] Avoid modifying materials mid-scene to improve journal batching
    
    Currently cogl_set_source_color uses a single shared material which means
    each actor that uses it causes the journal to flush if the color changes.
    Until we improve cogl_set_source_color to use a pool of materials that can
    be recycled as the journal is flushed we avoid mid-scene material changes by
    giving all actors a private material instead.

 clutter/clutter-actor.c |   14 ++++++++++----
 1 files changed, 10 insertions(+), 4 deletions(-)

commit 40cfaeaffc9b744d99c21c1e6cd5b57e358ff37a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 10 13:59:45 2009 +0100

    [journal] Always pad our vertex data as if at least 2 layers are enabled
    
    The number of material layers enabled when logging a quad in the journal
    determines the stride of the corresponding vertex data (since we need a set
    of texture coordinates for each layer.) By padding data in the case where we
    have only one layer we can avoid a change in stride if we are mixing single
    and double layer primitives in a scene (e.g.  relevent for a composite
    manager that may use 2 layers for all shaped windows) Avoiding stride
    changes means we can minimize calls to gl{Vertex,Color}Pointer when flushing
    the journal.
    
    Since we need to update the texcoord pointers when the actual number of
    layers changes, this adds another batch_and_call() stage to deal with
    glTexCoordPointer and enabling/disabling the client arrays.

 clutter/cogl/common/cogl-primitives.c |  108 ++++++++++++++++++++++++---------
 1 files changed, 78 insertions(+), 30 deletions(-)

commit 845ff67301da767926f96c56026a8dd9c7964f01
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 18:46:42 2009 +0100

    [cogl] Improving Cogl journal to minimize driver overheads + GPU state changes
    
    Previously the journal was always flushed at the end of
    _cogl_rectangles_with_multitexture_coords, (i.e.  the end of any
    cogl_rectangle* calls) but now we have broadened the potential for batching
    geometry.  In ideal circumstances we will only flush once per scene.
    
    In summary the journal works like this:
    
    When you use any of the cogl_rectangle* APIs then nothing is emitted to the
    GPU at this point, we just log one or more quads into the journal.  A
    journal entry consists of the quad coordinates, an associated material
    reference, and a modelview matrix.  Ideally the journal only gets flushed
    once at the end of a scene, but in fact there are things to consider that
    may cause unwanted flushing, including:
    
    - modifying materials mid-scene
        This is because each quad in the journal has an associated material
        reference (i.e. not copy), so if you try and modify a material that is
        already referenced in the journal we force a flush first)
    
        NOTE: For now this means you should avoid using cogl_set_source_color()
    	      since that currently uses a single shared material. Later we
    	  should change it to use a pool of materials that is recycled
    	  when the journal is flushed.
    
    - modifying any state that isn't currently logged, such as depth, fog and
      backface culling enables.
    
    The first thing that happens when flushing, is to upload all the vertex data
    associated with the journal into a single VBO.
    
    We then go through a process of splitting up the journal into batches that
    have compatible state so they can be emitted to the GPU together.  This is
    currently broken up into 3 levels so we can stagger the state changes:
    
    1) we break the journal up according to changes in the number of material layers
       associated with logged quads. The number of layers in a material determines
       the stride of the associated vertices, so we have to update our vertex
       array offsets at this level. (i.e. calling gl{Vertex,Color},Pointer etc)
    2) we further split batches up according to material compatability. (e.g.
       materials with different textures) We flush material state at this level.
    3) Finally we split batches up according to modelview changes. At this level
       we update the modelview matrix and actually emit the actual draw command.
    
    This commit is largely about putting the initial design in-place; this will be
    followed by other changes that take advantage of the extended batching.

 clutter/clutter-main.c                      |    3 +
 clutter/cogl/cogl-debug.h                   |   21 +-
 clutter/cogl/cogl-material.h                |   19 +-
 clutter/cogl/cogl.h.in                      |   14 +
 clutter/cogl/common/cogl-clip-stack.c       |    4 +
 clutter/cogl/common/cogl-debug.c            |    3 +-
 clutter/cogl/common/cogl-material-private.h |   99 +++--
 clutter/cogl/common/cogl-material.c         |  318 ++++++++++++--
 clutter/cogl/common/cogl-primitives.c       |  667 +++++++++++++++++++--------
 clutter/cogl/common/cogl-primitives.h       |    2 +
 clutter/cogl/common/cogl-vertex-buffer.c    |   28 +-
 clutter/cogl/common/cogl.c                  |   38 ++-
 clutter/cogl/gl/cogl-context.c              |    4 +
 clutter/cogl/gl/cogl-context.h              |    4 +
 clutter/cogl/gl/cogl-fbo.c                  |    2 +
 clutter/cogl/gl/cogl-primitives.c           |   44 ++-
 clutter/cogl/gl/cogl-program.c              |    5 +
 clutter/cogl/gl/cogl-texture-private.h      |   12 +-
 clutter/cogl/gl/cogl-texture.c              |    3 +-
 clutter/eglnative/clutter-backend-egl.c     |    1 +
 clutter/eglx/clutter-backend-egl.c          |    1 +
 clutter/fruity/clutter-backend-fruity.c     |    1 +
 clutter/glx/clutter-backend-glx.c           |    1 +
 clutter/osx/clutter-stage-osx.c             |    1 +
 clutter/sdl/clutter-backend-sdl.c           |    3 +-
 clutter/win32/clutter-backend-win32.c       |    1 +
 26 files changed, 1003 insertions(+), 296 deletions(-)

commit 04bb7899416063994af8730866f390e68ecc4d65
Author: Øyvind Kolås <pippin@linux.intel.com>
Date:   Tue Jun 30 16:48:53 2009 +0100

    [texture] fix load-async and load-data-async properties.
    
    Removed the G_PARAM_CONSTRUCT from the property registration of
    "load-async" and "load-data-async". It made it impossible to use only
    load-data-async, as the async loading state would be unset when
    load-async got set it's default FALSE value.

 clutter/clutter-texture.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit 722360774ca4628c1589f5d6f09932faa0c8b711
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 22 00:58:32 2009 +0100

    [clip-stack] Use signed integers while combining window space clip rectangles
    
    Use signed integers while combining window space clip rectangles, so we avoid
    arithmatic errors later resulting in glScissor getting negative width and
    height arguments.

 clutter/cogl/common/cogl-clip-stack.c |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

commit d63cda3b7620daa4e081e7023ce5d0afb5783b54
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 22 00:00:04 2009 +0100

    [cogl] Remove unused ctx->polygon_vertices array
    
    This array used to be used by cogl_polygon but was changed to use
    ctx->logged_vertices some time ago.

 clutter/cogl/gl/cogl-context.c |    4 ----
 clutter/cogl/gl/cogl-context.h |    1 -
 2 files changed, 0 insertions(+), 5 deletions(-)

commit 30f13cafc5fff69c7e31f3ead2df5d6c0282ec07
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jun 23 15:24:42 2009 +0100

    [cogl] Give the default (fallback) texture a format of RGBA_8888_PRE
    
    Previously this was RGBA_8888. It souldn't really make a difference but for
    consistency we expect almost all textures in use to have an internaly
    premultiplied pixel format.

 clutter/cogl/gl/cogl-context.c |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

commit 4680b34046aba7adfb958d2995d7e56fdcb3d473
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jun 19 16:39:37 2009 +0100

    [cogl-texture] use the right format when downloading sliced textures from GL
    
    _cogl_texture_download_from_gl needs to create transient CoglBitmaps when
    downloading sliced textures from GL, and then copies these as subregions
    into the final target_bitmap. _cogl_texture_download_from_gl also supports
    target_bitmaps with a different format to the source CoglTexture being
    downloaded.
    
    The problem was that in the case of slice textures we were always looking
    at the format of the CoglTexture, not of the target_bitmap when setting
    up the transient slice bitmap.

 clutter/cogl/gl/cogl-texture.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 24ca92951f739278697990fb25f351045d6ece9c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 14:30:44 2009 +0100

    [cogl] Adds cogl_read_pixels to replace direct use of glReadPixels
    
    To allow for flushing of batched geometry within Cogl we can't support users
    directly calling glReadPixels.  glReadPixels is also awkward, not least
    because it returns upside down image data.
    
    All the unit tests have been swithed over and clutter_stage_read_pixels now
    sits on top of this too.

 clutter/clutter-stage.c                       |   44 ++-----------------
 clutter/cogl/cogl.h.in                        |   33 ++++++++++++++
 clutter/cogl/common/cogl.c                    |   56 +++++++++++++++++++++++++
 doc/reference/cogl/cogl-sections.txt          |    4 ++
 tests/conform/test-blend-strings.c            |   16 ++++---
 tests/conform/test-premult.c                  |   14 ++++---
 tests/conform/test-vertex-buffer-contiguous.c |   28 +++++++++---
 tests/conform/test-vertex-buffer-interleved.c |    9 ++--
 tests/conform/test-vertex-buffer-mutability.c |   13 ++++--
 9 files changed, 151 insertions(+), 66 deletions(-)

commit 27fff12a6a880241002cec3705da7af9905a20bf
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 02:08:31 2009 +0100

    [cogl matrix] Adds ability to dirty state cached by the client matrix apis
    
    To be able to load matrices to GL manually within Cogl we need a way to
    dirty the state cached by the client matrix stack API.

 clutter/cogl/common/cogl-current-matrix.c |   15 +++++++++++++++
 clutter/cogl/common/cogl-current-matrix.h |    1 +
 clutter/cogl/common/cogl-matrix-stack.c   |    7 +++++++
 clutter/cogl/common/cogl-matrix-stack.h   |    1 +
 4 files changed, 24 insertions(+), 0 deletions(-)

commit 26d5afd203ba393255fdc98cd980f65d014967c3
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jun 11 00:34:00 2009 +0100

    [debug] Adds a "nop-picking" clutter debug option to NOP _clutter_do_pick()
    
    I've found this is something I do quite often when debugging rendering
    problems since its a simple way to wipe out lots of geometry and removes a
    lot of unpredictable noise when logging geometry passing through the Cogl
    journal.

 clutter/clutter-debug.h |    3 ++-
 clutter/clutter-main.c  |    6 +++++-
 2 files changed, 7 insertions(+), 2 deletions(-)

commit 56bc54d2426e7ea4a092d4cae1792a124ce55600
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jun 16 22:48:21 2009 +0100

    [cogl_polygon] fixes a buffer overrun and color format bug
    
    We were calculating our vertex stride and allocating our vertex array
    differently depending on whether the user passed TRUE for use_color or not.
    The problem was that we were always writting color data to the array
    regardless of use_color.
    
    There was also a bug with _cogl_texture_sliced_polygon in that it was
    writing byte color components but we were expecting float components.  We
    now use byte components in _cogl_multitexture_unsliced_polygon too and pass
    GL_UNSIGNED_BYTE to glColorPointer.

 clutter/cogl/common/cogl-primitives.c |   40 +++++++++++++++++++--------------
 1 files changed, 23 insertions(+), 17 deletions(-)

commit 060f1488e043c31b5c6841a719a5bc0cb7e8c30b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jun 16 00:45:44 2009 +0100

    [test-cogl-tex-getset] Assume a premultiplied pixel format
    
    test-cogl-tex-getset was assuming it was dealing with
    COGL_PIXEL_FORMAT_RGBA_8888 but since merging the premultiplcation branch
    the pixel format is actually COGL_PIXEL_FORMAT_RGBA_8888_PRE

 tests/interactive/test-cogl-tex-getset.c |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

commit 8f734ccbb48effa1b9f3057e26ac5eb40ef54930
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 15:03:33 2009 +0100

    [vertex-buffer] Add cogl_vertex_buffer_indices_get_type API
    
    cogl_vertex_buffer_indices lets you query back the data type used for the
    given indices handle.

 clutter/cogl/cogl-vertex-buffer.h        |   11 +++++++++++
 clutter/cogl/common/cogl-vertex-buffer.c |   21 +++++++++++++++++++++
 2 files changed, 32 insertions(+), 0 deletions(-)

commit 555159776b9146d86b0be8b224c4712cf67dcaa7
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jun 17 15:02:56 2009 +0100

    [vertex-buffer] Remove the COGL_INDICES_TYPE_UNSIGNED_INT indicies type
    
    Since some embedded GPUs may not support 32bit integer indices we wont
    include it until there is a particular need.

 clutter/cogl/cogl-vertex-buffer.h |    2 --
 1 files changed, 0 insertions(+), 2 deletions(-)

commit a66f027c61c9dfd545c3ba4d9d104679bef2ec43
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Jun 25 16:06:41 2009 +0200

    [cogl] Add COGL_HAS_GL and COGL_HAS_GLES
    
    Cogl already add similar defines but with the CLUTTER namespace
    (CLUTTER_COGL_HAS_GL and CLUTTER_COGL_HAS_GLES). Let's just add two
    similar defines with the COGL namespace. Removing the CLUTTER_COGL ones
    could break applications silently for no real good reason.

 clutter/cogl/gl/cogl-defines.h.in   |    1 +
 clutter/cogl/gles/cogl-defines.h.in |    1 +
 2 files changed, 2 insertions(+), 0 deletions(-)

commit 30b5dac7c319ecedee7492b126bcb6e0c4b5928c
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Jun 25 15:59:11 2009 +0200

    [misc] Update headers #endif comments
    
    While grepping through the public headers looking for invalid use of
    private HAVE_* defines, I stumbled upon two out of sync comments. Yes
    it's a very minor trivial change.

 clutter/clutter-actor.h |    2 +-
 clutter/clutter-color.h |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 81bc2b4cc7c755b825f55424be261a5120f4fc0c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 29 16:34:49 2009 +0100

    [actor] Remove unused clutter_actor_pick()
    
    The clutter_actor_pick() function just emits the ::pick signal
    on the actor. Nobody should be using it, since the paint() method
    is already context sensitive and will result in a ::pick emission
    by itself. The clutter_actor_pick() is just confusing things.

 clutter/clutter-actor.c                    |   29 ----------------------------
 clutter/clutter-actor.h                    |    2 -
 clutter/clutter-deprecated.h               |    2 +
 doc/reference/clutter/clutter-sections.txt |    1 -
 4 files changed, 2 insertions(+), 32 deletions(-)

commit bd668cf156bf54d2ad1cee8ea7cd0c13b02ea95f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 29 16:33:07 2009 +0100

    Add more debug notes inside the master clock

 clutter/clutter-master-clock.c |   20 +++++++++++++++-----
 1 files changed, 15 insertions(+), 5 deletions(-)

commit 9e84e5203421c8a358fbcfe6f1eb6c70f95fd160
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 23 15:45:42 2009 +0100

    [docs] Update after the Input API changes

 doc/reference/clutter/clutter-sections.txt |    3 +--
 1 files changed, 1 insertions(+), 2 deletions(-)

commit 537ccc3cd94cb43740c622d5e65d62cbae062579
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 23 15:25:16 2009 +0100

    [docs] Add an initial porting guide
    
    The Clutter API reference should have a section on how to port
    applications from older version of Clutter to the new API.
    
    The first guide deals on how to port animations created with
    ClutterEffect to clutter_actor_animate().

 doc/reference/clutter/Makefile.am                 |    6 +-
 doc/reference/clutter/clutter-docs.xml.in         |   16 ++-
 doc/reference/clutter/migrating-ClutterEffect.xml |  137 +++++++++++++++++++++
 3 files changed, 154 insertions(+), 5 deletions(-)

commit de745e93c99951baae16151c373ebc06a2571b59
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 23 15:23:53 2009 +0100

    [docs] Fix the ActorBox annotations
    
    The ClutterActorBox API is incorrectly annotated and gtk-doc is unable
    to pick it up.

 clutter/clutter-actor.c |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

commit 20f3c173fe10bee6d04814d08bfe21e23c294cf8
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jun 24 12:04:55 2009 +0100

    [test-shader] Fix some of the shaders to use premultiplied colors
    
    Texture data is now in premultiplied format and the shader should
    output a premultiplied color if the default blend mode is being
    used. Shaders that directly manipulate the rgb values now
    unpremultiply and premultiply again afterwards.

 tests/interactive/test-shader.c |    6 ++++++
 1 files changed, 6 insertions(+), 0 deletions(-)

commit e9d277609d81bd5198638b9565e1668ff8391235
Author: Tim Horton <hortont@svn.gnome.org>
Date:   Thu Jun 18 22:46:48 2009 -0400

    Add element-type annotations for animate*v functions
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1653
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-animation.c |   12 ++++++------
 1 files changed, 6 insertions(+), 6 deletions(-)

commit c272a7b2a2a9817b3b4f67fafcefeb2b241b7eb0
Author: Ole André Vadla Ravnås <ole.andre.ravnas@tandberg.com>
Date:   Thu Jun 18 23:53:46 2009 +0200

    [master clock] Fix MT safety issues
    
    Fix MT issues when enabling threading in Clutter.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1655
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |    8 ++++++++
 1 files changed, 8 insertions(+), 0 deletions(-)

commit ba6c0c27f9b796bbf6f81de1deab10877a287f37
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 22 12:07:08 2009 +0100

    [texture] Revert to integer parameters in ::size-change
    
    In the int-to-float switch for actor properties, the ::size-change signal
    was moved to use floats instead of integers. Sub-pixel precision for image
    size is meaningless, though, so we should revert it back to ints.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1659

 clutter/clutter-texture.c |   96 +++++++++++++++++++++++++--------------------
 1 files changed, 53 insertions(+), 43 deletions(-)

commit 8a1cf0cff4320b61cbede38b39e5b7ece6d24b08
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 18:25:25 2009 +0100

    Post-release bump to 0.9.5

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit fdaaa8b6d701d2b43fd2750de1b018b5af5577ea
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 17:50:31 2009 +0100

    [release] 0.9.4

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit b833ed3c0d678e0fa65da8c602d946446d225f5d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:42:41 2009 +0100

    Update the NEWS file

 NEWS |   78 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 78 insertions(+), 0 deletions(-)

commit 3d49edad85dd4756b4845b619abdfa76ecd4e469
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 18:06:02 2009 +0100

    [docs] Add new input-related accessors
    
    Add the ClutterEvent accessors for the device pointer and type, and
    the ClutterInputDevice accessors for the id and type.

 doc/reference/clutter/clutter-sections.txt |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit a79d6228aa75e5d27f4229c32950494629c81126
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 16:38:35 2009 +0100

    Remove the last few fixed-point entry points
    
    The last fixed-point entry points are just a few, and trivial. The
    end user is expected to do the conversion using the CoglFixed type
    and macros.

 clutter/clutter-behaviour-ellipse.c        |  275 ++--------------------------
 clutter/clutter-behaviour-ellipse.h        |  136 +++++----------
 clutter/clutter-behaviour-rotate.c         |   96 ----------
 clutter/clutter-behaviour-rotate.h         |   11 -
 clutter/clutter-behaviour-scale.c          |  104 -----------
 clutter/clutter-behaviour-scale.h          |   47 ++----
 clutter/clutter-deprecated.h               |   20 ++
 clutter/clutter-timeline.c                 |   16 --
 clutter/clutter-timeline.h                 |    1 -
 doc/reference/clutter/clutter-sections.txt |   16 --
 10 files changed, 94 insertions(+), 628 deletions(-)

commit cb4e5c90835e218247d3787c9df310b1fbdc7726
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 15:12:32 2009 +0100

    [x11] Simplify the XInput support
    
    Instead of using a specific function to check whether the X
    server supports the XInput extension we can use the generic
    Xlib function XQueryExtension(). This cuts down the extra
    checks inside the configure.ac and simplifies the code inside
    clutter_x11_register_xinput().

 clutter/x11/clutter-backend-x11.c |   54 +++++++++++++++++--------------------
 configure.ac                      |   41 ----------------------------
 2 files changed, 25 insertions(+), 70 deletions(-)

commit 21608fe5f7c7a7750b09a1cbd10d68027a425085
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 14:32:37 2009 +0100

    [x11] Add a command line switch for enabling XInput
    
    Currently, XInput support requires a function call. In order to
    make it easier for people to test it, we can also add a command
    line switch that moves the pointer device detection and handling
    to XInput. This should ensure that, at least for people building
    Clutter with --enable-xinput, applications can be easily migrated
    and regressions can be caught.

 clutter/x11/clutter-backend-x11.c |   18 +++++++++++++-----
 1 files changed, 13 insertions(+), 5 deletions(-)

commit 0ec541282acf7b9ea08217b154524013c93b7d95
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 14:20:50 2009 +0100

    [tests] Remove unneeded g_type_init()
    
    Now that we can safely check for an uninitialized Clutter we
    don't have side effects in calling one of the functions like
    clutter_x11_enable_xinput(), which require to be called before
    any other Clutter function.

 tests/interactive/test-devices.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit a6b469736770d2c2ea25b582196bd221ce85721e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 14:19:39 2009 +0100

    [backend] Do not store the stage manager singleton
    
    The StageManager singleton instance is already kept around
    by the clutter_stage_manager_get_default() function; there is
    no need to have it inside the main Clutter context as well.

 clutter/clutter-backend.c         |    9 +++------
 clutter/clutter-private.h         |    1 -
 clutter/x11/clutter-backend-x11.c |    5 +----
 3 files changed, 4 insertions(+), 11 deletions(-)

commit b6e404a40605bc94ad429e5d64325286a381275e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 14:12:36 2009 +0100

    [x11] Use _clutter_context_is_initialized()
    
    Instead of using _clutter_context_get_default() and checking the
    is_initialized flag, we should use the newly added private function
    that does not cause side effects, especially for functions that have
    to be called before any other Clutter function.

 clutter/x11/clutter-backend-x11.c |   22 ++++++++--------------
 1 files changed, 8 insertions(+), 14 deletions(-)

commit b5f4befeaa2d1944c7623a31f8a8ccaae200b640
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 14:09:42 2009 +0100

    Allow checking initialization without side-effects
    
    The _clutter_context_get_default() function will automatically
    create the main Clutter context; if we just want to check whether
    Clutter has been initialized this will complicate matters, by
    requiring a call to g_type_init() inside the client code.
    
    Instead, we should simply provide an internal API that checks
    whether the main Clutter context exists and if it has been
    initialized, without any side effect.

 clutter/clutter-main.c    |   13 +++++++++++--
 clutter/clutter-private.h |    1 +
 2 files changed, 12 insertions(+), 2 deletions(-)

commit 184df2a5fa34375cff8cde5318ba46bdbd7c3026
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 19 13:07:20 2009 +0100

    [input] Rework input device API
    
    The input device API is split halfway thorugh the backends in a very
    weird way. The data structures are private, as they should, but most
    of the information should be available in the main API since it's
    generic enough.
    
    The device type enumeration, for instance, should be common across
    every backend; the accessors for device type and id should live in the
    core API. The internal API should always use ClutterInputDevice and
    not the private X11 implementation when dealing with public structures
    like ClutterEvent.
    
    By adding accessors for the device type and id, and by moving the
    device type enumeration into the core API we can cut down the amount
    of symbols private and/or visible only to the X11 backends; this way
    when other backends start implementing multi-pointer support we can
    share the same API across the code.

 clutter/clutter-event.c           |  147 +++++++++++++++++++++-
 clutter/clutter-event.h           |   95 ++++++++++-----
 clutter/clutter-main.c            |   35 -----
 clutter/clutter-private.h         |    3 +
 clutter/x11/clutter-backend-x11.c |  252 ++++++++++++++++++-------------------
 clutter/x11/clutter-backend-x11.h |    2 +-
 clutter/x11/clutter-event-x11.c   |   39 +++---
 clutter/x11/clutter-x11.h         |   10 +--
 tests/interactive/test-devices.c  |   60 +++++----
 9 files changed, 392 insertions(+), 251 deletions(-)

commit 3653a9a64d1666f05a256d96ef5741144459b686
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Jun 15 14:15:27 2009 +0100

    Public headers should not have #ifdefs relying on private defines
    
    HAVE_COGL_GLES2 is defined in config.h through the configure script and
    should not be used in public headers.
    
    The patch makes configure generate the right define that can be used
    later in the header.

 clutter/cogl/gles/cogl-defines.h.in |    6 ++++--
 configure.ac                        |    3 +++
 2 files changed, 7 insertions(+), 2 deletions(-)

commit c6fba47a5229b7d52f2ff7e78c6cff52ce2069c2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 17 17:59:54 2009 +0100

    Hide clutter_context_get_default()
    
    The clutter_context_get_default() function is private, but shared
    across Clutter. For this reason, it should be prefixed by '_' so
    that the symbol is hidden from the shared object.

 clutter/clutter-actor.c                 |   13 +++----
 clutter/clutter-backend.c               |    8 ++--
 clutter/clutter-event.c                 |   10 +++---
 clutter/clutter-feature.c               |    4 +-
 clutter/clutter-main.c                  |   61 ++++++++++++++++---------------
 clutter/clutter-private.h               |    4 +-
 clutter/clutter-stage.c                 |    5 ++-
 clutter/clutter-texture.c               |    2 +-
 clutter/eglnative/clutter-event-egl.c   |    2 +-
 clutter/fruity/clutter-backend-fruity.c |    8 +++--
 clutter/fruity/clutter-fruity.c         |    2 +-
 clutter/sdl/clutter-event-sdl.c         |    2 +-
 clutter/win32/clutter-backend-win32.c   |    4 +--
 clutter/win32/clutter-event-win32.c     |    6 +--
 clutter/win32/clutter-stage-win32.c     |   10 +++--
 clutter/x11/clutter-backend-x11.c       |   16 ++++----
 clutter/x11/clutter-event-x11.c         |    4 +-
 clutter/x11/clutter-stage-x11.c         |   14 +++----
 18 files changed, 87 insertions(+), 88 deletions(-)

commit 8c676ebd872b65e84896f5390b7642416fcb1040
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 17 15:43:53 2009 +0100

    Remove an unusued member from MainContext
    
    The MainContext structure has a field for the master clock, but
    clutter_master_clock_get_default() will return the same instance
    from everywhere.

 clutter/clutter-main.c    |    2 --
 clutter/clutter-private.h |    1 -
 2 files changed, 0 insertions(+), 3 deletions(-)

commit 1aa8c89f2c18e01e9f36338c0609f58caaa90c3a
Author: Matthew Allum <mallum@openedhand.com>
Date:   Wed Jun 17 15:09:16 2009 +0100

    [XInput] Get XInput working again.
    
    Check for distros shipping out of sync header vs libXi,
    call in g_type_init() in test-devices, fix ifdef so
    XInput events get correctly selected.

 clutter/glx/clutter-stage-glx.c  |    2 +-
 configure.ac                     |   13 ++++++++++---
 tests/interactive/test-devices.c |    2 ++
 3 files changed, 13 insertions(+), 4 deletions(-)

commit 3035092edba837593ff753817b3d8807a83555aa
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 18:08:52 2009 +0100

    Do not use the --pkd switch for g-ir-scanner
    
    Revert commit 8aacff0e0f38d2cdfae841f6a154baa793ea7739

 clutter/Makefile.am |    1 -
 1 files changed, 0 insertions(+), 1 deletions(-)

commit c4716d78d0ee874115e970666ba7739f1829b90e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:42:07 2009 +0100

    [docs] Update the backends hacking reference

 HACKING.backends |    2 --
 1 files changed, 0 insertions(+), 2 deletions(-)

commit 29ab2691166a2417733fef527845e9877e627186
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:41:46 2009 +0100

    [docs] Update the release notes

 README |   40 ++++++++++++++++++++++++++++++++++++----
 1 files changed, 36 insertions(+), 4 deletions(-)

commit 5e098c388668fe3ee3f08b28e73a9a4120216993
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:41:29 2009 +0100

    [docs] Update the HACKING file

 HACKING |   52 +++++++---------------------------------------------
 1 files changed, 7 insertions(+), 45 deletions(-)

commit 8aacff0e0f38d2cdfae841f6a154baa793ea7739
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:40:36 2009 +0100

    [introspection] Add --pkg switch pointing at Clutter
    
    Add a <package/> element pointing to Clutter's pkg-config
    file name.

 clutter/Makefile.am |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 9f83e7dc2ee855dbbb8cb7de8b7a42d43dd485b0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:38:01 2009 +0100

    [stage] Remove an assertion
    
    We might get a size request on destruction, so it should be safe
    to avoid an assertion failure because we don't have the stage
    implementation anymore.

 clutter/clutter-stage.c |    9 ++++++---
 1 files changed, 6 insertions(+), 3 deletions(-)

commit 4bed539b215d2504977aa6cee739854b7ca612d8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 16:30:41 2009 +0100

    Add more ActorBox utility methods
    
    ActorBox should have methods for easily extracting the X and Y
    coordinates of the origin, and the width and height separately.
    
    These methods will make it easier for high-level language bindings
    to manipulate ActorBox instances and avoid the Geometry type.

 clutter/clutter-actor.c                    |   72 ++++++++++++++++++++++++++++
 clutter/clutter-types.h                    |    4 ++
 doc/reference/clutter/clutter-sections.txt |    4 ++
 3 files changed, 80 insertions(+), 0 deletions(-)

commit 9ed2a47db1818322c8ef8a93aa8654c1ab1e7ef6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 13:48:11 2009 +0100

    [doap] Add branches for past releases

 clutter.doap |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

commit 275f292ab9ac2961695d0596d9fe5b172f7470c7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 16 12:47:19 2009 +0100

    Add accessors for the boxed types
    
    The Vertex and ActorBox boxed types are meant to be used across
    the API, but are fairly difficult to bind. Their memory management
    is also unclear, and has to go through the indirection of
    g_boxed_copy() and g_boxed_free().

 clutter/clutter-actor.c                    |  391 +++++++++++++++++++++++-----
 clutter/clutter-actor.h                    |   47 +---
 clutter/clutter-deprecated.h               |    2 +
 clutter/clutter-types.h                    |   90 +++++--
 doc/reference/clutter/clutter-sections.txt |   24 ++-
 5 files changed, 417 insertions(+), 137 deletions(-)

commit 63c84c46f8c4e2c1e0c6654d016912dc3bbaefc5
Author: Colin Walters <walters@verbum.org>
Date:   Tue Jun 16 10:34:13 2009 -0400

    Plug minor memory leak in cogl_vertex_buffer_submit_real
    
    Free a temporary list.

 clutter/cogl/common/cogl-vertex-buffer.c |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit f8e956548235116de18558c86470b16555149122
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 15 15:08:59 2009 +0100

    [tests] Beautify the bouncing actor
    
    The test-easing interactive demo for the high-level animation API
    is a bit "flat". Instead of using a Rectangle actor we should
    probably be using something more "interesting" -- like a CairoTexture
    with a gradient.

 tests/interactive/test-easing.c |   72 ++++++++++++++++++++++++++++++---------
 1 files changed, 56 insertions(+), 16 deletions(-)

commit f95f4ba3cb02b0f4d0aefcd19d18a1af0ba81707
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jun 15 12:41:13 2009 +0100

    [ClutterCairoTexture] Use the right component ordering when uploading data
    
    Cairo stores the image data in ARGB native byte order so we need to
    upload this as BGRA on little endian architectures and ARGB on big
    endian. ClutterTexture doesn't currently expose any flags to describe
    ARGB format so until we can fix the Clutter API it now uses the Cogl
    API directly.

 clutter/clutter-cairo-texture.c |   46 +++++++++++++++++++++++++-------------
 1 files changed, 30 insertions(+), 16 deletions(-)

commit c6b4ea8b442af4e6bfa0e5961685b58c23595e32
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 15 11:50:23 2009 +0100

    [cairo-texture] Clean up and whitespace fixes
    
    Simple clean up of the CairoTexture to remove unneeded checks,
    redundant variables and white space.

 clutter/clutter-cairo-texture.c |   34 ++++++++++++++++------------------
 1 files changed, 16 insertions(+), 18 deletions(-)

commit 9799750c0338218a542334c9f4dbf2177beafa4f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 15 10:53:43 2009 +0100

    [animation] Rework animation chaining
    
    In order to chain up animations using clutter_actor_animate() and
    friends you have to use an idle handler that guarantees that the
    main loop spins at least once after the animation pointer has been
    detached from the actor.
    
    This has several drawbacks, first and foremost the fact that the
    slice of the main loop for the idle handler might be starved by
    other operations, like redrawing. This inevitably leads to tricks
    with priorities and the like, contributing to the overall complexity.
    
    Instead, we should guarantee that the animation instance created by
    clutter_actor_animate() is valid for the ::completed signal until
    it reaches its default handler; after that, the animation is detached
    from the actor and destroyed. This means that it's possible to
    create a new animation after the first is complete by simply using
    g_signal_connect_after().
    
    This unfortunately makes it impossible to keep a reference to the
    animation pointer attached to the actor by using g_object_ref(); a
    way to "fix" this would be to have a clutter_animation_attach()
    and a clutter_animation_detach() pair of methods that allow attaching
    any animation to an actor. This might overcomplicate what it is
    the simple animation API, though, so it's currently not implemented
    and left for future versions.
    
    The test-easing interactive demo has been modified to show how
    the animation queuing works by adding a command line switch that
    recenters the animated actor once the first animation has ended.

 clutter/clutter-animation.c     |  252 ++++++++++++---------------------------
 tests/interactive/test-easing.c |   53 ++++++++-
 2 files changed, 126 insertions(+), 179 deletions(-)

commit 612d1cded77c07b6a4884e5ec3c0bf5b8929bff9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 15 11:24:54 2009 +0100

    [animation] Allow swapped/after signal variants
    
    Continuing in the tradition on making clutter_actor_animate() the
    next g_object_connect(), here's the addition of the signal-after::
    and signal-swapped:: modifiers for the automagic signal connection
    arguments.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1646

 clutter/clutter-animation.c |   47 ++++++++++++++++++++++++++++++++++++++++--
 1 files changed, 44 insertions(+), 3 deletions(-)

commit 0415d62d40b728e328042eb6c1c3f60c92dd2909
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 15 10:48:56 2009 +0100

    Disable single header inclusion for GLib
    
    In order to be ready for the next major version of GLib we need to
    disable single header inclusion by using the G_DISABLE_SINGLE_INCLUDES
    define in the build process.

 clutter/Makefile.am                    |    1 +
 clutter/cogl/common/Makefile.am        |    1 +
 clutter/cogl/gl/Makefile.am            |    1 +
 clutter/cogl/gles/Makefile.am          |    1 +
 clutter/json/Makefile.am               |    1 +
 clutter/pango/Makefile.am              |    1 +
 tests/conform/Makefile.am              |    1 +
 tests/conform/test-clutter-rectangle.c |    2 +-
 tests/interactive/Makefile.am          |    9 +++++++--
 tests/micro-bench/Makefile.am          |    1 +
 10 files changed, 16 insertions(+), 3 deletions(-)

commit e6a987d670cce4e6ce99529f1ef0b227dd237edd
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Thu Jun 11 18:56:27 2009 -0400

    Fix redraw queueing in the presence of cloning
    
    We can't short-circuit the emission of ::queue-redraw for not-visible
    actors, since ClutterClone uses that signal to know when things need
    to be redrawn.
    
    Calling clutter_actor_queue_redraw() out of clutter_actor_real_map() /
    clutter_actor_real_unmap() was causing the flag state to get set
    incorrectly from _clutter_actor_set_enable_paint_unmapped(), because
    a paint queueing a redraw was not expected.
    
    Moving queuing the redraw to clutter_actor_hide()/show() fixes this, and
    also fixes a problem where showing a child of a cloned actor wouldn't
    cause the clone to be repainted.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1484
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-actor.c |   25 +++++++++++++------------
 1 files changed, 13 insertions(+), 12 deletions(-)

commit abac520f0c081c3c4c986d50ff42a297dd6e8ccd
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 12 03:46:38 2009 +0100

    [tests] Add unit for Clone behaviour
    
    A clone actor should not modify the state of its source, so we need
    to check that it's not breaking any invariant.

 .gitignore                            |    2 +
 tests/conform/test-actor-invariants.c |   34 +++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c     |    1 +
 3 files changed, 37 insertions(+), 0 deletions(-)

commit 795e005566f2055999e226da8a34f50890c71c25
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Thu Jun 11 18:46:44 2009 -0400

    Fix handling of not-visible texture pixmaps
    
    If we have an not-visible texture pixmap, we need to:
    
     - Still update it if it is realized, since it won't be
       updated when shown. And it might be also be cloned.
    
     - Queue a redraw if even if not visible, since it
       it might be cloned.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1647
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/glx/clutter-glx-texture-pixmap.c |    2 --
 clutter/x11/clutter-x11-texture-pixmap.c |    3 ---
 2 files changed, 0 insertions(+), 5 deletions(-)

commit b9a53d379d3aaca4b09a90cd44d5a9d9736a2435
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Sun Jun 14 01:16:30 2009 +0100

    [gitignore] ignore TAGS and new test
    
    * ignore files generated by make tags
    * ignore the newly introduced premult test

 .gitignore |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit 0dfc1dd284ea698ed6d3d814d12a5e5b7bff7095
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jun 12 11:05:26 2009 +0100

    [test-cogl-tex-tile] Fix breakages from ClutterFixed removal and timelines
    
    The test has been broken since the change to use floats instead of
    fixed point because it was passing degrees to sin and cos but they
    expect radians.
    
    It was further broken since the timeline changes because it was
    directly using the parameter of the new-frame signal as a frame number
    but it now represents the elapsed time.

 tests/interactive/test-cogl-tex-tile.c |   31 ++++++++++++++-----------------
 1 files changed, 14 insertions(+), 17 deletions(-)

commit 9d829957737fc016033e80c33593d2cc8daa0f4c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 8 17:43:34 2009 +0100

    [_cogl_texture_bitmap_prepare] use bitmap format for FORMAT_ANY + no alpha
    
    My patch to choose a premultiplied format when the user gives
    COGL_PIXEL_FORMAT_ANY for the internal_format broke the case where the data
    in question doesn't have and alpha channel.
    
    This was accidentally missed when merging the premultiplication branch
    since I merged a local version of the branch that missed this commit.

 clutter/cogl/gl/cogl-texture.c   |    2 ++
 clutter/cogl/gles/cogl-texture.c |    2 ++
 2 files changed, 4 insertions(+), 0 deletions(-)

commit 6414adbfeb696282c5e5ca0eb47a77caf3309d92
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 11 16:59:50 2009 +0100

    [tests] Fix the cogl_polygon() interactive test
    
    We need to premultiply the alpha, and we also need to change the
    frame painting to use the frame-less Timeline.

 tests/interactive/test-cogl-tex-polygon.c |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

commit a8fc4e1694a5faef75d3b962640c87b057bef322
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 11 16:53:52 2009 +0100

    [tests] Fix the VBO interactive test
    
    We need to fix the VBO premultiplication; we also do not need to
    forcibly queue a redraw in an idle handler: the timeline and the
    master clock will do that for us.

 tests/interactive/test-cogl-vertex-buffer.c |   26 ++++++++------------------
 1 files changed, 8 insertions(+), 18 deletions(-)

commit 19f112f9bca3077cc946acb828bd681b3ddf1b7c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 11 16:23:26 2009 +0100

    [tests] Update test-actors (and clones)
    
    The test-actors test (and its clones, test-actor-clone and
    test-paint-wrapper) was written a long time ago for a different API
    and has been tweaked to bits. We should probably have something a
    little bit more complicated, but at least we should not use semantics
    and coding patterns from Clutter 0.2, otherwise we won't be testing
    anything except that Clutter 0.2 worked.

 tests/interactive/test-actor-clone.c   |   63 ++++-----
 tests/interactive/test-actors.c        |   56 ++++----
 tests/interactive/test-paint-wrapper.c |  247 +++++++++++++++++---------------
 3 files changed, 181 insertions(+), 185 deletions(-)

commit 71b62e75d24eeee15c6522e6d67f6439fb1315c5
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jun 8 12:18:34 2009 +0100

    [cogl] Don't allow calling cogl_set_source_texture with an INVALID_HANDLE
    
    Although the underlying materials should allow layers with INVALID_HANDLES
    it shouldn't be necissary to expose that via cogl_set_source_texture() and
    it's easier to resolve a warning/crash here than odd artefacts/crashes later
    in the pipeline.

 clutter/cogl/common/cogl-material.c |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit 96827db74089054763c596e28aa180bc0fb1b7c5
Merge: eb55397 ec77b91
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jun 11 15:16:27 2009 +0100

    Bug 1406 - Handling of premultiplication in clutter
    
    Merge branch 'premultiplication'
    
    [cogl-texture docs] Improves the documentation of the internal_format args
    [test-premult] Adds a unit test for texture upload premultiplication semantics
    [fog] Document that fogging only works with opaque or unmultipled colors
    [test-blend-strings] Explicitly request RGBA_888 tex format for test textures
    [premultiplication] Be more conservative with what data gets premultiplied
    [bitmap] Fixes _cogl_bitmap_fallback_unpremult
    [cogl-bitmap] Fix minor copy and paste error in _cogl_bitmap_fallback_premult
    Avoid unnecesary unpremultiplication when saving to local data
    Don't unpremultiply Cairo data
    Default to a blend function that expects premultiplied colors
    Implement premultiplication for CoglBitmap
    Use correct texture format for pixmap textures and FBO's
    Add cogl_color_premultiply()

commit ec77b9139820207962ba38b3cd2ecc491144592f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jun 11 14:31:01 2009 +0100

    [cogl-texture docs] Improves the documentation of the internal_format args
    
    Clarifies that if you give COGL_PIXEL_FORMAT_ANY as the internal format for
    cogl_texture_new_from_file or cogl_texture_new_from_data then Cogl will
    choose a premultiplied internal format.

 clutter/cogl/cogl-texture.h |   16 ++++++++++++++--
 1 files changed, 14 insertions(+), 2 deletions(-)

commit 41579eb3c9d7243d41754e38d30f1d8ad20958fd
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun Jun 7 16:31:12 2009 +0100

    [test-premult] Adds a unit test for texture upload premultiplication semantics
    
    cogl_texture_new_from_data lets you specify a source format for the users given
    data, and an internal format which the user wants the GPU to see. This unit
    test verifies that the users data is premultiplied, un-premultiplied or
    left alone for a number of (source format, internal format) pairs.
    
    cogl_texture_set_region allows specifying a source format, and the internal
    format is determined from the texture being updated. As above we test
    a number of format pairs and check Cogl is converting data correctly.
    
    The test verifies that if the user allows COGL_FORMAT_ANY for the
    internal_format then by default Cogl will choose a premultipled format for
    RGBA textures.
    
    Note: Currently this only tests cogl_texture_new_from_data and
    cogl_texture_set_region, we should also test cogl_texture_new_from_file,
    cogl_texture_new_from_bitmap and cogl_texture_new_from_foreign.

 tests/conform/Makefile.am         |    1 +
 tests/conform/test-conform-main.c |    1 +
 tests/conform/test-premult.c      |  388 +++++++++++++++++++++++++++++++++++++
 3 files changed, 390 insertions(+), 0 deletions(-)

commit 70636b4815283136ca5d878b6e39e12337c4f9ed
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun Jun 7 11:54:05 2009 +0100

    [fog] Document that fogging only works with opaque or unmultipled colors
    
    The fixed function fogging provided by OpenGL only works with unmultiplied
    colors (or if the color has an alpha of 1.0) so since we now premultiply
    textures and colors by default a note to this affect has been added to
    clutter_stage_set_fog and cogl_set_fog.
    
    test-depth.c no longer uses clutter_stage_set_fog for this reason.
    
    In the future when we can depend on fragment shaders we should also be
    able to support fogging of premultiplied primitives.

 clutter/clutter-stage.c        |   10 ++++++++++
 clutter/cogl/cogl.h.in         |   23 ++++++++++++++++-------
 tests/interactive/test-depth.c |    3 ---
 3 files changed, 26 insertions(+), 10 deletions(-)

commit 80aceda9bb3fde41827cb35bec98ba523a095b0f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat Jun 6 21:55:05 2009 +0100

    [test-blend-strings] Explicitly request RGBA_888 tex format for test textures
    
    This test assumes that the textures will be stored internally with exactly
    the color given so that specific texture combining arithmetic can be
    tested. Using COGL_PIXEL_FORMAT_ANY allows Cogl to internally premultiply
    the textures, so we have to explicitly request an unmultiplied format.

 tests/conform/test-blend-strings.c |    4 +++-
 1 files changed, 3 insertions(+), 1 deletions(-)

commit a9b011f3edc9730f60280e38bf2164f1c2dd95a9
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat Jun 6 21:45:05 2009 +0100

    [premultiplication] Be more conservative with what data gets premultiplied
    
    We don't want to force texture data to be premultipled if the user
    explicitly specifies a non premultiplied internal_format such as
    COGL_PIXEL_FORMAT_RGBA_8888.  So now Cogl will only automatically
    premultiply data when COGL_PIXEL_FORMAT_ANY is given for the
    internal_format, or a premultiplied internal format such as
    COGL_PIXEL_FORMAT_RGBA_8888_PRE is requested but non-premultiplied source
    data is given.
    
    This approach is consistent with OpenVG image formats which have already
    influenced Cogl's pixel format semantics.

 clutter/cogl/gl/cogl-texture.c   |   24 +++++++++++-------------
 clutter/cogl/gles/cogl-texture.c |   24 +++++++++++-------------
 2 files changed, 22 insertions(+), 26 deletions(-)

commit 9d3aa576045ce0aea51ef767b74596bb4582570f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun Jun 7 15:58:56 2009 +0100

    [bitmap] Fixes _cogl_bitmap_fallback_unpremult
    
    The _cogl_unpremult_alpha_{first,last} functions which
    _cogl_bitmap_fallback_unpremult depends on were incorrectly casting each
    of the byte components of a texel to a gulong and performing shifts as
    if it were dealing with the whole texel.
    
    It now just uses array indexing to access the byte components without
    needing to cast or manually shift any bits around.
    
    Even though we used to depend on unpremult whenever we used a
    ClutterCairoTexture, clutter_cairo_texture_context_destroy had it's own
    unpremult code which worked which is why this bug wouldn't have been noticed
    before.

 clutter/cogl/common/cogl-bitmap-fallback.c |   60 ++++++++++++++--------------
 1 files changed, 30 insertions(+), 30 deletions(-)

commit cb959ef457a670a5e827963d4a85f6c732993295
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun Jun 7 20:29:13 2009 +0100

    [cogl-bitmap] Fix minor copy and paste error in _cogl_bitmap_fallback_premult
    
    The returned bitmap format should include the COGL_PREMULT_BIT flag not
    have it explicitly removed as for _cogl_bitmap_fallback_unpremult.

 clutter/cogl/common/cogl-bitmap-fallback.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 5e18cee77ab0167a000bb3af8a7c047357141177
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat May 9 14:39:01 2009 -0400

    Avoid unnecesary unpremultiplication when saving to local data
    
    Now that we typically have premultiplied data stored in Cogl
    textures, when fetching a texture into local data for temporary
    storage, use a premultiplied format to avoid an unpremultiply/
    premultiply roundtrip.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1406
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/clutter-texture.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit 1e5b5d10c5608efa411afcb8e032c5e956325249
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Thu Jun 4 13:45:43 2009 -0400

    Don't unpremultiply Cairo data
    
    Instead of unpremultiplying the Cairo data, pass it directly to Cogl
    in premultiplied form; we now *prefer* premultiplied data.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1406
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/clutter-cairo-texture.c |   58 ++++++---------------------------------
 1 files changed, 9 insertions(+), 49 deletions(-)

commit c3448314d59a855a7dfaa47d68c3fa3531eee4ce
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat May 9 14:39:01 2009 -0400

    Default to a blend function that expects premultiplied colors
    
    Many operations, like mixing two textures together or alpha-blending
    onto a destination with alpha, are done most logically if texture data
    is in premultiplied form. We also have many sources of premultiplied
    texture data, like X pixmaps, FBOs, cairo surfaces. Rather than trying
    to work with two different types of texture data, simplify things by
    always premultiplying texture data before uploading to GL.
    
    Because the default blend function is changed to accommodate this,
    uses of pure-color CoglMaterial need to be adapted to add
    premultiplication.
    
    gl/cogl-texture.c gles/cogl-texture.c: Always premultiply
      non-premultiplied texture data before uploading to GL.
    
    cogl-material.c cogl-material.h: Switch the default blend functions
      to ONE, ONE_MINUS_SRC_ALPHA so they work correctly with premultiplied
      data.
    
    cogl.c: Make cogl_set_source_color() premultiply the color.
    
    cogl.h.in color-material.h: Add some documentation about
      premultiplication and its interaction with color values.
    
    cogl-pango-render.c clutter-texture.c tests/interactive/test-cogl-offscreen.c:
      Use premultiplied colors.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1406
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/clutter-texture.c               |    3 ++-
 clutter/cogl/cogl-material.h            |   10 ++++++++++
 clutter/cogl/cogl.h.in                  |    9 +++++++--
 clutter/cogl/common/cogl-material.c     |    2 +-
 clutter/cogl/common/cogl.c              |    7 ++++++-
 clutter/cogl/gl/cogl-texture.c          |   22 ++++++++++++----------
 clutter/cogl/gles/cogl-texture.c        |   23 +++++++++++++----------
 clutter/pango/cogl-pango-display-list.c |    5 ++++-
 clutter/pango/cogl-pango-render.c       |   18 +++++++++++-------
 tests/interactive/test-cogl-offscreen.c |    2 +-
 10 files changed, 67 insertions(+), 34 deletions(-)

commit 888a26199918f84d6f444910f49db8cc321296f3
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat May 9 14:39:01 2009 -0400

    Implement premultiplication for CoglBitmap
    
    cogl-bitmap.c cogl-bitmap-pixbuf.c cogl-bitmap-fallback.c cogl-bitmap-private.h:
      Add _cogl_bitmap_can_premult(), _cogl_bitmap_premult() and implement
      a reasonably fast implementation in the "fallback" code.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1406
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/cogl/common/cogl-bitmap-fallback.c |   93 ++++++++++++++++++++++++++++
 clutter/cogl/common/cogl-bitmap-pixbuf.c   |   13 ++++
 clutter/cogl/common/cogl-bitmap-private.h  |   14 ++++
 clutter/cogl/common/cogl-bitmap.c          |   26 ++++++--
 4 files changed, 140 insertions(+), 6 deletions(-)

commit 4dcd5f6134f62bf1d5988cea7479b14c896190fd
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat May 9 14:39:01 2009 -0400

    Use correct texture format for pixmap textures and FBO's
    
    RGBA data in X pixmaps and in FBOs is already premultiplied; use
    the right format when creating cogl textures.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1406
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/clutter-texture.c                |    4 ++--
 clutter/glx/clutter-glx-texture-pixmap.c |    6 ++++--
 clutter/x11/clutter-x11-texture-pixmap.c |    6 ++++--
 3 files changed, 10 insertions(+), 6 deletions(-)

commit f90017ab4ef69d1275f726f4a8a272bfae3cb5a7
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat May 9 14:39:01 2009 -0400

    Add cogl_color_premultiply()
    
    Add a convenience function to convert an ARGB color from
    non-premultiplied to premultiplied form.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1406
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/cogl/cogl-color.h        |   12 ++++++++++++
 clutter/cogl/common/cogl-color.c |    8 ++++++++
 2 files changed, 20 insertions(+), 0 deletions(-)

commit eb55397423181272914c4bdb861eb55b72808dc6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 11 13:24:34 2009 +0100

    [build] Fix distcheck for the json-glib internal copy
    
    Since commit d743aeaa updated the internal copy of JSON-GLib and
    added a new private header file, we need to fix the build to avoid
    a distcheck failure.

 clutter/json/Makefile.am |   12 +++++++-----
 1 files changed, 7 insertions(+), 5 deletions(-)

commit 61c45da90a489a619b6e99b6a93f12c5192d306a
Merge: cd08dc6 e60584e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 11 13:01:34 2009 +0100

    Bug 1637 - Master clock improvements
    
    Merge branch 'master-clock-updates'
    
    * master-clock-updates: (22 commits)
      Change the paint forcing on the Text cache text
      [timelines] Improve marker hit check and don't fudge the delta
      Revert "[timeline] Don't clamp the elapsed time when a looping tl reaches the end"
      [tests] Don't add a newline to the end of g_test_message calls
      [test-timeline] Add a marker at the beginning of the timeline
      [timeline] Don't clamp the elapsed time when a looping tl reaches the end
      [master-clock] Throttle if no redraw was performed
      [docs] Update Clutter's API reference
      Force a paint instead of calling clutter_redraw()
      Fix clutter_redraw() to match the redraw cycle
      Run the repaint functions inside the redraw cycle
      Remove useless manual timeline ticking
      Move elapsed-time calculations into ClutterTimeline
      Limit the frame rate when not syncing to VBLANK
      Decrease the main-loop priority of the frame cycle
      Avoid motion-compression in test-picking test
      Compress events as part of the frame cycle
      Remove stage update idle and do updates from the master clock
      Call g_main_context_wakeup() when we start running timelines
      Remove unused msecs_delta member
      ...

commit cd08dc6327d5c1eb5342c49b222ad00feaa9c449
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 11 12:36:41 2009 +0100

    [tests] Fix a segfault in the binding-pool test
    
    The commit that moved all the properties to floats missed the
    test-binding-pool interactive test.

 tests/interactive/test-binding-pool.c |   24 ++++++++++++------------
 1 files changed, 12 insertions(+), 12 deletions(-)

commit e60584ea6f7db76974b18789c9b90aaeeedf072a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 18:10:32 2009 +0100

    Change the paint forcing on the Text cache text
    
    The changes in the master clock and the repaint cycle have been
    changed, and broke the way the test for the Text actor cache of
    PangoLayouts forces a redraw.
    
    We have to call clutter_actor_paint() on the Stage embedding the
    Text actor we want to test; this is kinda fugly because if the
    Layout has changed it will end up causing a reallocation cycle
    in the middle of the Text actor paint. Since it's a test case,
    and since forcing redraws is a bit of a hack as well, we can
    close both our eyes on that.

 tests/conform/test-text-cache.c |    9 ++++++++-
 1 files changed, 8 insertions(+), 1 deletions(-)

commit f1000db3caa450e4917b48d3c4f69bea5a255197
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 11 12:14:53 2009 +0100

    [timelines] Improve marker hit check and don't fudge the delta
    
    Markers added at the start of the timeline need to be special cased
    because we effectively check whether the marker time is greater than
    the old frame time or less than or equal to the new frame time but we
    never actually emit a frame for the start of the timeline.
    
    If the timeline is looping then it adjusts the position to interpolate
    a wrapped around position. However we do not emit a new frame after
    setting this position so we need to check for markers again there.
    
    clutter_timeline_get_delta should return the actual wall clock time
    between emissions of the new-frame signal - even if the elapsed time
    has been fudged at the end of the timeline. To make this work it no
    longer directly manipulates priv->msecs_delta but instead passes a
    delta value to check_markers.

 clutter/clutter-timeline.c |  102 ++++++++++++++++++++++++++++++++++++-------
 1 files changed, 85 insertions(+), 17 deletions(-)

commit bf0c21e0154a9666d5be2be18cf93f3a5119953c
Author: Tommi Komulainen <tko@litl.com>
Date:   Fri Apr 24 16:43:39 2009 +0100

    stage: set key focus actor to NULL before emitting focus-out
    
    Someone might hide the previously focused actor in the focus-out signal
    handler and as key focus still appears to be on that actor we'd get
    re-entrant call and get glib critical from g_object_weak_unref
    
    This changes clutter_stage_get_key_focus() to return stage/NULL during
    focus-out signal emission. It used to be the actor focus-out was being
    emitted on.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1547
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-stage.c |   18 +++++++++++++++++-
 1 files changed, 17 insertions(+), 1 deletions(-)

commit 9021aa2909189becd9809d29ebf8c9a3c362ce5f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 11 10:55:52 2009 +0100

    Revert "[timeline] Don't clamp the elapsed time when a looping tl reaches the end"
    
    This reverts commit 9c5663d6717722d6d77162060f284355b5081174.
    
    The patch was causing problems for applications that expect the
    elapsed_time to be at either end of the timeline when the completed
    signal is fired. For example test-behave swaps the direction of the
    timeline in the completed handler but if the time has overflowed the
    end then the timeline would only take a short time to get back the
    beginning. This caused the animation to just vibrate around the
    beginning.

 clutter/clutter-timeline.c                |  142 ++++++++++-------------------
 tests/conform/test-timeline-interpolate.c |    8 +-
 2 files changed, 54 insertions(+), 96 deletions(-)

commit 6bb5b3a13e6dfe1934c9d2476f00ac2be86d33cd
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 11 11:38:49 2009 +0100

    [tests] Don't add a newline to the end of g_test_message calls
    
    Two of the timeline tests were calling g_test_message and adding a \n
    so the output looked odd.

 tests/conform/test-timeline-interpolate.c |   14 +++++++-------
 tests/conform/test-timeline-rewind.c      |   20 ++++++++++----------
 2 files changed, 17 insertions(+), 17 deletions(-)

commit 19cbb307831234e5cfeb473802db77eb56328013
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 11 11:23:45 2009 +0100

    [test-timeline] Add a marker at the beginning of the timeline
    
    The beginning of the timeline needs special treatment to detect a
    marker so it should have one in the conformance test.

 tests/conform/test-timeline.c |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit 9c5663d6717722d6d77162060f284355b5081174
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jun 10 17:41:16 2009 +0100

    [timeline] Don't clamp the elapsed time when a looping tl reaches the end
    
    The new-frame signal of a timeline was previously guaranteed to be
    emitted with the elapsed_time set to the end before it emits the
    completed signal. This doesn't necessarily make sense for looping
    timelines because it would cause the elapsed time to be clamped to a
    slightly off value whenever the timeline restarts. This patch makes it
    perform the wrap around before emitting the new-frame signal so that
    the elapsed time always corresponds to the time elapsed since the
    timeline was started.
    
    Additionally it no longer fudges the msecs_delta property to make the
    marker check work so clutter_timeline_get_delta will always return the
    wall clock time since the last frame.

 clutter/clutter-timeline.c                |  142 +++++++++++++++++++----------
 tests/conform/test-timeline-interpolate.c |    8 +-
 2 files changed, 96 insertions(+), 54 deletions(-)

commit df839e22e6c5e5e323168fd4b336ff2b4df0fbcc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 16:23:35 2009 +0100

    [text] Do not leak the effective attributes
    
    Thanks to Iain Holmes for catching the leak.

 clutter/clutter-text.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit acf7722a41dc5c568f895166cc471f53f3546926
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jun 10 15:50:27 2009 +0100

    [master-clock] Throttle if no redraw was performed
    
    A flag in the master clock is now set whenever the dispatch caused an
    actual redraw of a stage. If this flag is not set during the prepare
    and check functions then it will resort to limiting the redraw
    attempts to the default frame rate as if vblank syncing was
    disabled. Otherwise if a timeline is running that does not cause the
    scene to change then it would busy-wait with 100% CPU until the next
    frame.
    
    This fix was suggested by Owen Taylor in:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |   11 +++++++++--
 clutter/clutter-private.h      |    2 +-
 clutter/clutter-stage.c        |   12 ++++++++----
 3 files changed, 18 insertions(+), 7 deletions(-)

commit eca73fe6c7cdc6657f6da2bdff19d635d0459792
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 14:54:42 2009 +0100

    [docs] Annotate fixed sized arrays

 clutter/clutter-actor.c |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

commit 7c08f554bc403938d90363fcba552d5121ad1449
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 14:54:19 2009 +0100

    [docs] Update Clutter's API reference

 doc/reference/clutter/clutter-sections.txt |    5 +----
 1 files changed, 1 insertions(+), 4 deletions(-)

commit 0f9dea0337aadc5c7218c93a592d83ae4828d6b4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 14:52:53 2009 +0100

    Force a paint instead of calling clutter_redraw()
    
    We do not need the whole redraw machinery inside
    clutter_stage_read_pixels(): instead, we want Clutter to drop everything,
    paint and call glReadPixels() with the current buffer.

 clutter/clutter-stage.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 92a7e23ec1c7fbbb8233bf7207630b5fc9992c08
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 14:24:33 2009 +0100

    [build] Use top_srcdir instead of relative paths

 doc/reference/clutter/Makefile.am |   12 ++++++------
 1 files changed, 6 insertions(+), 6 deletions(-)

commit 84d67bf1b3c39444efd2c85c90f9bbd7da5fc0ec
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 14:23:45 2009 +0100

    [l10n] Add LINGUAS
    
    Use the LINGUAS file to generate the contents of the ALL_LINGUAS
    variable.

 configure.ac |    2 +-
 po/LINGUAS   |    1 +
 2 files changed, 2 insertions(+), 1 deletions(-)

commit bd3254c0f8ee775df9979deb46d2ac8dbfc92876
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 10 12:50:45 2009 +0100

    [docs] Various gtk-doc fixes for COGL
    
    Try to keep the gtk-doc errors down to a minimum.

 clutter/cogl/cogl-bitmap.h           |    8 ++-
 clutter/cogl/cogl-material.h         |   24 ++++++----
 clutter/cogl/cogl-matrix.h           |   32 +++++++------
 clutter/cogl/cogl-offscreen.h        |    4 +-
 clutter/cogl/cogl-vertex-buffer.h    |    9 +++-
 clutter/cogl/cogl.h.in               |    6 +-
 doc/reference/cogl/Makefile.am       |    2 -
 doc/reference/cogl/cogl-sections.txt |   83 +++++++++++++++++++++++++++++++--
 8 files changed, 126 insertions(+), 42 deletions(-)

commit e1cac4fece275c0e8428942a880ae5e5f4b3b13b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 16:29:29 2009 +0100

    Fix clutter_redraw() to match the redraw cycle
    
    The clutter_redraw() function is used by embedding toolkits to
    force a redraw on a stage. Since everything is performed by
    toggling a flag inside the Stage itself and then letting the
    master clock advance, we need a ClutterStage method to ensure
    that we start the master clock and redraw.

 clutter/clutter-main.c                     |   13 ++-----------
 clutter/clutter-stage.c                    |   27 +++++++++++++++++++++++++++
 clutter/clutter-stage.h                    |    1 +
 doc/reference/clutter/clutter-sections.txt |    1 +
 4 files changed, 31 insertions(+), 11 deletions(-)

commit 7099d251c664752ef72c076d2b9cc45b70d58624
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 16:28:25 2009 +0100

    Run the repaint functions inside the redraw cycle
    
    Now that every redraw is performed within the master clock we
    need to run the repaint functions inside it.

 clutter/clutter-master-clock.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

commit 287d4f76ecf0ccd2171eaf4a61c79ccea06e5f1d
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Jun 8 13:13:18 2009 -0400

    Remove useless manual timeline ticking
    
    The master clock now works fine whether or not there are any stages,
    so in the timeline conformance tests don't need to set up their
    own times.
    
    Set CLUTTER_VBLANK=none for the conformance tests, which in addition
    to removing an test-environment dependency, will result in the ticking
    for timeline tests being throttled to the default frame rate.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 tests/conform/test-conform-main.c         |    7 ++++
 tests/conform/test-timeline-interpolate.c |   19 ------------
 tests/conform/test-timeline-rewind.c      |   19 ------------
 tests/conform/test-timeline.c             |   44 -----------------------------
 4 files changed, 7 insertions(+), 82 deletions(-)

commit 6705ce6c6a8c7b490714a15c697c1ad24c9bf8b0
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Jun 8 13:00:09 2009 -0400

    Move elapsed-time calculations into ClutterTimeline
    
    Instead of calculating a delta in the master clock, and passing that
    into each timeline, make each timeline individually responsible for
    remembering the last time and computing the delta.
    
    This:
    
     - Fixes a problem where we could spin infinitely processing
       timeline-only frames with < 1msec differences.
     - Makes timelines consistently start timing on the first frame;
       instead of doing different things for the first started timeline
       and other timelines.
     - Improves accuracy of elapsed time computations by avoiding
       accumulating microsecond => millisecond truncation errors.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c            |   37 ++------------------
 clutter/clutter-timeline.c                |   53 +++++++++++++++++++++--------
 clutter/clutter-timeline.h                |    4 +-
 tests/conform/test-timeline-interpolate.c |   17 +---------
 tests/conform/test-timeline-rewind.c      |   17 +---------
 tests/conform/test-timeline.c             |   15 +--------
 6 files changed, 48 insertions(+), 95 deletions(-)

commit dcd8d2831455f1ae950cbab073f37d0ad36d2295
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 22:48:15 2009 -0400

    Limit the frame rate when not syncing to VBLANK
    
    clutter-master-clock.c clutter-master-clock.h: When the
      SYNC_TO_VBLANK feature is not available, wait for 1/frame_rate
      seconds since the start of the last frame before drawing the next
      frame. Add _clutter_master_clock_start_running() to abstract
      the usage of g_main_context_wakeup()
    
    clutter-stage.c: Add _clutter_master_clock_start_running()
    
    clutter-main.c: Update docs for clutter_set_default_frame_rate()
      clutter_get_default_frame_rate() to no longer talk about timeline
      frame rates.
    
    test-text-perf.c test-text.c: Set a frame rate of 1000fps so that
      frame-rate limiting doesn't affect the result.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-main.c             |    9 ++-
 clutter/clutter-master-clock.c     |  131 ++++++++++++++++++++++++++++--------
 clutter/clutter-master-clock.h     |    2 +
 clutter/clutter-stage.c            |   18 ++++--
 tests/micro-bench/test-text-perf.c |    1 +
 tests/micro-bench/test-text.c      |    1 +
 6 files changed, 124 insertions(+), 38 deletions(-)

commit 64bb2e694fde2656c26b3b0bf60edbab544ba7ee
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 19:31:32 2009 -0400

    Decrease the main-loop priority of the frame cycle
    
    Change CLUTTER_PRIORITY_REDRAW to be lower than the GTK+ resize
      and relayout priorities to avoid starving GTK+ when run in the
      same process as clutter.
    Remove the unused CLUTTER_PRIORITY_TIMELINE
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-main.h |   17 ++++++-----------
 1 files changed, 6 insertions(+), 11 deletions(-)

commit fc83e364779431dd3a89733ad9e762440de8a001
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 22:55:34 2009 -0400

    Avoid motion-compression in test-picking test
    
    Using clutter_stage_get_actor_at_pos() rather than synthesizing
    events; the synthesized events were being compressed, so we were
    only tesitng one pick per frame.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 tests/micro-bench/test-picking.c |   20 +++++++-------------
 1 files changed, 7 insertions(+), 13 deletions(-)

commit 6e69692e22334d15e2d01d39439362bbf1ba8679
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 19:10:41 2009 -0400

    Compress events as part of the frame cycle
    
    Instead of trying to guess about which motion events are
    extraneous, queue up all events until we process a frame.
    This allows us to look ahead and reliably compress consecutive
    sequence of motion events.
    
    clutter-main.c: Feed received events to the stage for queueing.
      Remove old compression code. Remove clutter_get_motion_events_frequency()
      clutter_set_motion_events_frequency()
    clutter-stage.c: Keep a queue of pending events.
    clutter-master-clock.c: Add processng of queued events to the
      clock source dispatch function.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-main.c         |  129 +++++++--------------------------------
 clutter/clutter-main.h         |    2 -
 clutter/clutter-master-clock.c |   19 +++++-
 clutter/clutter-private.h      |   10 +++-
 clutter/clutter-stage.c        |   90 +++++++++++++++++++++++++++-
 5 files changed, 136 insertions(+), 114 deletions(-)

commit 89a8fd7755b7a12d579994f7cf0d0e66cf7f99b6
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 18:22:51 2009 -0400

    Remove stage update idle and do updates from the master clock
    
    When a redraw is queued on a stage, simply set a flag; then in
    the check/prepare functions of the master clock source, check
    for stages that need redrawing.
    
    This avoids the complexity of having multiple competing sources
    at the same priority and makes the update ordering more reliable and
    understandable.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |   27 ++++++++----
 clutter/clutter-private.h      |    2 +
 clutter/clutter-stage.c        |   84 +++++++++++++++++++++-------------------
 3 files changed, 64 insertions(+), 49 deletions(-)

commit 77cd4e2bc8ec4ad99ab2349fcb10dc5f0b57dca8
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 18:12:26 2009 -0400

    Call g_main_context_wakeup() when we start running timelines
    
    If a timeline is added from a different thread, we need to
    call g_main_context_wakeup() to wake the main thread up to
    start updating the timeline.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |    5 +++++
 1 files changed, 5 insertions(+), 0 deletions(-)

commit 4b63f9524e64f2c0a2f7baa4034f2a9657de7ddb
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 18:11:19 2009 -0400

    Remove unused msecs_delta member
    
    msecs_delta member of ClutterMasterClock was set but not used.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |    2 --
 1 files changed, 0 insertions(+), 2 deletions(-)

commit ebaec9798ed6790a559c96010e1074b74c1e260b
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 17:44:40 2009 -0400

    Simplify timeout list handling for the master clock
    
    Instead of keeping a list of all timelines, and connecting to
    signals and weak notifies, simply keep a list of running timelines;
    this greatly simplifies both the book-keeping, and also determining
    if there are any running timelines.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |  117 +++++++---------------------------------
 clutter/clutter-timeline.c     |   39 ++++++++++----
 2 files changed, 48 insertions(+), 108 deletions(-)

commit 3ab303b66234f633d03db660e4a780320dbfe423
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 17:54:05 2009 -0400

    Only advance the master clock before drawing a frame
    
    Remove code to advance the master clock after drawing a frame; if
    there are any running timelines the master clock will do another
    frame by itself, and the clock will be advanced before running
    that frame.
    
    With this change, there is no point in queueing an extra frame
    redraw after completing a timeline, since we are always advancing
    the timeline *before* redrawing, so remove that code as well.
    (This does mean that calling clutter_timeline_stop() won't implicitly
    cause the stage to be redrawn; this doesn't seem like something
    an app should rely on in any case.)
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1637
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-main.c         |    5 ---
 clutter/clutter-master-clock.c |   63 ----------------------------------------
 2 files changed, 0 insertions(+), 68 deletions(-)

commit 19c2e66398280950d210a321beae5774a735fed4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 14:47:36 2009 +0100

    [docs] Various gtk-docs fixes

 clutter/clutter-event.c                    |    2 +-
 clutter/clutter-stage.c                    |    2 +-
 clutter/clutter-timeline.c                 |   50 +---------------------------
 clutter/clutter-units.c                    |    6 ++--
 clutter/clutter-units.h                    |    2 +-
 clutter/eglnative/clutter-egl.h            |    7 ++++
 clutter/eglx/clutter-backend-egl.c         |    2 +-
 clutter/eglx/clutter-eglx.h                |    8 ++++
 doc/reference/clutter/clutter-sections.txt |    1 +
 9 files changed, 24 insertions(+), 56 deletions(-)

commit 33f5fe73b3acfabd20dd867244005a6cf2609ab1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 14:05:03 2009 +0100

    [stage] Rename fullscreen methods
    
    The clutter_stage_fullscreen() and clutter_stage_unfullscreen() are
    a GDK-ism. The underlying implementation is already using an accessor
    with a boolean parameter.
    
    This should take the amount of collisions between properties, methods
    and signals to zero.

 clutter/clutter-deprecated.h                   |    3 +
 clutter/clutter-stage.c                        |   75 ++++++++++++------------
 clutter/clutter-stage.h                        |    5 +-
 doc/reference/clutter/clutter-sections.txt     |    4 +-
 tests/interactive/test-clutter-cairo-flowers.c |    2 +-
 tests/interactive/test-events.c                |   12 +---
 tests/interactive/test-fullscreen.c            |    4 +-
 tests/interactive/test-perspective.c           |    2 +-
 8 files changed, 54 insertions(+), 53 deletions(-)

commit 7c89a0ccfab2d597b306f8189c623cec3ee76580
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 13:48:03 2009 +0100

    [stage] Rename :fullscreen to :fullscreen-set
    
    The :fullscreen property is very much confusing as it is implemented.
    It can be written to a value, but the whole process might fail. If we
    set:
    
      g_object_set (stage, "fullscreen", TRUE, NULL);
    
    and the fullscreen process fails or it is not implemented, the value
    will be reset to FALSE (if we're lucky) or left TRUE (most of the
    times).
    
    The writability is just a shorthand for invoking clutter_stage_fullscreen()
    or clutter_stage_unfullscreen() depending on a boolean value without
    using an if.
    
    The :fullscreen property also greatly confuses high level languages,
    since the same symbol is used:
    
      - for a method name (Clutter.Stage.fullscreen())
      - for a property name (Clutter.Stage.fullscreen)
      - for a signal (Clutter.Stage::fullscreen)
    
    For these reasons, the :fullscreen should be renamed to :fullscreen-set
    and be read-only. Implementations of the Stage should only emit the
    StageState event to change from normal to fullscreen, and the Stage
    will automatically update the value of the property and emit a notify
    signal for it.

 clutter/clutter-stage.c              |  127 ++++++++++++++++++----------------
 clutter/sdl/clutter-stage-sdl.c      |    2 +-
 clutter/x11/clutter-stage-x11.c      |    4 +-
 tests/interactive/test-events.c      |   12 ++-
 tests/interactive/test-fullscreen.c  |    2 +-
 tests/interactive/test-perspective.c |    3 +-
 6 files changed, 79 insertions(+), 71 deletions(-)

commit ea82346e0df061e230d9ce27c2ff578558e54c5f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 12:43:57 2009 +0100

    [build] Update the experimental features checks
    
    Instead of blacklisting experimental features at the end we can
    explicitly mark backends and image backends near their checks and
    provide a summary at the end.

 configure.ac |   23 +++++++++++++++++------
 1 files changed, 17 insertions(+), 6 deletions(-)

commit d743aeaa21b2c06ce9e673808e6f3ab2b05dd929
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 12:42:19 2009 +0100

    [json] Update the internal JSON-GLib copy
    
    There have been changes in JSON-GLib upstream to clean up the
    data structures, and facilitate introspection.
    
    We still not use the updated JsonParser with the (private) JsonScanner
    code, since it's a fork of GLib's GScanner.

 clutter/clutter-script.c          |    2 +-
 clutter/json/json-array.c         |  479 ++++++++++++++++++++++++++-
 clutter/json/json-generator.c     |    4 +-
 clutter/json/json-node.c          |  163 ++++++++--
 clutter/json/json-object.c        |  647 +++++++++++++++++++++++++++++++++++--
 clutter/json/json-parser.c        |    8 +-
 clutter/json/json-types-private.h |   61 ++++
 clutter/json/json-types.h         |  228 ++++++++++----
 8 files changed, 1459 insertions(+), 133 deletions(-)

commit 91856b1bed071b98a4d3eb22a4efae089faf6490
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 12:40:06 2009 +0100

    [introspection] Add --c-include to g-ir-scanner
    
    Since Clutter has a single-include header policy we need to put
    the header to be included inside the GIR file.

 clutter/Makefile.am      |   38 ++++++++++++++++++++------------------
 clutter/cogl/Makefile.am |    1 +
 2 files changed, 21 insertions(+), 18 deletions(-)

commit 8728afa2ee8311a92021ee70ca5c4d09fe6c4966
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 9 12:39:28 2009 +0100

    [build] Add as-compiler-flag.m4 to the dist

 build/autotools/Makefile.am |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 4b125d7fde86559baaf945943bbe5d9f81b45c9e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jun 9 11:13:11 2009 +0100

    [CoglTexture] Initialise tex->first_pixels to NULL in all constructors
    
    Otherwise if there is an error before the slices are created it will
    try to free the first_pixels array and crash.
    
    It now also checks whether first_pixels has been created before using
    it to update the mipmaps. This should only happen for
    cogl_texture_new_from_foreign and doesn't matter if the FBO extension
    is available. It would be better in this case to fetch the first pixel
    using glGetTexImage as Owen mentioned in the last commit.

 clutter/cogl/gl/cogl-texture.c   |    6 +++++-
 clutter/cogl/gles/cogl-texture.c |    6 +++++-
 2 files changed, 10 insertions(+), 2 deletions(-)

commit 1d7a7bf1e61a800e5ddeb738899f09a0009eabba
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Jun 8 16:45:43 2009 -0400

    Fix unitialized first_pixels for foreign textures
    
    tex->first_pixels was never set for foreign textures, leading
    to a crash when the texture object is freed.
    
    As a quick fix, simply set to NULL. A more complete fix would
    require remembering if we had ever seen the first pixel uploaded,
    and if not, doing a glReadPixel to get it before triggering the
    mipmap update.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1645
    
    Signed-off-by: Neil Roberts <neil@linux.intel.com>

 clutter/cogl/gl/cogl-texture.c   |    2 ++
 clutter/cogl/gles/cogl-texture.c |    2 ++
 2 files changed, 4 insertions(+), 0 deletions(-)

commit 08d580f68a02b7cd9eb4b8a93d9f32aa63db3a38
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Jun 8 09:26:57 2009 -0400

    On bad blend strings, print the error if not returning it
    
    It's very common that there's no reasonable fallback to do if the
    blend or combine string you set isn't supported. So, rather than
    requiring everybody to pass in a GError purely to catch syntax erorrs,
    automatically g_warning() if a parse error is encountered and @error
    is NULL.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1642
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/cogl/cogl-material.h        |    5 ++++-
 clutter/cogl/common/cogl-material.c |   30 ++++++++++++++++++++++++++----
 2 files changed, 30 insertions(+), 5 deletions(-)

commit d873a57ec90da7b5ae5b2cec62c1779316200177
Author: Garry Bodsworth <gjb@camvine.com>
Date:   Mon Jun 8 11:56:59 2009 +0100

    Fix for new potential memory leak in ClutterGLXTexturePixmap.
    
    This fixes a new instance of glXDestroyGLXPixmap which should be
    glXDestroyPixmap.
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/glx/clutter-glx-texture-pixmap.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit fd0a490ced2a945eb19ed9d22b88efc7ade5f97c
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Jun 8 07:57:41 2009 -0400

    Properly adjust msecs_delta when clamping elapsed time
    
    When we complete a timeline, we clamp the elapsed_time variable
    to the range of the timeline. We need to adjust msecs_delta so that
    when we check for hit markers we have the correct interval.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1641
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-timeline.c |   14 +++++++++++---
 1 files changed, 11 insertions(+), 3 deletions(-)

commit fd19d337461bd187a38e73edc3d620b97eac8bf8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 8 14:42:22 2009 +0100

    [animation] Keep a reference during notify::alpha
    
    The Animation should be referenced during the notification of the
    alpha value, since the callback is invoked depending on the Alpha
    and it won't vivify the Animation instance for us.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1537

 clutter/clutter-animation.c |    9 ++++++++-
 1 files changed, 8 insertions(+), 1 deletions(-)

commit 41e85f3073ab88cb5bfaeda479ed5ffa7db93264
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jun 6 15:27:37 2009 +0100

    introspection-friendly ClutterEvent accessors
    
    ClutterEvent is not really gobject-introspection friendly because
    of the whole discriminated union thing. In particular, if you get
    a ClutterEvent in a signal handler, you probably can't access the
    event-type-specific fields, and you probably can't call methods
    like clutter_key_event_symbol() either, because you can't cast the
    ClutterEvent to a ClutterKeyEvent.
    
    The cleanest solution is to turn every accessor into ClutterEvent
    methods, accepting a ClutterEvent* and internally checking the event
    type.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1585

 clutter/clutter-deprecated.h               |    5 +
 clutter/clutter-event.c                    |  214 ++++++++++++++++++++-------
 clutter/clutter-event.h                    |   64 +++++----
 clutter/clutter-text.c                     |   11 +-
 doc/reference/clutter/clutter-sections.txt |   16 ++-
 tests/interactive/test-actor-clone.c       |    8 +-
 tests/interactive/test-actors.c            |    8 +-
 tests/interactive/test-layout.c            |    8 +-
 tests/interactive/test-paint-wrapper.c     |    6 +-
 tests/interactive/test-pixmap.c            |    8 +-
 tests/interactive/test-threads.c           |   18 ++-
 11 files changed, 245 insertions(+), 121 deletions(-)

commit 04dc4106e5451da823d1141013d1653e4b909f19
Author: Garry Bodsworth <gjb@camvine.com>
Date:   Mon Jun 8 08:46:33 2009 +0100

    [glx-texture-pixmap] Unref a cogl texture handle.
    
    According to clutter_texture_set_cogl_texture you should unref the handle as
    the texture takes its own.
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/glx/clutter-glx-texture-pixmap.c |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit c968b06f15f994827f9dd77e7e9efb6e8e06db6b
Author: Garry Bodsworth <gjb@camvine.com>
Date:   Mon Jun 8 08:38:50 2009 +0100

    Fix memory leak in ClutterGLXTexturePixmap.
    
    The OpenGL spec states that if you create a pixmap using glXCreatePixmap you
    should use glXDestroyPixmap to destroy it.
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/glx/clutter-glx-texture-pixmap.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit 1e6e41190b47c384d70216a09204f39808a3fd84
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 12:07:42 2009 -0400

    Straighten out 'realize' handling for ClutterGLXTexturePixmap
    
    Setting the pixmap for an unrealized ClutterGLXTexturePixmap should
    not cause it to be realized, and certainly shouldn't cause the the
    REALIZED flag to be set without using clutter_actor_realize().
    
    This patch uses the simple approach that;
    
     - pixmap changes on an unrealized ClutterGLXTexturePixmap
       are ignored
     - when the ClutterGLXTexturePixmap is realized, we then create
       the GLXPixmap and the corresponding texture.
    
    The call to clutter_glx_texture_pixmap_update_area() is moved
    from create_cogl_texture() to
    clutter_glx_texture_pixmap_create_glx_pixmap() since
    create_cogl_texture() is only called from one place, and updating
    the area is really something we do *after* creating the texture,
    not part of creating the texture.
    
    clutter_glx_texture_pixmap_create_glx_pixmap() is reorganized a
    bit to avoid debug-logging confusingly if it's called before a pixmap
    has been set, and for readability.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1635
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/glx/clutter-glx-texture-pixmap.c |   80 ++++++++++++------------------
 1 files changed, 31 insertions(+), 49 deletions(-)

commit d28c9e5db1c7dd7faab2fc9e718d70747d21dfb1
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 09:55:00 2009 -0400

    Remove unnecessary setting of CLUTTER_ACTOR_REALIZED flag
    
    An implementaton of realize() never needs to set the
    CLUTTER_ACTOR_REALIZED flag, though it can unset the flag if
    things fail unexpectedly. (Previously, stage backend implementations
    had to do this since clutter_actor_realize() wasn't used; this
    is no longer the case.)
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1634
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-stage.c                  |    5 +----
 clutter/eglnative/clutter-stage-egl.c    |    3 +--
 clutter/eglx/clutter-stage-egl.c         |    2 --
 clutter/fruity/clutter-stage-fruity.c    |    3 +--
 clutter/glx/clutter-stage-glx.c          |    6 ++----
 clutter/osx/clutter-stage-osx.c          |    8 +-------
 clutter/sdl/clutter-stage-sdl.c          |    2 --
 clutter/win32/clutter-stage-win32.c      |    3 +--
 clutter/x11/clutter-x11-texture-pixmap.c |    2 --
 9 files changed, 7 insertions(+), 27 deletions(-)

commit 2b7e98f4b3d48269dbfb2232af80cde92bcae306
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 11:37:18 2009 -0400

    Be more tolerant about natural_width < min_width
    
    Due to the accumulation of floating point errors, natural_width
    and min_width can diverge significantly even if the math for
    computing them is correct. So just clamp natural_width to
    min_width instead of warning about it.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1632
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-actor.c |   28 ++++++++++------------------
 1 files changed, 10 insertions(+), 18 deletions(-)

commit 583a86b537cd3b0d41c23949600c06515f5056bf
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 11:28:02 2009 -0400

    Use double temporaries when computing group size
    
    If we use float temporaries when computing the bounds of
    a group, then, depending on what variables are kept in registers
    and what stored on the stack, the accumulated difference between
    natural_width and min_width can be more than FLOAT_EPSILON.
    
    Using double temporaries will eliminate the difference in most
    cases, or, very rarely, reduce it to a last-bit error.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1632
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-group.c |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

commit 009eafb9ee1ea3b6e969b95f219e3f607c10f7e9
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Jun 6 11:56:08 2009 -0400

    Handle a clone of an actor with an unmapped parent
    
    If we are cloning an source actor with an unmapped parent, then when
    we temporarily map the source actor:
    
     - We need to skip the check that a mapped actor has a mapped
       parent.
     - We need to realize the actor's parents before mapping it,
       or we'll get an assertion failure in clutter_actor_update_map_state()
       because an actor with an unmapped parent is !may_be_realized.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1633
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-actor.c |   26 ++++++++++++++++++--------
 1 files changed, 18 insertions(+), 8 deletions(-)

commit d8459b0a32c95e0e6d59cc314d5d032c9f9c4edb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 8 10:59:22 2009 +0100

    [tests] Clarify the numbers

 tests/conform/test-timeline.c |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

commit 2ebe36cf0834ba6eca511a349aca95aa3777f87b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 8 10:58:20 2009 +0100

    [tests] The ::focus-in signal was renamed ::key-focus-in
    
    The test-events interactive test is still using the old name.

 tests/interactive/test-events.c |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

commit 54b5d076820cce3f69a699b34ca810204651bcc0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 8 02:22:26 2009 +0100

    [build] Add AS_COMPILER_FLAGS
    
    Use the AS_COMPILER_FLAGS to check whether the maintainer compiler flags
    we use are supported; this should fail gracefully and only use the ones
    that the compiler actually understands.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1639

 build/autotools/as-compiler-flag.m4 |   62 +++++++++++++++++++++++++++++++++++
 configure.ac                        |    5 ++-
 2 files changed, 66 insertions(+), 1 deletions(-)

commit 12b4e0400cfa85ab2c7d1544174747226d6b031a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 8 02:04:27 2009 +0100

    [x11] Do not forcibly set the stage size on fullscreen
    
    Setting the stage size using clutter_actor_set_size() is almost always
    wrong: the X11 stage implementation should save the size and queue a
    relayout -- like it does when receiving a ConfigureNotify. The same
    should happen when setting it to be full screen.

 clutter/x11/clutter-stage-x11.c |   34 +++++++++++++++++++++++-----------
 1 files changed, 23 insertions(+), 11 deletions(-)

commit ca305d2a403a1e1f40cf9a606b590853863964f9
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Mon Jun 8 01:51:02 2009 +0100

    [build] Search for Cogl GIR in the right place
    
    Since we build the Cogl GIR inside /clutter/cogl we should be looking
    there when building the Clutter GIR. Otherwise g-ir-scanner will look
    inside the gir directory -- and if you never built Clutter before it
    will error out.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1638
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/Makefile.am |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit a87f6f32a6ce41623e893cc054591e9fe67d199f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat Jun 6 21:33:31 2009 +0100

    [test-blend-strings] Fix a silly off by one that meant the test couldn't fail
    
    The test was quiting after the 2nd frame but it should be the third frame because
    the test doesn't actually check results until the third frame due to the workaround
    for drivers with broken glReadPixels.
    
    (When first written the test would have been verified with the
    clutter_main_quit() commented out which gives visual feedback of what the
    test does, so the off by one would have snuck in just before uncommenting
    and pushing.)

 tests/conform/test-blend-strings.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 9691827b5b03886d6eb88e1aed5844514d59366f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jun 6 15:57:29 2009 +0100

    [texture] Fix error reporting on ::load-finished
    
    The load-finished signal has a GError* argument which is meant to
    signify whether the loading was successful. However many of the
    places in ClutterTexture that emit this signal directly pass their
    'error' variable which is a GError** and will be NULL or not
    completely independently of whether there was an error. If the
    argument was dereferenced it would probably crash.
    
    The test-texture-async interactive test case should also verify
    that the ::load-finished signal is correctly emitted.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1622

 clutter/clutter-texture.c              |   31 +++++++++-------
 tests/interactive/test-texture-async.c |   60 ++++++++++++++++++++++++++++---
 2 files changed, 72 insertions(+), 19 deletions(-)

commit ea9bd6761ad840c12c063a14d9334dd807473a9d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jun 6 14:39:21 2009 +0100

    [units] Always recompute pixels
    
    When asking for the pixels value we should always recompute it.
    
    The "pixel_set" guard can be left in place for future use.

 clutter/clutter-units.c |    3 ---
 1 files changed, 0 insertions(+), 3 deletions(-)

commit 7e5f7eb7902e9424bb223896ca0219e3032c416c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jun 6 14:38:10 2009 +0100

    [build] Remove -Werror for the maintainer cflags
    
    Now that we have Shave in place and don't risk losing warnings
    we can avoid -Werror in the anal-retentive maintainer compiler
    flags.

 configure.ac |    5 ++---
 1 files changed, 2 insertions(+), 3 deletions(-)

commit c3dc03997cf4a2b82f45c90ad855785f8ac86853
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jun 6 14:37:41 2009 +0100

    Fixes for some compiler warnings

 clutter/clutter-actor.c   |    2 ++
 clutter/clutter-texture.c |    1 +
 clutter/clutter-units.c   |    8 ++++++--
 3 files changed, 9 insertions(+), 2 deletions(-)

commit 5f0afa52187750c08be279a5ff840ef8b9a4f642
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri Jun 5 17:53:57 2009 -0400

    [actor] get_transformed_position(): initialize Z value
    
    Initialize the Z value in the point we pass to
    clutter_actor_apply_transform_to_point().
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1630
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-actor.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 276952d6f9c20e4a2be5fbf2ab381c263598f864
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri Jun 5 16:52:18 2009 -0400

    Fix stopping a timeline
    
    Correctly apply De Morgan's laws to the short-circuit test in
    clutter_timeline_pause(); it was short-circuiting always and
    never actually pausing.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1629
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-timeline.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit f87e10c02409b8c5fbdb4cf5b289109fbcc67e45
Author: Johan Bilien <jobi@via.ecp.fr>
Date:   Wed Jun 3 22:08:17 2009 +0100

    Fix the leak of the GList of layers in CoglMaterial
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1624
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/cogl/common/cogl-material.c |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 6f7afdf5536408885acb8f31a7dcf1bf0ab93114
Author: Bastian Winkler <buz@netbuz.org>
Date:   Wed Jun 3 14:36:18 2009 +0200

    Broken fixed:: arguments
    
    The commit 2c95b378 prevents clutter_animation_setup_property from being
    called with fixed:: property names. This patch adds a additional
    parameter "is_fixed" to clutter_animation_setup_property instead of
    searching for "fixed::" in property_name.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-animation.c |   29 ++++++++++++++++-------------
 1 files changed, 16 insertions(+), 13 deletions(-)

commit ca5473836bb41687640a7f2fcf538bfa3733f122
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Jun 6 12:34:00 2009 +0100

    [build] Check for libXext
    
    It seems GNU Gold (the new linker) either behaves as if with
    --no-undefined by default, or has some issue preventing it from not
    doing that when instructed to (I'm not sure if this actually
    happens). In any case, clutter uses the Xshm extensions, but does not
    link to libXext, which makes gold unhappy.
    
    Based on a patch by: Xan Lopez <xan@gnome.org>
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 configure.ac |   15 +++++++++++++++
 1 files changed, 15 insertions(+), 0 deletions(-)

commit ea15e4c7f0476e1610e79a990616a467615358db
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jun 5 18:00:22 2009 +0100

    [CoglPangoDisplayList] Don't store the base color in the display list
    
    It should be possible render a single PangoLayout with different
    colors without recalculating the layout. This was not working because
    the color used at the first edit was being stored in the display
    list. This broke changing the opacity on a ClutterText.
    
    Now each node in the display list has a 'color override' flag which
    marks whether it should use the base color or not. The base color is
    now passed in from _cogl_pango_display_list_render_texture. The alpha
    value is always taken from the base color.

 clutter/pango/cogl-pango-display-list.c |   44 ++++++++++++++++++++++++++-----
 clutter/pango/cogl-pango-display-list.h |    6 +++-
 clutter/pango/cogl-pango-render.c       |   26 ++++++++----------
 3 files changed, 53 insertions(+), 23 deletions(-)

commit 6fe22ac8505da2c9a0b7eb97c3a6ea5f3edea95c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 17:55:24 2009 +0100

    [repaint] Run the repaint functions in clutter_redraw()
    
    The clutter_redraw() function is used by libraries embedding
    Clutter inside another toolkit, instead of queueing a redraw
    on the embedded stage. This means that clutter_redraw() should
    perform the same sequence of actions done by the redraw idle
    callback.

 clutter/clutter-main.c    |   34 +++++++++++++++++++++++++++-------
 clutter/clutter-private.h |    3 +++
 clutter/clutter-stage.c   |    4 ++--
 3 files changed, 32 insertions(+), 9 deletions(-)

commit f66021825c191a7185e488086b4ef06e84f16061
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 17:54:21 2009 +0100

    [docs] Update README
    
    * Remove mentions of Subversion
    
    * Update the configure command line switches

 README |   31 +++++++++++++++++++------------
 1 files changed, 19 insertions(+), 12 deletions(-)

commit 01e1aae7dd7c65ef8f60d66f95cb335d609fdff4
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat Apr 4 19:21:22 2009 +0100

    [cogl] cogl_material_set_layer does nothing if resetting the same texture
    
    This avoids dirtying the layer, and should avoid some uneeded state changes

 clutter/cogl/common/cogl-material.c |    3 +++
 1 files changed, 3 insertions(+), 0 deletions(-)

commit dea7f9b7d3fe36d398ade3f8e45ec4e31652dc48
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri May 22 16:59:14 2009 +0100

    [test-conformance] we were calling clutter_init with un-initialized arguments
    
    This ensure we initialize shared_state->arg{c,v}_addr before calling
    clutter_init

 tests/conform/test-conform-main.c |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

commit 6b92296e7f933a6d9798ba807fbd80ee2221144d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 16:46:12 2009 +0100

    [build] Fix compiler warnings
    
    Silence GCC

 clutter/cogl/common/cogl-blend-string.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit 02fa34f65b3efefaca4146e968c0f84a20061da1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 15:18:43 2009 +0100

    Fix a compiler warning

 clutter/cogl/common/cogl-vertex-buffer.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit b061a00f4cde1bdf1406bbf94b87fb88e996987a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jun 5 16:25:39 2009 +0100

    [ClutterActor] Fix check for zero opacity when being painted from a clone
    
    Clutter short-circuits painting when an actor's opacity is
    zero. However if the actor is being painted from a ClutterClone then
    it will be painted using the clone's opacity instead so the test was
    broken.

 clutter/clutter-actor.c |    4 +++-
 1 files changed, 3 insertions(+), 1 deletions(-)

commit 03471daf50dae5baf906ba95ba200d77e40bb3fb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 12:46:37 2009 +0100

    [build] Add all dependencies for pkg-config
    
    A merge conflict gone bad: the IMAGE_PC_FILES variable was not appended
    to the CLUTTER_REQUIRES one, thus leading to Clutter depending on
    GdkPixbuf but never actually checking for it.

 configure.ac |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

commit 7e33fe3175d17ff659705c24ac7865510b145528
Merge: b5a7b3a cbb748f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 12:41:42 2009 +0100

    Merge branch '1.0-integration'
    
    * 1.0-integration: (138 commits)
      [x11] Disable XInput by default
      [xinput] Invert the XI extension version check
      [cogl-primitives] Fix an unused variable warning when building GLES
      [clutter-stage-egl] Pass -1,-1 to clutter_stage_x11_fix_window_size
      Update the GLES backend to have the layer filters in the material
      [gles/cogl-shader] Add a missing semicolon
      [cogl] Move the texture filters to be a property of the material layer
      [text] Fix Pango unit to pixels conversion
      [actor] Force unrealization on destroy only for non-toplevels
      [x11] Rework map/unmap and resizing
      [xinput] Check for the XInput entry points
      [units] Validate units against the ParamSpec
      [actor] Add the ::allocation-changed signal
      [actor] Use flags to control allocations
      [units] Rework Units into logical distance value
      Remove a stray g_value_get_int()
      Remove usage of Units and macros
      [cogl-material] Allow setting a layer with an invalid texture handle
      [timeline] Remove the concept of frames from timelines
      [gles/cogl-shader] Fix parameter spec for cogl_shader_get_info_log
      ...
    
    Conflicts:
    	configure.ac

commit cbb748f7c042e250b9383c59236645966c5ad47e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 12:26:29 2009 +0100

    [x11] Disable XInput by default
    
    The XInput support in Clutter is still using XI 1.x. This will never
    work correctly, and we are all waiting for XInput 2 anyway. The changes
    internally should be minimal, so we can leave everything in place, but
    it's better to disable XInput support by default -- at least for the
    time being.

 clutter/x11/clutter-backend-x11.c |   20 ++++++++++++--------
 clutter/x11/clutter-event-x11.c   |    6 ++----
 configure.ac                      |    2 +-
 3 files changed, 15 insertions(+), 13 deletions(-)

commit 3ee093e356de19253f4a838553c8f31579a256ad
Merge: 745ca8a 9c7afe0
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jun 5 12:20:41 2009 +0100

    Merge branch 'timeline-no-fps' into 1.0-integration

commit 745ca8a62ca52eedfad850e556f160f36eb32953
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jun 5 12:06:09 2009 +0100

    [xinput] Invert the XI extension version check
    
    Since having XQueryInputVersion means also having XGetExtensionVersion
    we need to check the former first to avoid the deprecation warning.

 clutter/x11/clutter-backend-x11.c |    6 +++---
 1 files changed, 3 insertions(+), 3 deletions(-)

commit fa3ed19db56db26cadd37ea73539f1bd59254ef4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 22:20:18 2009 +0100

    [cogl-primitives] Fix an unused variable warning when building GLES
    
    The 'tex' variable is only used if #ifdef'd GL code so it was throwing
    an error under GLES. The variable is now moved into a block inside the
    #ifdef.

 clutter/cogl/common/cogl-primitives.c |   14 ++++++++------
 1 files changed, 8 insertions(+), 6 deletions(-)

commit 810e936164028043682b014a8e9b531fb373f317
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 22:15:41 2009 +0100

    [clutter-stage-egl] Pass -1,-1 to clutter_stage_x11_fix_window_size
    
    This reflects the changes made to e4ff24bc for the egl stage.

 clutter/eglx/clutter-stage-egl.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 6efbb92c5899dfadac4f366bee709f5154180967
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 22:12:33 2009 +0100

    Update the GLES backend to have the layer filters in the material
    
    This reflects the changes made in 54d8aadf1d86 for the GLES backend.

 clutter/cogl/gles/cogl-texture-private.h |   31 +++++-
 clutter/cogl/gles/cogl-texture.c         |  182 ++++++++++++++++++-----------
 2 files changed, 142 insertions(+), 71 deletions(-)

commit eff82a546d2ae6747ae32f639f07a6d182114016
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 22:10:33 2009 +0100

    [gles/cogl-shader] Add a missing semicolon
    
    cogl_shader_get_info_log was missing a semicolon which broke the build
    on GLES 2.

 clutter/cogl/gles/cogl-shader.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 54d8aadf1d86bf6cfacc5346c02a13f3a2577268
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 16:04:57 2009 +0100

    [cogl] Move the texture filters to be a property of the material layer
    
    The texture filters are now a property of the material layer rather
    than the texture object. Whenever a texture is painted with a material
    it sets the filters on all of the GL textures in the Cogl texture. The
    filter is cached so that it won't be changed unnecessarily.
    
    The automatic mipmap generation has changed so that the mipmaps are
    only generated when the texture is painted instead of every time the
    data changes. Changing the texture sets a flag to mark that the
    mipmaps are dirty. This works better if the FBO extension is available
    because we can use glGenerateMipmap. If the extension is not available
    it will temporarily enable automatic mipmap generation and reupload
    the first pixel of each slice. This requires tracking the data for the
    first pixel.
    
    The COGL_TEXTURE_AUTO_MIPMAP flag has been replaced with
    COGL_TEXTURE_NO_AUTO_MIPMAP so that it will default to
    auto-mipmapping. The mipmap generation is now effectively free if you
    are not using a mipmap filter mode so you would only want to disable
    it if you had some special reason to generate your own mipmaps.
    
    ClutterTexture no longer has to store its own copy of the filter
    mode. Instead it stores it in the material and the property is
    directly set and read from that. This fixes problems with the filters
    getting out of sync when a cogl handle is set on the texture
    directly. It also avoids the mess of having to rerealize the texture
    if the filter quality changes to HIGH because Cogl will take of
    generating the mipmaps if needed.

 clutter/clutter-texture.c                   |  132 +++++++-------------
 clutter/cogl/cogl-material.h                |   80 ++++++++++++
 clutter/cogl/cogl-texture.h                 |   80 ------------
 clutter/cogl/cogl-types.h                   |   13 ++-
 clutter/cogl/common/cogl-material-private.h |    3 +
 clutter/cogl/common/cogl-material.c         |   59 +++++++++
 clutter/cogl/common/cogl-primitives.c       |    3 +-
 clutter/cogl/gl/cogl-context.h              |    1 +
 clutter/cogl/gl/cogl-defines.h.in           |    4 +
 clutter/cogl/gl/cogl-texture-private.h      |   31 +++++-
 clutter/cogl/gl/cogl-texture.c              |  179 +++++++++++++++++---------
 clutter/cogl/gl/cogl.c                      |    7 +-
 clutter/glx/clutter-glx-texture-pixmap.c    |   20 ++--
 clutter/pango/cogl-pango-glyph-cache.c      |   22 +---
 clutter/pango/cogl-pango-glyph-cache.h      |    2 +-
 clutter/pango/cogl-pango-render.c           |   40 +++---
 doc/reference/cogl/cogl-sections.txt        |    7 +-
 tests/conform/test-backface-culling.c       |   22 ++--
 tests/interactive/test-cogl-multitexture.c  |    9 +-
 tests/interactive/test-cogl-tex-polygon.c   |   21 ++--
 tests/interactive/test-cogl-tex-tile.c      |    4 -
 21 files changed, 422 insertions(+), 317 deletions(-)

commit c27f42981961eed79ef32e4b4fd7081098619844
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 4 17:28:35 2009 +0100

    [text] Fix Pango unit to pixels conversion
    
    When going from Pango units to pixels we need to divide by 1024,
    and not multiply by 1024.

 clutter/clutter-text.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 5ea3b47144720dfa1692cc085537300e4d24d97c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 4 16:50:19 2009 +0100

    [actor] Force unrealization on destroy only for non-toplevels
    
    We cannot force unrealization on toplevels ourselves, so we need
    to check inside clutter_actor_destroy() if we want to avoid a
    warning.

 clutter/clutter-actor.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

commit e4ff24bcff4881ddadaf3bb52d74ee71061504fc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 4 16:27:21 2009 +0100

    [x11] Rework map/unmap and resizing
    
    The mapping and unmapping of the X11 stage implementation is
    a bit bong. It's asynchronous, for starters, when it really
    can avoid it by tracking the state internally.
    
    The ordering of the map/unmap sequence is also broken with
    respect to the resizing.
    
    By tracking the state internally into StageX11 we can safely
    remove the MapNotify and UnmapNotify X event handling.
    
    In theory, we should use _NET_WM_STATE a lot more, and reuse
    the X11 state flags for fullscreening as well.

 clutter/clutter-actor.c         |    5 +-
 clutter/clutter-stage-window.h  |    4 +
 clutter/clutter-stage.c         |   13 ++-
 clutter/glx/clutter-stage-glx.c |    2 +-
 clutter/x11/clutter-event-x11.c |    9 +-
 clutter/x11/clutter-stage-x11.c |  195 +++++++++++++++++++++++++--------------
 clutter/x11/clutter-stage-x11.h |   11 ++-
 7 files changed, 155 insertions(+), 84 deletions(-)

commit 0a4a28a950ae5022684742d18144c1cb9b6a96d1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 4 13:41:32 2009 +0100

    [xinput] Check for the XInput entry points
    
    Apparently, the XInput extension is using the same pkg-config
    file ('xi') for both the 1.x and the 2.x API, so we need to
    check for both the 1.x XGetExtensionVersion and the 2.x
    XQueryInputVersion.

 clutter/x11/clutter-backend-x11.c |   36 ++++++++++++++++++++++++++----------
 clutter/x11/clutter-backend-x11.h |   12 ++----------
 clutter/x11/clutter-event-x11.c   |    8 ++++----
 clutter/x11/clutter-stage-x11.h   |    6 ++----
 configure.ac                      |   33 ++++++++++++++++++++++++++++++++-
 5 files changed, 66 insertions(+), 29 deletions(-)

commit 876dc22633a62c3eb451d9f491d97cddadf6d3c0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 4 12:15:15 2009 +0100

    [units] Validate units against the ParamSpec
    
    When declaring a property using ClutterParamSpecUnits we pass a
    default type to limit the type of units we accept as valid values
    for the property.
    
    This means that we need to add the unit type check as part of the
    validation process.

 clutter/clutter-units.c |   38 ++++++++++++++++++++++++++++++++++++++
 1 files changed, 38 insertions(+), 0 deletions(-)

commit 5ebb59e6b0a11c156e1f246a852986f15080f297
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jun 4 12:00:58 2009 +0100

    [actor] Add the ::allocation-changed signal
    
    Sometimes it is useful to be able to track changes in the allocation
    flags, like the absolute origin, inside children of a container.
    
    Using the notify::allocation signal is not enough, in these cases, so
    we need a specific signal that gives us both the allocation box and the
    allocation flags.

 clutter/clutter-actor.c      |   43 +++++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-marshal.list |    1 +
 2 files changed, 43 insertions(+), 1 deletions(-)

commit 0187bb396524435fe32696176bcb234f36be326f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 3 14:02:06 2009 +0100

    [actor] Use flags to control allocations
    
    Instead of passing a boolean value, the ::allocate virtual function
    should use a bitmask and flags. This gives us room for expansion
    without breaking API/ABI, and allows to encode more information to
    the allocation process instead of just changes of absolute origin.

 clutter/clutter-actor.c             |   64 +++++++++++++++++-----------------
 clutter/clutter-actor.h             |   46 +++++++++++++++++--------
 clutter/clutter-clone.c             |   13 +++----
 clutter/clutter-group.c             |   17 ++++-----
 clutter/clutter-main.c              |    2 +-
 clutter/clutter-stage.c             |   21 +++++++----
 clutter/clutter-text.c              |    8 ++--
 clutter/clutter-texture.c           |   13 ++++---
 clutter/osx/clutter-stage-osx.c     |    8 ++--
 clutter/sdl/clutter-stage-sdl.c     |    8 ++--
 clutter/win32/clutter-stage-win32.c |   16 ++++----
 clutter/x11/clutter-stage-x11.c     |    8 ++--
 tests/interactive/test-layout.c     |   13 +++----
 13 files changed, 128 insertions(+), 109 deletions(-)

commit 0d5e17ecd12c680e52144e9f3493616cf96cbd05
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 3 11:12:09 2009 +0100

    [units] Rework Units into logical distance value
    
    Units as they have been implemented since Clutter 0.4 have always been
    misdefined as "logical distance unit", while they were just pixels with
    fractionary bits.
    
    Units should be reworked to be opaque structures to hold a value and
    its unit type, that can be then converted into pixels when Clutter needs
    to paint or compute size requisitions and perform allocations.
    
    The previous API should be completely removed to avoid collisions, and
    a new type:
    
            ClutterUnits
    
    should be added; the ability to install GObject properties using
    ClutterUnits should be maintained.

 .gitignore                                 |    2 +
 clutter/clutter-actor.c                    |  111 ++---
 clutter/clutter-units.c                    |  763 ++++++++++++++++++----------
 clutter/clutter-units.h                    |  271 +++-------
 doc/reference/clutter/clutter-sections.txt |   50 +--
 tests/conform/Makefile.am                  |    1 +
 tests/conform/test-clutter-units.c         |   58 +++
 tests/conform/test-conform-main.c          |    3 +
 tests/interactive/test-text-field.c        |   22 +-
 9 files changed, 701 insertions(+), 580 deletions(-)

commit 1580ffb884fa1864e9bd53934ae2d1258c3b7dbe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 3 10:09:56 2009 +0100

    Remove a stray g_value_get_int()
    
    Now that all properties are float, using g_value_get_int() to
    retrieve the value of the :anchor-x property is going to print
    out a warning.

 clutter/clutter-actor.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 046e571bae28790cb4d3e59d83e838a553fe15f0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jun 2 18:44:30 2009 +0100

    Remove usage of Units and macros
    
    The ClutterUnit and relative macros should not be used when dealing
    with pixels -- which is to say, all the time when inside Clutter.

 clutter/clutter-backend.c             |    4 +-
 clutter/clutter-interval.c            |   15 +-----
 clutter/clutter-text.c                |   90 +++++++++++++++-----------------
 clutter/x11/clutter-stage-x11.c       |   31 +++++------
 tests/conform/test-anchors.c          |   54 +++++++++----------
 tests/conform/test-binding-pool.c     |   16 ++----
 tests/interactive/test-animation.c    |    5 +-
 tests/interactive/test-binding-pool.c |   16 ++----
 tests/interactive/test-layout.c       |   68 ++++++++++++------------
 tests/interactive/test-project.c      |   18 ++----
 tests/interactive/test-text-field.c   |    8 +--
 11 files changed, 142 insertions(+), 183 deletions(-)

commit 26f07abc6566e88828a9d8ca9419b1de3bec7c46
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jun 3 15:22:42 2009 +0100

    [cogl-material] Allow setting a layer with an invalid texture handle
    
    It was previously possible to create a material layer with no texture
    by setting some property on it such as the matrix. However it was not
    possible to get back to that state without removing the layer and
    recreating it. It is useful to be able to remove the texture to free
    resources without forgetting the state of the layer so we can put a
    different texture in later.

 clutter/cogl/common/cogl-material.c |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

commit 9c7afe0c5bf99e38c6fd4584b8fa3b0ed02cf996
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 13:05:12 2009 +0100

    [timeline] Remove the concept of frames from timelines
    
    Timelines no longer work in terms of a frame rate and a number of
    frames but instead just have a duration in milliseconds. This better
    matches the working of the master clock where if any timelines are
    running it will redraw as fast as possible rather than limiting to the
    lowest rated timeline.
    
    Most applications will just create animations and expect them to
    finish in a certain amount of time without caring about how many
    frames are drawn. If a frame is going to be drawn it might as well
    update all of the animations to some fraction of the total animation
    rather than rounding to the nearest whole frame.
    
    The 'frame_num' parameter of the new-frame signal is now 'msecs' which
    is a number of milliseconds progressed along the
    timeline. Applications should use clutter_timeline_get_progress
    instead of the frame number.
    
    Markers can now only be attached at a time value. The position is
    stored in milliseconds rather than at a frame number.
    
    test-timeline-smoothness and test-timeline-dup-frames have been
    removed because they no longer make sense.

 clutter/clutter-alpha.c                     |  116 +++---
 clutter/clutter-timeline.c                  |  638 ++++++++-------------------
 clutter/clutter-timeline.h                  |   24 +-
 doc/reference/clutter/clutter-sections.txt  |    8 +-
 tests/conform/Makefile.am                   |    2 -
 tests/conform/test-conform-main.c           |    3 -
 tests/conform/test-timeline-dup-frames.c    |  134 ------
 tests/conform/test-timeline-interpolate.c   |   19 +-
 tests/conform/test-timeline-rewind.c        |   12 +-
 tests/conform/test-timeline-smoothness.c    |  147 ------
 tests/conform/test-timeline.c               |   48 ++-
 tests/interactive/test-actor-clone.c        |    7 +-
 tests/interactive/test-actors.c             |    9 +-
 tests/interactive/test-behave.c             |    2 +-
 tests/interactive/test-cogl-multitexture.c  |    8 +-
 tests/interactive/test-cogl-primitives.c    |    7 +-
 tests/interactive/test-cogl-tex-polygon.c   |    2 +-
 tests/interactive/test-cogl-tex-tile.c      |    2 +-
 tests/interactive/test-cogl-vertex-buffer.c |    5 +-
 tests/interactive/test-depth.c              |    2 +-
 tests/interactive/test-layout.c             |    2 +-
 tests/interactive/test-multistage.c         |    2 +-
 tests/interactive/test-paint-wrapper.c      |   13 +-
 tests/interactive/test-pixmap.c             |    2 +-
 tests/interactive/test-rotate.c             |    2 +-
 tests/interactive/test-scale.c              |    2 +-
 tests/interactive/test-score.c              |   10 +-
 tests/interactive/test-texture-async.c      |    2 +-
 tests/interactive/test-texture-quality.c    |    2 +-
 tests/interactive/test-threads.c            |    2 +-
 tests/interactive/test-viewport.c           |    2 +-
 31 files changed, 323 insertions(+), 913 deletions(-)

commit c20886c5e36fa92a8bfa79a5c24d73d4c558b9ae
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 12:04:47 2009 +0100

    [gles/cogl-shader] Fix parameter spec for cogl_shader_get_info_log
    
    The stub version of cogl_shader_get_info_log needed to be updated to
    match the changes to the function signature in 61deeafa.

 clutter/cogl/gles/cogl-shader.c |    7 +++----
 1 files changed, 3 insertions(+), 4 deletions(-)

commit fa0b33ec30a0e95e6dc0731abe698e16135b19db
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 11:59:17 2009 +0100

    [clutter-stage-win32] Call clutter_actor_map instead of setting the flags
    
    The clutter_actor_map and unmap functions need to be called to
    properly update the mapped state. This matches the changes to the X11
    stage in 125bded8.

 clutter/win32/clutter-stage-win32.c |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

commit af68945486ff20adb8d386af5dd0b76a50eca098
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 11:50:52 2009 +0100

    [clutter-event-win32] Fix the argument types to clutter_actor_get_size
    
    clutter_actor_get_size now takes float pointers so it was issuing a
    warning.

 clutter/win32/clutter-event-win32.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit f89ff7f3835edab93de1c67895b6a754abffc5eb
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 11:50:06 2009 +0100

    Load glBlendEquation and glBlendColor using cogl_get_proc_address
    
    These are defined since OpenGL 1.2 and since Windows doesn't export
    any functions defined after 1.1 we need to load them dynamically.

 clutter/cogl/common/cogl-material.c |    2 ++
 clutter/cogl/gl/cogl-context.h      |    2 ++
 clutter/cogl/gl/cogl-defines.h.in   |   11 +++++++++++
 clutter/cogl/gl/cogl.c              |    7 +++++++
 4 files changed, 22 insertions(+), 0 deletions(-)

commit daa95b561e1dda0c13624fdbde602c36dc786842
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 11:48:51 2009 +0100

    Rename 'near' and 'far' variables to 'z_near' and 'z_far'
    
    The Windows headers define near and far to be empty so it breaks the
    build.

 clutter/cogl/cogl-matrix.h                |   12 ++++++------
 clutter/cogl/common/cogl-current-matrix.c |   18 +++++++++---------
 2 files changed, 15 insertions(+), 15 deletions(-)

commit b5a7b3a004de7e0b237811dbf8c4feb025a09333
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jun 4 11:03:34 2009 +0100

    [configure] Require pango 1.20 instead of 1.18
    
    Clutter now calls pango_layout_set_height which is only available
    since Pango 1.20.

 README       |    2 +-
 configure.ac |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 6825b9db1c1eaeab151d4ca9cc4f5ec923cbcde0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 3 12:59:16 2009 +0100

    [actor] Unrealize on destroy
    
    If the application code calls for destruction of an actor we need
    to make sure that the actor is unrealized before running the dispose
    sequence; otherwise, we might trigger an assertion failure on composite
    actors.

 clutter/clutter-actor.c |    5 +++++
 1 files changed, 5 insertions(+), 0 deletions(-)

commit 181ba67114d8bd88c0b7091ad9033ebee6bff63c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 3 14:03:25 2009 +0100

    Revert commit 762873e7
    
    The commit 762873e79e501c949f3ef55cbac20276b6f6ed4e is completely
    and utterly wrong and I should have never pushed it.
    
    Serves me well for trying to work on three different branches and
    on three different things.

 clutter/clutter-master-clock.c |   21 +--------------------
 clutter/clutter-timeline.c     |   10 +++-------
 clutter/clutter-timeline.h     |    2 +-
 3 files changed, 5 insertions(+), 28 deletions(-)

commit 762873e79e501c949f3ef55cbac20276b6f6ed4e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jun 3 12:02:56 2009 +0100

    [master clock] Avoid excessive redraws
    
    Currently, the clock source spins a redraw every time there is at
    least a timeline running. If the timelines were not advanced in
    the previous frame, though, because their interval is larger than
    the vblanking interval then this will lead to excessive redraws of
    the scenegraph even if nothing has changed.
    
    To avoid this a simple guard should be set by the MasterClock::advance
    method in case no timeline was effectively advanced, and checked
    before dispatching the stage redraws.

 clutter/clutter-master-clock.c |   21 ++++++++++++++++++++-
 clutter/clutter-timeline.c     |   10 +++++++---
 clutter/clutter-timeline.h     |    2 +-
 3 files changed, 28 insertions(+), 5 deletions(-)

commit f4a431a947011aaa4101935691058a10cd80ff08
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jun 2 18:01:18 2009 +0100

    [cogl-texture] Don't take ownership of the data in cogl_texture_new_from_bitmap
    
    When creating a Cogl texture from a Cogl bitmap it would steal the
    data by setting the bitmap_owner flag and clearing the data pointer
    from the bitmap. The data would be freed by the time the
    new_from_bitmap is finished. There is no reason to do this because the
    data will be freed when the Cogl bitmap is unref'd and it is confusing
    not to be able to reuse the bitmap for creating multiple textures.

 clutter/cogl/gl/cogl-texture.c |    3 +--
 1 files changed, 1 insertions(+), 2 deletions(-)

commit b6f1322e07f0fd678a48f1128eae6cba8b8211d7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 1 18:43:47 2009 +0100

    [tests] Add ClutterColor conformance tests
    
    Add a conformance test unit for the to_string() and from_string()
    methods.

 .gitignore                        |    2 +
 tests/conform/Makefile.am         |    1 +
 tests/conform/test-color.c        |   71 +++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c |    3 ++
 4 files changed, 77 insertions(+), 0 deletions(-)

commit bd13a4ddc486586bc1051080cbe64c2d90ee853e
Author: Robert Staudinger <robsta@gnome.org>
Date:   Mon Jun 1 18:54:46 2009 +0200

    [color] Add support for the "#rgba" color format
    
    clutter_color_from_string() only supported the "#rrggbbaa" format with
    alpha channel, this patch adds support for "#rgba".
    
    Colors in "#rrggbb" format were parsed manually, this is now left to
    the pango color parsing fallback, since that's handling it just fine.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-color.c |   58 ++++++++++++++++++++++------------------------
 1 files changed, 28 insertions(+), 30 deletions(-)

commit ffd5fb172b390f7fbdeadce3dda181a67a1e7916
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 1 17:35:41 2009 +0100

    [docs] Rework the API reference version generation
    
    Clutter copies the gtk-doc from the usual gtk+ template, and
    has a version.xml.in containing only:
    
      @VERSION@
    
    Without a newline at the end. Unfortunately, it appears that
    autoconf has started adding a newline to the generated version.xml
    which then is used as the payload for the "version" XML entity.
    
    Instead of using a secondary file we can make configure generate
    the whole clutter-docs.xml and cogl-docs.xml files from a template;
    this way we also get the ability to substitute more autoconf variables
    into the documentation -- if needs be.

 .gitignore                                |    4 +-
 configure.ac                              |    4 +-
 doc/reference/clutter/Makefile.am         |    2 -
 doc/reference/clutter/clutter-docs.xml    |  245 -----------------------------
 doc/reference/clutter/clutter-docs.xml.in |  245 +++++++++++++++++++++++++++++
 doc/reference/clutter/version.xml.in      |    1 -
 doc/reference/cogl/Makefile.am            |    2 -
 doc/reference/cogl/cogl-docs.xml          |  107 -------------
 doc/reference/cogl/cogl-docs.xml.in       |  107 +++++++++++++
 doc/reference/cogl/version.xml.in         |    1 -
 10 files changed, 356 insertions(+), 362 deletions(-)

commit 61deeafa71a81384978bd199f0df6e88d0904a52
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 1 16:31:32 2009 +0100

    [cogl-shader] Make get_info_log() slightly nicer
    
    The cogl_shader_get_info_log() function is very inconvenient for
    language bindings and for regular use, as it requires a static
    buffer to be filled -- basically just providing a wrapper around
    glGetInfoLogARB().
    
    Since COGL aims to be a more convenient API than raw GL we should
    just make cogl_shader_get_info_log() return an allocated string
    with the GLSL compiler log.

 clutter/clutter-shader.c        |   12 +++++++++---
 clutter/cogl/cogl-shader.h      |   13 ++++++-------
 clutter/cogl/gl/cogl-shader.c   |   15 ++++++++-------
 clutter/cogl/gles/cogl-shader.c |   15 ++++++++-------
 4 files changed, 31 insertions(+), 24 deletions(-)

commit 5c26cc6ba7ab9b90bfe4aa2612a56c191c8b1204
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jun 1 17:10:22 2009 +0100

    Use GL_QUADS for flushing a quad batch
    
    Instead of using GL_TRIANGLES and uploading the indices every time, it
    now uses GL_QUADS instead on OpenGL. Under GLES it still uses indices
    but it uses the new cogl_vertex_buffer_indices_get_for_quads function
    to avoid uploading the vertices every time.
    
    This requires the _cogl_vertex_buffer_indices_pointer_from_handle
    function to be exposed privately to the rest of Cogl.
    
    The static_indices array has been removed from the Cogl context.

 clutter/cogl/common/cogl-primitives.c            |   79 +++++++---------------
 clutter/cogl/common/cogl-vertex-buffer-private.h |    4 +
 clutter/cogl/gl/cogl-context.c                   |    3 -
 clutter/cogl/gl/cogl-context.h                   |    1 -
 clutter/cogl/gles/cogl-context.c                 |    3 -
 clutter/cogl/gles/cogl-context.h                 |    1 -
 6 files changed, 29 insertions(+), 62 deletions(-)

commit 6cd1cb21cc0b629535994ad41e4fc78613fe0319
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 1 15:51:59 2009 +0100

    [introspection] Remove Cogl symbols from Clutter GIR
    
    The GIR file for Clutter still contains symbols from COGL, even
    though we provide a Cogl GIR as well. The Clutter GIR should
    depend on the Cogl GIR instead.

 clutter/Makefile.am |    8 +-------
 1 files changed, 1 insertions(+), 7 deletions(-)

commit 86230eb9fa134c3df50634e9196477c82d20a403
Author: Marc-André Lureau <marcandre.lureau@gmail.com>
Date:   Sat May 30 23:58:03 2009 +0300

    build: don't double install clutter-version.h
    
    Automake 1.11 installs several files in one command, and it fails if
    the same file is installed two times.
    
    See NEWS for details:
    http://lists.gnu.org/archive/html/automake/2009-05/msg00093.html
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/Makefile.am |    1 -
 1 files changed, 0 insertions(+), 1 deletions(-)

commit 097400747e112d01cbd4ecb72401abcca41158f9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jun 1 12:51:23 2009 +0100

    [git ignore] Add report XML output file

 .gitignore |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit c759aeb6a720043b8b74242d5e18da405be3825d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun May 31 15:15:46 2009 +0100

    Uniformly use floats in Actor properties
    
    All the underlying implementation and the public entry points have
    been switched to floats; the only missing bits are the Actor properties
    that deal with positioning and sizing.
    
    This usually means a major pain when dealing with GValues and varargs
    functions. While GValue will warn you when dealing with the wrong
    conversions, varags will simply die an horrible (and hard to debug)
    death via segfault. Nothing much to do here, except warn people in the
    release notes and hope for the best.

 clutter/clutter-actor.c                        |  353 ++++++++++++++----------
 clutter/clutter-interval.c                     |   12 +-
 tests/conform/Makefile.am                      |    3 +
 tests/conform/test-anchors.c                   |  145 ++++++-----
 tests/conform/test-binding-pool.c              |   18 +-
 tests/interactive/test-animation.c             |    8 +-
 tests/interactive/test-clutter-cairo-flowers.c |   23 +-
 tests/interactive/test-cogl-multitexture.c     |    2 +-
 tests/interactive/test-cogl-tex-polygon.c      |    2 +-
 tests/interactive/test-cogl-tex-tile.c         |    2 +-
 tests/interactive/test-easing.c                |    4 +-
 tests/interactive/test-layout.c                |   17 +-
 tests/interactive/test-multistage.c            |    2 +-
 tests/interactive/test-paint-wrapper.c         |    2 +-
 tests/interactive/test-rotate.c                |    2 +-
 tests/interactive/test-shader.c                |    3 +-
 16 files changed, 346 insertions(+), 252 deletions(-)

commit bafa448666a73dd06b69b6167138c3c43e854482
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun May 31 15:07:58 2009 +0100

    [texture] Increase verbosity of error messages
    
    The GError messages in set_from_rgb_data() and set_from_yuv_data()
    are a little bit too thin on details.

 clutter/clutter-texture.c |   15 ++++++++++++---
 1 files changed, 12 insertions(+), 3 deletions(-)

commit 8b71fa1acbb8580e61ce30fd6a48a4bf0024ba97
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun May 31 15:06:16 2009 +0100

    [docs] Remove misleading text
    
    The documentation for ClutterTexture's set_from_rgb_data() and
    set_from_yuv_data() says:
    
      Note: This function is likely to change in future versions.
    
    This is not true, since they'll remain for the whole 1.x API cycle.

 clutter/clutter-texture.c |   26 +++++++++++---------------
 1 files changed, 11 insertions(+), 15 deletions(-)

commit 3b70e0b6b7a3c01c9e9d0c15f39b676877eee119
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri May 29 11:52:21 2009 +0100

    [pango-display-list] Use the CoglAttributeType macros instead of GL_FLOAT
    
    Cogl now has an enum for the VBO attribute type so we should use that
    instead of the GL enums.

 clutter/pango/cogl-pango-display-list.c |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

commit 97921a7d137bde2b73cfb2dabea89c14e30510a9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri May 29 11:38:03 2009 +0100

    [pango-display-list] Use indexed vertices on GLES
    
    Now that CoglVertexBuffers support indices we can use them with GLES
    to avoid duplicating vertices. Regular GL still uses GL_QUADS because
    it is shown to still have a performance benefit over indices with the
    Intel drivers.

 clutter/pango/cogl-pango-display-list.c |   47 ++++++++++++++-----------------
 1 files changed, 21 insertions(+), 26 deletions(-)

commit 67544f38d4dc93bd1be477656171681c5acf9721
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 28 13:47:18 2009 +0100

    [cogl-vertex-buffer] Add cogl_vertex_buffer_indices_get_for_quads
    
    This function can be used as an efficient way of drawing groups of
    quads without using GL_QUADS. It generates a VBO containing the
    indices needed to render using pairs of GL_TRIANGLES. The VBO is
    globally cached so that it only needs to be uploaded whenever more
    indices are requested than ever before.

 clutter/cogl/cogl-vertex-buffer.h        |   40 +++++++++++++++
 clutter/cogl/common/cogl-vertex-buffer.c |   80 ++++++++++++++++++++++++++++++
 clutter/cogl/gl/cogl-context.c           |    9 +++
 clutter/cogl/gl/cogl-context.h           |    6 ++
 clutter/cogl/gles/cogl-context.c         |    9 +++
 clutter/cogl/gles/cogl-context.h         |    7 ++-
 doc/reference/cogl/cogl-sections.txt     |    1 +
 7 files changed, 151 insertions(+), 1 deletions(-)

commit 4afe1e9a8b7822522e990989ad156df49bfc29e3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 17:53:19 2009 +0100

    [actor] Add allocate_available_size()
    
    The allocate_available_size() method is a convenience method in
    the same spirit as allocate_preferred_size(). While the latter
    will allocate the preferred size of an actor regardless of the
    available size provided by the actor's parent -- and thus it's
    suitable for simple fixed layout managers like ClutterGroup -- the
    former will take into account the available size provided by the
    parent and never allocate more than that; it is, thus, suitable
    for simple fluid layout managers.

 clutter/clutter-actor.c                    |  112 ++++++++++++++++++++++++++++
 clutter/clutter-actor.h                    |    6 ++
 doc/reference/clutter/clutter-sections.txt |    1 +
 3 files changed, 119 insertions(+), 0 deletions(-)

commit 293eeed507460ef6a9168264b04f119acf567eb7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 17:50:58 2009 +0100

    [build] Remove cogl-enum-types.h on distclean
    
    The cogl-enum-types.h file is created by glib-mkenums under
    /clutter/cogl/common, and then copied in /clutter/cogl in order
    to make the inclusion of that file work inside cogl.h.
    
    Since we're copying it in a different location, the Makefile
    for that location has to clean up the copy.

 clutter/cogl/Makefile.am |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit 936f638a4234b0dd9f5122447bf09f8fcde1ac26
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 17:10:27 2009 +0100

    [build] Fix dist issues
    
    * cogl-deprecated.h is not being installed
    
    * cogl-enum-types.c.in is not part of the dist

 clutter/cogl/Makefile.am        |    1 +
 clutter/cogl/common/Makefile.am |    2 +-
 2 files changed, 2 insertions(+), 1 deletions(-)

commit faec5c468ba77e61a3f724be49f031be65ef2011
Author: Jonas Bonn <jonas@southpole.se>
Date:   Thu May 28 09:47:45 2009 +0200

    Freeze notifiers around property setters
    
    Notifications should be fired off from both the internal timeline and
    the wrapping animation here, so notifiers should be frozen around these
    property setters.
    
    Signed-off-by: Jonas Bonn <jonas@southpole.se>
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-animation.c |    8 ++++++++
 1 files changed, 8 insertions(+), 0 deletions(-)

commit 1187972e45b8c64ad25c2a243b0112bbde84e3e6
Author: Jonas Bonn <jonas@southpole.se>
Date:   Thu May 28 09:40:09 2009 +0200

    [animation] Final cleanups to new Animation model
    
    Just a couple of final cleanups after the reimplementation of the
    Animation model.
    
    i)  _set_mode does not need to set the timeline on the alpha
    ii) freeze notifications around the setting of a new alpha
    
    Signed-off-by: Jonas Bonn <jonas@southpole.se>
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-animation.c |   11 ++++++-----
 1 files changed, 6 insertions(+), 5 deletions(-)

commit c5e659d5922b406059c94545c1a5c773f61b2379
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 14:52:49 2009 +0100

    [master clock] Use StageManager::peek_stages()
    
    Use the new StageManager::peek_stages() method to avoid a copy
    of the stages list.

 clutter/clutter-master-clock.c |    7 ++-----
 1 files changed, 2 insertions(+), 5 deletions(-)

commit 5d4974ed365d9882945f211f1dadd067b4b2d8b1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 14:45:53 2009 +0100

    [stage manager] Add peek_stages()
    
    We need an method for StageManager that returns a const pointer
    to the internal list, to avoid the copy.

 clutter/clutter-stage-manager.c |   24 ++++++++++++++++++++++--
 clutter/clutter-stage-manager.h |    1 +
 2 files changed, 23 insertions(+), 2 deletions(-)

commit 63c7cc0175461a08e5b1d3f3b78e37d581a03ffd
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 14:25:19 2009 +0100

    [master clock] Handle Timeline::started signal correctly
    
    The "started" signal is sent first after the timeline has been set to the
    'running' state. For this reason, checking if the clock has any running
    timelines running will always return true in the "started" signal handler:
    the timeline that sent the signal is running.
    
    What needs to be checked in the signal handler is if there are any
    timelines running other than the one that emitted the ::started signal,
    which we know is running anyway.
    
    This prevents frames from being lost at the beginning of an animation when
    a timeline is started after a quiescent period.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1617
    
    Signed-off-by: Jonas Bonn <jonas@southpole.se>
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-master-clock.c |   67 +++++++++++++++++++++++++++++++++++----
 1 files changed, 60 insertions(+), 7 deletions(-)

commit cbbc1a9ca36972ee0bf0612605c5176ce9b63b7f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 14:27:55 2009 +0100

    [build] Copy cogl-enum-types.h under the guard
    
    We avoid rebuilding cogl-enum-types.h and cogl-enum-types.c by
    using a "guard" -- a stamp file that will block Makefile. Since
    we need cogl-enum-types.h into /clutter/cogl as well for the
    cogl.h include to work, if we copy the cogl-enum-types.h
    unconditionally it will cause a rebuild of the whole COGL; which
    will cause a full rebuild.
    
    To solve this, we can copy the header file when generating it
    under the stamp file.

 clutter/cogl/common/Makefile.am |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

commit cfb95084651b0ea199eecef5993d7fc2da3586fa
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri May 29 14:23:16 2009 +0100

    [configure] Always execute the AM_CONDITIONAL call for X11_TESTS
    
    Automake gets upset if an AM_CONDITIONAL call is itself conditionally
    executed.

 configure.ac |    4 +++-
 1 files changed, 3 insertions(+), 1 deletions(-)

commit e565c1f1dbfdb29fcaa7065d078f524c8432c12c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 12:50:48 2009 +0100

    [build] Encode the target into the backend library
    
    The libclutter-cogl internal object should be the only dependency
    for Clutter, since we are already copying it inside clutter/cogl
    for the introspection scanner. For this reason, the backend-specific,
    real internal object should be built with the backend encoded into
    the file name, like libclutter-common. This makes the build output
    a little bit more clear: instead of having two:
    
      LINK libclutter-cogl-common.la
      ...
      LINK libclutter-cogl.la
      LINK libclutter-cogl.la
    
    We'll have:
    
      LINK libclutter-cogl-common.la
      ...
      LINK libclutter-cogl-gl.la
      LINK libclutter-cogl.la
    
    Same applies for the GLES backend.

 clutter/cogl/Makefile.am      |    4 ++--
 clutter/cogl/gl/Makefile.am   |   10 +++++-----
 clutter/cogl/gles/Makefile.am |   12 ++++++------
 3 files changed, 13 insertions(+), 13 deletions(-)

commit b4861cbd21210b99294b93ea18bbfb4724a0aca6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 12:40:23 2009 +0100

    Use g_once when registering enumeration types
    
    Just like we do with GObject types and G_DEFINE_TYPE, we should
    use the g_once_init_enter/g_once_init_leave mechanism to make the
    GType registration of enumeration types thread safe.

 clutter/clutter-enum-types.c.in          |   20 +++++++++++++++-----
 clutter/cogl/common/cogl-enum-types.c.in |   18 +++++++++++++-----
 2 files changed, 28 insertions(+), 10 deletions(-)

commit 3248bb1b755ae23cfb1a2eabd7a72b803faa5a31
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 29 12:31:47 2009 +0100

    [cogl] Generate enumeration GTypes
    
    COGL is starting to have more enumerations than I can handle
    by hand. Let's use glib-mkenums and be done with it.

 .gitignore                               |    3 +
 clutter/cogl/Makefile.am                 |   40 +++++---
 clutter/cogl/cogl-shader.h               |    5 +-
 clutter/cogl/cogl-types.h                |   83 +++-------------
 clutter/cogl/cogl.h.in                   |   11 +-
 clutter/cogl/common/Makefile.am          |   53 ++++++++++-
 clutter/cogl/common/cogl-enum-types.c.in |   33 +++++++
 clutter/cogl/common/cogl-enum-types.h.in |   25 +++++
 clutter/cogl/common/cogl-util.c          |  154 ------------------------------
 clutter/cogl/gl/Makefile.am              |    5 -
 10 files changed, 161 insertions(+), 251 deletions(-)

commit 7b75f93db1ad29ef4c81c20ee8434876d54aa358
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 28 17:18:13 2009 +0100

    [docs] Fixes for the API reference
    
    * Add unused symbols
    
    * Document and sync argument names with their gtk-doc counterpart
    
    * Add missing descriptions

 clutter/clutter-actor.h                    |    4 +++
 clutter/clutter-animation.c                |    2 +-
 clutter/clutter-container.h                |    5 ++++
 clutter/clutter-main.h                     |    2 +-
 clutter/clutter-texture.c                  |    2 +-
 clutter/cogl/cogl-material.h               |    5 ++++
 clutter/cogl/cogl-shader.h                 |   14 +++++++++--
 clutter/cogl/cogl-vertex-buffer.h          |   33 +++++++++++++++++----------
 clutter/cogl/cogl.h.in                     |    4 +++
 doc/reference/clutter/clutter-sections.txt |    7 ++++-
 doc/reference/cogl/cogl-sections.txt       |    6 -----
 11 files changed, 58 insertions(+), 26 deletions(-)

commit e51fbebd67e04182438c7f24d5db7b0f678c3f56
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 28 17:18:10 2009 +0100

    [git ignore] Add blend strings test

 .gitignore |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 9557328e4ec61ed0c78c165135c8f4b216f26b7f
Merge: 7252c14 d960ce4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 28 15:53:56 2009 +0100

    Merge branch 'master' into 1.0-integration
    
    * master:
      [test-text-perf] Use queue_redraw instead of painting the stage directly
      [actor] In paint when opacity == 0, clear the queued_redraw flag

commit d960ce46e5fe087bccae2aa9a023fa1a80b76e79
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 28 15:27:09 2009 +0100

    [test-text-perf] Use queue_redraw instead of painting the stage directly
    
    If it doesn't queue a redraw and allow the backend to clear and swap
    the buffers then the results will be skewed because it is not
    predictable when the driver will actually render the scene.

 tests/micro-bench/test-text-perf.c |   16 +++++++++++-----
 1 files changed, 11 insertions(+), 5 deletions(-)

commit 7252c141970eaa7c17214e9890b917221be70fd0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 28 13:03:19 2009 +0100

    [cogl] Make cogl_setup_viewport() a private function
    
    The setup_viewport() function should only be used by Clutter and
    not by application code.
    
    It can be emulated by changing the Stage size and perspective and
    requeueing a redraw after calling clutter_stage_ensure_viewport().

 clutter/clutter-main.c     |   16 +++++++++-------
 clutter/clutter-texture.c  |   10 +++++-----
 clutter/cogl/cogl.h.in     |   10 ++++++----
 clutter/cogl/common/cogl.c |   16 ++++++++--------
 4 files changed, 28 insertions(+), 24 deletions(-)

commit 32018584c0eda5bd29d4f3a773e7d243a740cbc4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 28 12:52:00 2009 +0100

    [cogl deprecated] Add backface culling deprecation
    
    The backface culling enabling function was split and renamed, just
    like the depth testing one, so we need to add the macro to the
    cogl-deprecated.h header.

 clutter/cogl/cogl-deprecated.h |   13 ++++++-------
 1 files changed, 6 insertions(+), 7 deletions(-)

commit be826ed4e7b9e834da0055f4e5d253c22204b870
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu May 28 12:49:29 2009 +0100

    [cogl vertex buffers] Give indices a CoglHandle so they are shareable
    
    Previously indices were tightly bound to a particular Cogl vertex buffer
    but we would like to be able to share indices so now we have
    cogl_vertex_buffer_indices_new () which returns a CoglHandle.
    
    In particular we could like to have a shared set of indices for drawing
    lists of quads that can be shared between the pango renderer and the
    Cogl journal.

 clutter/cogl/cogl-vertex-buffer.h                |   34 +++-----
 clutter/cogl/common/cogl-vertex-buffer-private.h |    7 +-
 clutter/cogl/common/cogl-vertex-buffer.c         |   97 +++++----------------
 tests/interactive/test-cogl-vertex-buffer.c      |   16 ++--
 4 files changed, 46 insertions(+), 108 deletions(-)

commit f0849fc3e25185e86464cadcc98a7bcdac1b0ab8
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu May 28 02:03:16 2009 +0100

    [cogl journal] If we are only flushing one quad use a TRIANGLE_FAN
    
    At the moment Cogl doesn't do much batching of quads so most of the time we
    are flushing a single quad at a time.  This patch simplifies how we submit
    those quads to OpenGL by using glDrawArrays with GL_TRIANGLE_FAN mode
    instead of sending indexed vertices using GL_TRIANGLES mode.
    
    Note: I hope to follow up soon with changes that improve our batching and
    also move the indices into a VBO so they don't need to be re-validated every
    time we call glDrawElements.

 clutter/cogl/common/cogl-primitives.c |   80 +++++++++++++++++++--------------
 1 files changed, 46 insertions(+), 34 deletions(-)

commit 57cb20dc0685889b5eaa89d409a47d67d15450fb
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue May 26 18:25:00 2009 +0100

    [deprecated defines] Adds some missing cogl_texture_* deprecated defines
    
    To assist people porting code from 0.8, the cogl_texture_* functions that
    have been replaced now have defines that give some hint as to how they
    should be replaced.

 clutter/cogl/cogl-deprecated.h |    8 ++++++++
 1 files changed, 8 insertions(+), 0 deletions(-)

commit 605243d95285ad57cf55dc7674884f3ed4b09524
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue May 26 16:55:11 2009 +0100

    [cogl] renamed cogl_enable_* to cogl_set_*_enabled + added getters
    
    cogl_enable_depth_test and cogl_enable_backface_culling have been renamed
    and now have corresponding getters, the new functions are:
      cogl_set_depth_test_enabled
      cogl_get_depth_test_enabled
      cogl_set_backface_culling_enabled
      cogl_get_backface_culling_enabled

 README                                |    3 +++
 clutter/cogl/cogl-deprecated.h        |    1 +
 clutter/cogl/cogl.h.in                |   27 +++++++++++++++++++++++----
 clutter/cogl/common/cogl.c            |   25 +++++++++++++++++--------
 doc/reference/cogl/cogl-sections.txt  |    6 ++++--
 tests/conform/test-backface-culling.c |    4 ++--
 6 files changed, 50 insertions(+), 16 deletions(-)

commit 96188bab621d4a342d67a1e0a85dd1dcb3bdee68
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue May 26 11:33:54 2009 +0100

    [cogl matrix] Support ortho and perspective projections.
    
    This adds cogl_matrix api for multiplying matrices either by a perspective
    or ortho projective transform.  The internal matrix stack and current-matrix
    APIs also have corresponding support added.
    
    New public API:
    cogl_matrix_perspective
    cogl_matrix_ortho
    cogl_ortho
    cogl_set_modelview_matrix
    cogl_set_projection_matrix

 clutter/cogl/cogl-matrix.h                |   70 ++++++++--
 clutter/cogl/cogl.h.in                    |   39 +++++
 clutter/cogl/common/cogl-current-matrix.c |  215 ++++++++++++++++------------
 clutter/cogl/common/cogl-matrix-stack.c   |   68 +++++++---
 clutter/cogl/common/cogl-matrix-stack.h   |   20 ++-
 clutter/cogl/common/cogl-matrix.c         |   87 ++++++++++--
 doc/reference/cogl/cogl-sections.txt      |   19 ++-
 7 files changed, 370 insertions(+), 148 deletions(-)

commit 12c8ff8606c2fb6212e59c50842e04b634f7c4b2
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue May 26 15:41:53 2009 +0100

    [cogl] Remove cogl_{create,destroy}_context from the public API
    
    cogl_create_context is dealt with internally when _cogl_get_default context
    is called, and cogl_destroy_context is currently never called.
    
    It might be nicer later to get an object back when creating a context so
    Cogl can support multiple contexts, so these functions are being removed
    from the API until we get a chance to address context management properly.
    
    For now cogl_destroy_context is still exported as _cogl_destroy_context so
    Clutter could at least install a library deinit handler to call it.

 clutter/cogl/cogl.h.in               |   28 ++++++++++++----------------
 clutter/cogl/gl/cogl-context.c       |    4 ++--
 clutter/cogl/gles/cogl-context.c     |    4 ++--
 doc/reference/cogl/cogl-sections.txt |    3 ---
 4 files changed, 16 insertions(+), 23 deletions(-)

commit 59bd824404c34b20defb2e8e76335185e714efc7
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue May 26 16:27:36 2009 +0100

    [vbo indices] tweak add_indices api to return an id and add delete_indices api
    
    Originally cogl_vertex_buffer_add_indices let the user pass in their own unique
    ID for the indices; now the Id is generated internally and returned to the
    caller.

 clutter/cogl/cogl-vertex-buffer.h           |   30 +++++++++++----
 clutter/cogl/common/cogl-vertex-buffer.c    |   52 +++++++++++++++++---------
 doc/reference/cogl/cogl-sections.txt        |    1 +
 tests/interactive/test-cogl-vertex-buffer.c |   19 +++++-----
 4 files changed, 67 insertions(+), 35 deletions(-)

commit d51faed66095259f17467dceba0cc0cd02dcd042
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun May 24 11:33:29 2009 +0100

    [cogl-vertex-buffer] Seal GL types from the public API
    
    We now have CoglAttributeType and CoglVerticesMode typedefs to replace the
    use of GLenum in the public API.

 clutter/cogl/cogl-vertex-buffer.h           |  118 ++++++++++++++++-----------
 clutter/cogl/common/cogl-vertex-buffer.c    |   48 ++++++------
 tests/interactive/test-cogl-vertex-buffer.c |    6 +-
 3 files changed, 96 insertions(+), 76 deletions(-)

commit 6bb66866660018e90c2c1663e02fca3f0b818050
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sun May 24 04:04:38 2009 +0100

    [cogl-vertex-buffers] Support putting index arrays into VBOS
    
    It's now possible to add arrays of indices to a Cogl vertex buffer and
    they will be put into an OpenGL vertex buffer object. Since it's quite
    common for index arrays to be static it saves the OpenGL driver from
    having to validate them repeatedly.
    
    This changes the cogl_vertex_buffer_draw_elements API: It's no longer
    possible to provide a pointer to an index array at draw time. So
    cogl_vertex_buffer_draw_elements now takes an indices identifier that
    should correspond to an idendifier returned when calling
    cogl_vertex_buffer_add_indices ()

 clutter/cogl/cogl-vertex-buffer.h                |   79 ++++++++---
 clutter/cogl/common/cogl-vertex-buffer-private.h |   33 ++++--
 clutter/cogl/common/cogl-vertex-buffer.c         |  159 ++++++++++++++++++++--
 doc/reference/cogl/cogl-sections.txt             |    2 +
 tests/interactive/test-cogl-vertex-buffer.c      |   17 ++-
 5 files changed, 243 insertions(+), 47 deletions(-)

commit 68214fe4b88603c73a77d5cc543f8688a0bde82c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat May 23 17:52:18 2009 +0100

    [cogl] Remove cogl_flush_gl_state from the API
    
    This is being removed before we release Clutter 1.0 since the implementation
    wasn't complete, and so we assume no one is using this yet.  Util we have
    someone with a good usecase, we can't pretend to support breaking out into
    raw OpenGL.

 clutter/cogl/cogl.h.in     |    8 +++++++-
 clutter/cogl/common/cogl.c |    2 ++
 2 files changed, 9 insertions(+), 1 deletions(-)

commit f322da3794f6556648566ebcf6b83f59f88e7a5b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat May 23 17:42:10 2009 +0100

    [material] Reduce the material API in preperation for releasing Clutter 1.0
    
    There were a number of functions intended to support creating of new
    primitives using materials, but at this point they aren't used outside of
    Cogl so until someone has a usecase and we can get feedback on this
    API, it's being removed before we release Clutter 1.0.

 clutter/cogl/cogl-material.h                |  129 ++++-----------------------
 clutter/cogl/common/cogl-handle.h           |   17 ++--
 clutter/cogl/common/cogl-material-private.h |   86 ++++++++++++++++++
 clutter/cogl/common/cogl-material.c         |    6 +-
 clutter/cogl/common/cogl-primitives.c       |   50 +++++-----
 clutter/cogl/common/cogl-vertex-buffer.c    |   15 ++--
 clutter/cogl/common/cogl.c                  |    3 +-
 clutter/cogl/gl/cogl-context.c              |    4 +-
 clutter/cogl/gl/cogl-primitives.c           |   15 ++--
 clutter/cogl/gles/cogl-context.c            |    4 +-
 clutter/cogl/gles/cogl-primitives.c         |   15 ++--
 doc/reference/cogl/cogl-sections.txt        |    3 +
 12 files changed, 174 insertions(+), 173 deletions(-)

commit f28d5e481b7e01b241618a10e7fde834de3ac2b2
Author: Robert Bragg <robert@linux.intel.com>
Date:   Sat May 23 16:23:00 2009 +0100

    [cogl-material] Removes all the API made redundant by the blend strings API
    
    This removes the following API:
      cogl_material_set_blend_factors
      cogl_material_set_layer_combine_function
      cogl_material_set_layer_combine_arg_src
      cogl_material_set_layer_combine_arg_op
    
    These were rather awkward to use, so since it's expected very few people are
    using them at this point and it should be straight forward to switch over
    to blend strings, the API is being removed before we release Clutter 1.0.

 clutter/cogl/cogl-material.h                |  293 ---------------------------
 clutter/cogl/common/cogl-material-private.h |   20 +-
 clutter/cogl/common/cogl-material.c         |  176 +++--------------
 clutter/pango/cogl-pango-render.c           |   22 +--
 doc/reference/cogl/cogl-sections.txt        |   11 -
 5 files changed, 38 insertions(+), 484 deletions(-)

commit 33994caa71fea904a80971a15216e6d7fa48712c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon May 11 00:40:41 2009 +0100

    [cogl-material] Support string based blending and layer combine descriptions
    
    Setting up layer combine functions and blend modes is very awkward to do
    programatically.  This adds a parser for string based descriptions which are
    more consise and readable.
    
    E.g. a material layer combine function could now be given as:
      "RGBA = ADD (TEXTURE[A], PREVIOUS[RGB])"
    or
      "RGB = REPLACE (PREVIOUS)"
      "A = MODULATE (PREVIOUS, TEXTURE)"
    
    The simple syntax and grammar are only designed to expose standard fixed
    function hardware, more advanced combining must be done with shaders.
    
    This includes standalone documentation of blend strings covering the aspects
    that are common to blending and texture combining, and adds documentation
    with examples specific to the new cogl_material_set_blend() and
    cogl_material_layer_set_combine() functions.
    
    Note: The hope is to remove the now redundant bits of the material API
    before 1.0

 clutter/cogl/cogl-debug.h                   |   20 +-
 clutter/cogl/cogl-material.h                |  244 ++++++-
 clutter/cogl/common/Makefile.am             |    2 +
 clutter/cogl/common/cogl-blend-string.c     |  999 +++++++++++++++++++++++++++
 clutter/cogl/common/cogl-blend-string.h     |  151 ++++
 clutter/cogl/common/cogl-debug.c            |    3 +-
 clutter/cogl/common/cogl-material-private.h |   13 +-
 clutter/cogl/common/cogl-material.c         |  406 +++++++++++-
 clutter/cogl/gl/cogl-context.c              |    3 +
 clutter/cogl/gl/cogl-context.h              |    3 +
 clutter/cogl/gl/cogl-defines.h.in           |   12 +
 clutter/cogl/gl/cogl.c                      |   10 +
 clutter/cogl/gles/cogl-gles2-wrapper.c      |    9 +-
 clutter/cogl/gles/cogl-gles2-wrapper.h      |    5 +-
 clutter/cogl/gles/cogl-texture.c            |   49 +-
 doc/reference/cogl/Makefile.am              |    9 +-
 doc/reference/cogl/blend-strings.xml        |  130 ++++
 doc/reference/cogl/cogl-docs.xml            |    1 +
 doc/reference/cogl/cogl-sections.txt        |    4 +
 tests/conform/Makefile.am                   |    3 +-
 tests/conform/test-blend-strings.c          |  410 +++++++++++
 tests/conform/test-conform-main.c           |    2 +
 22 files changed, 2404 insertions(+), 84 deletions(-)

commit ef1a771fde77e29b8bf327905674da59ea3d0bf0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed May 27 23:39:18 2009 +0100

    [build] Fixes some compiler warnings when building for GLES 2
    
    There were a number of variables shadowing other symbols, and an unused
    display variable.

 clutter/cogl/gles/cogl-gles2-wrapper.c |   20 ++++++++--------
 clutter/cogl/gles/cogl-primitives.c    |   36 ++++++++++++++++----------------
 tests/conform/test-conform-main.c      |    3 +-
 3 files changed, 29 insertions(+), 30 deletions(-)

commit ccd3b4c8863a2a0568d903b4b0273ad05cc17c39
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 27 18:28:37 2009 +0100

    [animation] Simplify the Animation code
    
    After long deliberation, the Animation class handling of the
    :mode, :duration and :loop properties, as well as the conditions
    for creating the Alpha and Timeline instances, came out as far too
    complicated for their own good.
    
    This is a rework of the API/parameters matrix and behaviour:
    
      - :mode accessors will create an Alpha, if needed
      - :duration and :loop accessors will create an Alpha and a Timeline
        if needed
      - :alpha will set or unset the Alpha
      - :timeline will set or unset the Timeline
    
    Plus, more documentation on the Animation class itself.
    
    Many thanks to Jonas Bonn <jonas@southpole.se> for the feedback
    and the ideas.

 clutter/clutter-animation.c |  420 ++++++++++++++++++-------------------------
 1 files changed, 174 insertions(+), 246 deletions(-)

commit 6fff1bcdc6cd90bfc75eff765c7512545fedded9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 27 13:01:31 2009 +0100

    [animatable] Allow validation in ::animate_property
    
    The Animatable interface implementation will always have the computed
    value applied, whilst the non-Animatable objects go through the
    interval validation first to avoid incurring in assertions and
    warnings.
    
    The Animatable::animate_property() should also be able to validate the
    property it's supposed to interpolate, and eventually discard it. This
    requires adding a return value to the virtual function (and its wrapper
    function).
    
    The Animation code will then apply the computed value only if the
    animate_property() returns TRUE -- unifying the code path with the
    non-Animatable objects.

 clutter/clutter-animatable.c |   43 +++++++++++++++++++++++++----------------
 clutter/clutter-animatable.h |   28 +++++++++++++-------------
 clutter/clutter-animation.c  |   21 +++++++++++--------
 3 files changed, 52 insertions(+), 40 deletions(-)

commit 7edaf8ece8af8c1f9bf7dd25263ec16dee5adf69
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 27 12:12:11 2009 +0100

    [animation] Proxy properties whenever possible
    
    The Animation class should proxy the :mode, :duration and :loop
    properties whenever possible, to avoid them going out of sync when
    changed using the Alpha and Timeline instances directly.
    
    Currently, if Timeline:duration is changed, querying Animation:duration
    will yield the old value, but the animation itself (being driven by
    the Timeline) will use the Timeline's :duration new value. This holds
    for the :loop and :mode properties as well.
    
    Instead, the getters for the Animation's :duration, :loop and
    :mode properties should ask the relevant object -- if any. The
    loop, duration and mode values inside AnimationPrivate should only
    be used if no Timeline or no Alpha instances are available, or
    when creating new instances.

 clutter/clutter-animation.c |   60 +++++++++++++++++++++++++++++++++----------
 1 files changed, 46 insertions(+), 14 deletions(-)

commit 1f44c3584c9040a6745f052ad7ce7ffd9dc399a9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 27 11:52:40 2009 +0100

    [animation] Defer the timeline handling to the Alpha
    
    The Animation should not directly manipulate a Timeline instance,
    but it should defer to the Alpha all handling of the timeline.
    
    This means that:
    
      - set_duration() and set_loop() will either create a Timeline or
        will set the :duration and :loop properties on the Timeline; if
        the Timeline must be created, and no Alpha instance is available,
        then a new Alpha instance will be created as well and the newly
        create Timeline will be assigned to the Alpha
    
      - if set_mode() on an Animation instance without an Alpha, the
        Alpha will be created; a Timeline will also be created
    
      - set_alpha() will replace the Alpha; if the new Alpha does not
        have a Timeline associated then a Timeline will be created using
        the current :duration and :loop properties of Animation; otherwise,
        if the replaced Alpha had a timeline, the timeline will be
        transferred to the new one

 clutter/clutter-animation.c |  342 +++++++++++++++++++++++++++++--------------
 1 files changed, 231 insertions(+), 111 deletions(-)

commit 331d43196da1a76fe5abe138639674b0cb9fbd47
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue May 26 17:23:24 2009 +0100

    [build] Decouple COGL debug level from Clutter's
    
    Using --enable-debug, which controls Clutter's debug level, also
    defines COGL_ENABLE_DEBUG. This should be left to --enable-cogl-debug
    instead, since it's the configure switch that controls COGL debug
    level.

 configure.ac |   16 ++++++++--------
 1 files changed, 8 insertions(+), 8 deletions(-)

commit 387ab4c142c8c3b4708e08be540b279fcda8ffd8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon May 25 17:16:44 2009 +0100

    [doap] Update
    
    Long overdue update of the DOAP file for Clutter
    
    * Repository update
    
    * Add authors

 clutter.doap |   61 +++++++++++++++++++++++++++++++++++++++++----------------
 1 files changed, 44 insertions(+), 17 deletions(-)

commit 733508b80d30a0946061c55e599f1348ea895140
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon May 25 16:52:53 2009 +0100

    [build] More spring clean fixes
    
    * Remove the last if...fi with AS_IF
    
    * Put back the regexp for the mingw32 check that commit 0d1c626a
      inadvertedly removed

 configure.ac |   55 +++++++++++++++++++++++++++++++------------------------
 1 files changed, 31 insertions(+), 24 deletions(-)

commit 0d1c626a86fdec432d5bb7ca78aec76ec1fecf7e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon May 25 14:04:53 2009 +0100

    [build] Spring cleanup of configure.ac
    
    Let's try to bring configure.ac into this century, shall we?
    
    * Use the proper shell macros AS_IF and AS_CASE instead of if...fi
      and case...esac
    
    * Check for X11 and relative extensions only when building for GLX
      and EGLX backends
    
    * Add documentation on the behaviour of binary_age and interface_age
    
    * Coalesce all the common checks to avoid redundancy
    
    * Escape everything that requires escaping

 configure.ac | 1057 +++++++++++++++++++++++++++++-----------------------------
 1 files changed, 534 insertions(+), 523 deletions(-)

commit b05d4be19d07a834120bac6bbeacca31daae51b9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon May 25 12:42:17 2009 +0100

    Use GLib variant of strcasecmp()
    
    The GLib version of strcasecmp() ignores any non-ASCII character,
    unlike the original which is locale-dependent.

 clutter/glx/clutter-backend-glx.c        |    2 +-
 clutter/glx/clutter-glx-texture-pixmap.c |    4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

commit ec374c7ab9d5b98230a90a4be7b8ca6f5337f2b8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon May 25 12:41:16 2009 +0100

    [build] Clean up cogl-pango Makefile

 clutter/pango/Makefile.am |   26 +++++++++++++-------------
 1 files changed, 13 insertions(+), 13 deletions(-)

commit 71498a6376f3c45e6fec228251ec11b9c2dc4cd1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat May 23 19:18:18 2009 +0100

    [cogl] Remove max_waste argument from Texture ctors
    
    The CoglTexture constructors expose the "max-waste" argument for
    controlling the maximum amount of wasted areas for slicing or,
    if set to -1, disables slicing.
    
    Slicing is really relevant only for large images that are never
    repeated, so it's a useful feature only in controlled use cases.
    Specifying the amount of wasted area is, on the other hand, just
    a way to mess up this feature; 99% the times, you either pull this
    number out of thin air, hoping it's right, or you try to do the
    right thing and you choose the wrong number anyway.
    
    Instead, we can use the CoglTextureFlags to control whether the
    texture should not be sliced (useful for Clutter-GST and for the
    texture-from-pixmap actors) and provide a reasonable value for
    enabling the slicing ourself. At some point, we might even
    provide a way to change the default at compile time or at run time,
    for particular platforms.
    
    Since max_waste is gone, the :tile-waste property of ClutterTexture
    becomes read-only, and it proxies the cogl_texture_get_max_waste()
    function.
    
    Inside Clutter, the only cases where the max_waste argument was
    not set to -1 are in the Pango glyph cache (which is a POT texture
    anyway) and inside the test cases where we want to force slicing;
    for the latter we can create larger textures that will be bigger than
    the threshold we set.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>
    Signed-off-by: Robert Bragg <robert@linux.intel.com>
    Signed-off-by: Neil Roberts <neil@linux.intel.com>

 clutter/clutter-texture.c                     |  116 +++++++------------------
 clutter/clutter-texture.h                     |    4 +-
 clutter/cogl/cogl-texture.h                   |   34 +++-----
 clutter/cogl/cogl-types.h                     |    4 +-
 clutter/cogl/common/cogl-util.c               |    1 +
 clutter/cogl/gl/cogl-context.c                |    6 +-
 clutter/cogl/gl/cogl-texture.c                |   81 +++++++++--------
 clutter/cogl/gles/cogl-context.c              |    6 +-
 clutter/cogl/gles/cogl-texture.c              |   60 ++++++++------
 clutter/glx/clutter-glx-texture-pixmap.c      |    2 +-
 clutter/pango/cogl-pango-glyph-cache.c        |    2 +-
 tests/conform/test-backface-culling.c         |   36 ++++----
 tests/conform/test-npot-texture.c             |   28 ++++---
 tests/conform/test-vertex-buffer-contiguous.c |    3 +-
 tests/interactive/test-clip.c                 |    2 +-
 tests/interactive/test-cogl-multitexture.c    |   18 ++--
 tests/interactive/test-cogl-offscreen.c       |    4 +-
 tests/interactive/test-cogl-tex-convert.c     |    8 +-
 tests/interactive/test-cogl-tex-getset.c      |    4 +-
 tests/interactive/test-cogl-tex-polygon.c     |    6 +-
 tests/interactive/test-cogl-tex-tile.c        |    2 +-
 21 files changed, 191 insertions(+), 236 deletions(-)

commit 87465355d3415a28fc6b3e4f62611cc3192516d8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Mar 30 13:49:03 2009 +0100

    Add repaint functions
    
    Sometimes it is necessary for third party code to have a
    function called during the redraw process, so that you can
    update the scenegraph before it is painted.

 clutter/clutter-main.c    |  159 +++++++++++++++++++++++++++++++++++++++++++++
 clutter/clutter-main.h    |   62 +++++++++--------
 clutter/clutter-private.h |    4 +
 clutter/clutter-stage.c   |    9 ++-
 4 files changed, 203 insertions(+), 31 deletions(-)

commit 5cde6a598f7b846615b817002389fcae954f612a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat May 23 19:32:24 2009 +0100

    [git ignore] Add test-text-perf

 .gitignore |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 654c26a1301c9bc5f8e3e5e3b68af5eb1b2e0673
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri May 22 14:49:37 2009 +0100

    [actor] In paint when opacity == 0, clear the queued_redraw flag
    
    If we are short-circuiting the paint when the opacity is zero we still
    need to clear the queued_redraw flag otherwise it won't be possible to
    queue another redraw of the actor until something else has caused a
    paint first.

 clutter/clutter-actor.c |    5 ++++-
 1 files changed, 4 insertions(+), 1 deletions(-)

commit c262ab0b638eba97e8a152ca5c76360d0f4bf348
Merge: 309f680 b3fe1b8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri May 22 12:00:33 2009 +0100

    Merge branch 'master' into 1.0-integration
    
    * master:
      [cogl-vertex-buffer] Ensure the clip state before rendering
      [test-text-perf] Small fix-ups
      Add a test for text performance
      [build] Ensure that cogl-debug is disabled by default
      [build] The cogl GE macro wasn't passing an int according to the format string
      Use the right internal format for GL_ARB_texture_rectangle
      [actor_paint] Ensure painting is a NOP for actors with opacity = 0
      Make backface culling work with vertex buffers

commit b3fe1b8a8a663fc8ac5e2388c7dbc7aa20929bce
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri May 22 11:41:02 2009 +0100

    [cogl-vertex-buffer] Ensure the clip state before rendering
    
    Before any rendering is done by Cogl it needs to ensure the clip stack
    is set up correctly by calling cogl_clip_ensure. This was not being
    done for the Cogl vertex buffer so it would still use the clip from
    the previous render.

 clutter/cogl/common/cogl-vertex-buffer.c |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit 309f680d323f25a83f0a529e499f84f301708e79
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri May 22 01:23:29 2009 +0100

    [texture] size-change closure is now VOID:FLOAT,FLOAT
    
    Now that everything is float, the marsharlling function of the
    size-change signal should reflect that fact.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-marshal.list |    1 +
 clutter/clutter-texture.c    |    4 ++--
 2 files changed, 3 insertions(+), 2 deletions(-)

commit a1b0160da7b72a92178d58c514d3988b2761a688
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 21 17:43:41 2009 +0100

    [test-text-perf] Small fix-ups
    
    - Fix a typo in a for loop in create_label which left 'i'
      uninitialised and caused a crash if you're unlucky.
    
    - Set the CLUTTER_VBLANK=none environment variable.
    
    - Don't quit on a keypress.
    
    - Trailing whitespace tidy up.

 tests/micro-bench/test-text-perf.c |   19 +++++++++----------
 1 files changed, 9 insertions(+), 10 deletions(-)

commit 8724a16452eb4cb577ba6a7763a8491e2935f9a5
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Nov 22 19:26:56 2008 -0500

    Add a test for text performance
    
    Add tests/test-text-perf, which allows testing text performance as
    a function of the length of text strings and font size.

 tests/micro-bench/Makefile.am      |    4 +-
 tests/micro-bench/test-text-perf.c |  123 ++++++++++++++++++++++++++++++++++++
 2 files changed, 126 insertions(+), 1 deletions(-)

commit d513c1c5403e9f92178d3ed7202d78b0db6efe67
Merge: 1985fa7 7e18109
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 21 16:51:16 2009 +0100

    Merge branch 'pango-vbo' into 1.0-integration
    
    This makes it cache the geometry of PangoLayouts into a VBO as
    described in bug #1572.

commit 7e18109f9bec0afba900534a9c96035ae1f32dd7
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 21 15:49:14 2009 +0100

    [cogl-pango-display-list] Use GL_TRIANGLES under GLES
    
    GLES doesn't support GL_QUADS. This patch makes it use GL_TRIANGLES
    instead in that case. Unfortunately this means submitting two extra
    vertices per quad. It could be better to use indexed elements once
    CoglVertexBuffers gains support for that.

 clutter/pango/cogl-pango-display-list.c |   28 +++++++++++++++++++++++++++-
 1 files changed, 27 insertions(+), 1 deletions(-)

commit 78a4f1de0d934b83d5ed30d33ac992f32c1b71c6
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu May 21 15:25:31 2009 +0100

    [build] Ensure that cogl-debug is disabled by default
    
    The new cogl-debug option was accidentally being enabled by default since
    configure.ac checked the 'default_enable' variable not 'cogl_default_enable'

 configure.ac |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 14c3ef1f8dab9390cbdb078ef4663b5ea88a78ce
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu May 21 15:04:38 2009 +0100

    [build] The cogl GE macro wasn't passing an int according to the format string
    
    This patch simply updates the arguments passed to g_warning inline with the
    given format string.

 clutter/cogl/common/cogl-internal.h |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 5481681e5c74a8eb994935e5a14d08cc4372a791
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Wed May 6 23:35:01 2009 -0400

    Use the right internal format for GL_ARB_texture_rectangle
    
    When ClutterGLXTexturePixmap uses GL_ARB_texture_rectangle,
    it needs to pass the right internal format (GL_RGB or GL_RGBA)
    when it initializes the texture with glTexImage2D() or later
    handling won't recognize the alpha channel.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1586
    
    Signed-off-by: Robert Bragg <robert@linux.intel.com>

 clutter/glx/clutter-glx-texture-pixmap.c |    7 +++++--
 1 files changed, 5 insertions(+), 2 deletions(-)

commit 2c6719502a1e22f4e910ef3514ba5bdf8b1f0c83
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed May 20 17:55:29 2009 +0100

    [actor_paint] Ensure painting is a NOP for actors with opacity = 0
    
    Since it is convenient to use geometry with an opacity of 0 for input only
    purposes it's a worthwhile optimization to avoid submitting anything
    for such actors while painting.

 clutter/clutter-actor.c |   11 ++++++++++-
 1 files changed, 10 insertions(+), 1 deletions(-)

commit f13c3ee3095ecb1c2ab6b8efbe25362967bc513e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 21 14:56:38 2009 +0100

    Make backface culling work with vertex buffers
    
    Backface culling is enabled as part of cogl_enable so the different
    rendering functions in Cogl need to explicitly opt-in to have backface
    culling enabled. Cogl vertex buffers should allow backface culling so
    they should check whether it is enabled and then set the appropriate
    cogl_enable flag.

 clutter/cogl/cogl.h.in                   |    6 +++---
 clutter/cogl/common/cogl-vertex-buffer.c |    3 +++
 2 files changed, 6 insertions(+), 3 deletions(-)

commit 3fc64dfaa799828c3e0743df60de4255dac58d60
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 21 12:17:12 2009 +0100

    [pango-render] Keep a reference to the first line to detect layout changes
    
    In order to cope with the situation where an application renders with
    a PangoLayout, makes some changes and then renders again with the same
    layout, CoglPangoRenderer needs to detect that the changes have
    occured so that it can recreate the display list. This is acheived by
    keeping a reference to the first line of the layout. When the layout
    is changed Pango will clear the layout pointer in the first line and
    create a new line. So if the layout pointer in the line becomes NULL
    then we know the layout has changed. This trick was suggested by
    Behdad Esfahbod in this email:
    
    http://mail.gnome.org/archives/gtk-i18n-list/2009-May/msg00019.html

 clutter/pango/cogl-pango-render.c |   81 ++++++++++++++++++++++++++++++------
 1 files changed, 67 insertions(+), 14 deletions(-)

commit 085be4cebc6f021d8deb114e7984fdfc49665f40
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu May 21 12:09:16 2009 +0100

    [cogl-pango-render] Fix the positioning when calling cogl_pango_render_layout
    
    When a position is given to cogl_pango_render_layout_subpixel it
    translates the GL matrix by the coordinates. However it was not
    dividing by PANGO_SCALE so the coordinates were completely wrong.

 clutter/pango/cogl-pango-render.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 1985fa75b1929b005d4b5ff46d62ae840f62f38d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 20 17:38:58 2009 +0100

    [texture] Use a box instead of int coordinates
    
    Most of the operations involving the texture's allocated area require
    floats -- either for computations or for setting the geometry into
    COGL. So it doesn't make any sense to use get_allocation_coords() and
    cast everything to floats.

 clutter/clutter-texture.c |   16 ++++++++--------
 1 files changed, 8 insertions(+), 8 deletions(-)

commit 3428e4dd1d1f852521efbc4b1590370b050173b1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 20 17:26:39 2009 +0100

    [actor] Do not try to dereference NULL data
    
    If the shader_data bound to an Actor is NULL we should not try to access
    its members.

 clutter/clutter-actor.c |   16 +++++++++-------
 1 files changed, 9 insertions(+), 7 deletions(-)

commit f8f54989be460f8ae7abda7c2dc01eb578471742
Merge: aa1246e 4f5a5f3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 20 16:49:22 2009 +0100

    Merge commit 'origin/master' into 1.0-integration
    
    Conflicts:
    	clutter/clutter-texture.c
    	clutter/cogl/gl/cogl-fbo.c

commit 4f5a5f38f7068d4ec0dca9967f304a39901e8fec
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 20 16:06:09 2009 +0100

    Add more padding in Model and ModelIter classes
    
    ClutterModel and ClutterModelIter have 4 padding slots, but if they
    have to survive the 1.x API cycle they will need at least twice that
    amount.

 clutter/clutter-model.h |   12 ++++++++++--
 1 files changed, 10 insertions(+), 2 deletions(-)

commit c74586d019a4651d52938610894c0396f02294bb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 20 15:15:25 2009 +0100

    [cogl] Do no include gprintf.h
    
    We are not using any of the g_printf* family of functions, so we
    can import glib.h instead.

 clutter/cogl/common/cogl-vertex-buffer.c |    3 +--
 1 files changed, 1 insertions(+), 2 deletions(-)

commit 1f1d19f63450f52caa7231738cad84067486a2ba
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue May 19 16:00:18 2009 +0100

    [cogl] Move debugging to a configure-time switch
    
    Currently, COGL depends on defining debug symbols by manually
    modifying the source code. When it's done, it will forcefully
    print stuff to the console.
    
    Since COGL has also a pretty, runtime selectable debugging API
    we might as well switch everything to it.
    
    In order for this to happen, configure needs a new:
    
            --enable-cogl-debug
    
    command line switch; this will enable COGL debugging, the
    CoglHandle debugging and will also turn on the error checking
    for each GL operation.
    
    The default setting for the COGL debug defines is off, since
    it slows down the GL operations; enabling it for a particular
    debug build is trivial, though.

 clutter/cogl/cogl-debug.h           |    3 ++-
 clutter/cogl/common/Makefile.am     |    2 +-
 clutter/cogl/common/cogl-debug.c    |    3 ++-
 clutter/cogl/common/cogl-handle.h   |   23 ++++++++++++-----------
 clutter/cogl/common/cogl-internal.h |    7 +++----
 clutter/cogl/gl/Makefile.am         |    2 +-
 clutter/cogl/gles/Makefile.am       |    2 +-
 configure.ac                        |   21 ++++++++++++++++++++-
 8 files changed, 42 insertions(+), 21 deletions(-)

commit df1a9b7a74880d60fe1f00a7e35b8b620705701a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue May 19 14:44:29 2009 +0100

    [cogl] Rework the debug messages
    
    COGL has a debug message system like Clutter's own. In parallel,
    it also uses a coupld of #defines. Spread around there are also
    calls to printf() instead to the more correct g_log* wrappers.
    
    This commit tries to unify and clean up the macros and the
    debug message handling inside COGL to be more consistent.

 clutter/cogl/common/cogl-handle.h     |  145 ++++++++++++++++-----------------
 clutter/cogl/common/cogl-internal.h   |   43 ++++------
 clutter/cogl/common/cogl-primitives.c |   30 ++++---
 clutter/cogl/common/cogl.c            |   31 +++++--
 clutter/cogl/gl/cogl-texture.c        |   22 +----
 clutter/cogl/gles/cogl-texture.c      |   11 ---
 6 files changed, 131 insertions(+), 151 deletions(-)

commit 529e48fbbe95f9fe2d8db631b129391d9c2f36c9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue May 19 14:42:37 2009 +0100

    Remove duplicate cogl-internal.h header
    
    The cogl-internal.h header has been moved inside cogl/common in
    commit 8a1b4f8326 but has been left behind inside cogl/gl and
    cogl/gles.

 clutter/cogl/gl/Makefile.am       |    1 -
 clutter/cogl/gl/cogl-internal.h   |   66 --------------------------
 clutter/cogl/gles/Makefile.am     |    1 -
 clutter/cogl/gles/cogl-internal.h |   93 -------------------------------------
 4 files changed, 0 insertions(+), 161 deletions(-)

commit 407ac5075fb5737aff3730773ec9ccba2dbe7fd0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue May 19 12:51:29 2009 +0100

    [texture] Add missing accessors
    
    ClutterTexture has many properties that can only be accessed using
    the GObject API. This is fairly inefficient and makes binding the
    class overly complicated.
    
    The Texture class should have accessor methods for all its properties,
    properly documented.

 clutter/clutter-texture.c                  |  453 +++++++++++++++++++++++-----
 clutter/clutter-texture.h                  |   45 ++-
 doc/reference/clutter/clutter-sections.txt |   13 +
 3 files changed, 429 insertions(+), 82 deletions(-)

commit 3115a6168836ff65ce58c31458d7672400458d74
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon May 18 19:38:03 2009 +0100

    [cogl] Rework the GL-error-to-string conversion
    
    The code for the conversion of the GL error enumeration code
    into a string is not following the code style and conventions
    we follow in Clutter and COGL.
    
    The GE() macro is also using fprintf(stderr) directly instead
    of using g_warning() -- which is redirectable to an alternative
    logging system using the g_log* API.

 clutter/cogl/common/cogl-internal.h |   22 +++++++-------
 clutter/cogl/common/cogl.c          |   52 ++++++++++++++++++-----------------
 2 files changed, 38 insertions(+), 36 deletions(-)

commit e725bd21bf6b0760ed099b6e7136765774cf2093
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue May 19 12:53:37 2009 +0100

    [gitignore] Add more gtk-doc droppings

 .gitignore |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit cd3acca2b793c45c81ea4fdc053f82aa2b0ffe21
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 23:23:00 2009 +0100

    [build] Link Cogl against -lm
    
    We use math routines inside Cogl, so it's correct to have it in
    the LIBADD line. In normal usage something else was pulling in
    -lm, but the introspection is relying on linking against the
    convenience library.
    
    Based on a patch by: Colin Walters <walters@verbum.org>
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/cogl/common/Makefile.am |   10 +++-------
 clutter/cogl/gl/Makefile.am     |    9 +++------
 clutter/cogl/gles/Makefile.am   |   13 ++++---------
 3 files changed, 10 insertions(+), 22 deletions(-)

commit 08ac50faaeca28703e3f5495c76a72edca3c17f0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 19:51:03 2009 +0100

    [build] List cogl-internal.h
    
    During the Makefile clean up, cogl-internal.h got lost and this
    broke the dist. Let's put it back in.

 clutter/cogl/common/Makefile.am |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

commit 2f5012e38cd6566d01b98fb44679c9b431dbd473
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 7 18:39:07 2009 +0100

    [animation] Do not leak timelines
    
    The timeline created when calling set_timeline(NULL) is referenced
    even though we implicitly own it. When the Animation is destroyed,
    the timeline is then leaked.
    
    Thanks to: Richard Heatley <richard.heatley@starleaf.com>
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1548

 clutter/clutter-animation.c |   20 ++++++++++++--------
 1 files changed, 12 insertions(+), 8 deletions(-)

commit 21e3901d6248ceb9fd4e3c0c82565817774f463f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 6 17:18:12 2009 +0100

    [text] Expose position_to_coords()
    
    The clutter_text_position_to_coords() is useful for ClutterText
    subclasses.
    
    See bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1521
    
    Based on a patch by: Raymond Liu <raymond.liu@intel.com>

 clutter/clutter-text.c                     |   33 ++++++++++++++++-----------
 clutter/clutter-text.h                     |    5 ++++
 doc/reference/clutter/clutter-sections.txt |    1 +
 3 files changed, 25 insertions(+), 14 deletions(-)

commit ca238387521d2df289e8df81ddf9e01597bed046
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 6 17:08:25 2009 +0100

    [text] Add ClutterText::delete_selection()
    
    Add a method for deleting the current selection inside a Text actor.
    
    This is useful for subclasses.
    
    See bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1521
    
    Based on a patch by: Raymond Liu <raymond.liu@intel.com>

 clutter/clutter-text.c                     |   47 +++++++++++++++++++---------
 clutter/clutter-text.h                     |    1 +
 doc/reference/clutter/clutter-sections.txt |    1 +
 3 files changed, 34 insertions(+), 15 deletions(-)

commit 79cb0a3515325dcf183684eb9809fd66abff478a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 6 17:01:44 2009 +0100

    [animation] Remove InitiallyUnowned from Animation
    
    ClutterAnimation currently inherits the initial floating reference
    semantics from GInitiallyUnowned. An Animation is, though, meant to
    be used as a top-level object, like a Timeline or a Behaviour, and
    not "owned" by another object. For this reason, the initial floating
    reference does not make any sense.

 clutter/clutter-animation.c |   18 ++++++++----------
 clutter/clutter-animation.h |    4 ++--
 2 files changed, 10 insertions(+), 12 deletions(-)

commit 0f7a3b973952505e85e93d0bde59be48973fbeb2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 6 16:43:52 2009 +0100

    [docs] Add Animation get_type() function
    
    We need to reference clutter_animation_get_type() if we want the
    properties, signals and object hierarchy to show up in the API
    reference

 doc/reference/clutter/clutter.types |    1 +
 1 files changed, 1 insertions(+), 0 deletions(-)

commit 092b41d53b793a985d5234acfa9df007b16be4c3
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 6 16:42:57 2009 +0100

    [docs] Document the destructor for Timeline
    
    The rest of the API reference lists the destructor for the class
    inside the constructor's return value -- except Timeline.

 clutter/clutter-timeline.c |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

commit 1c6580afd67526d1f8e7ee114fdcd69b83e9f4c6
Author: Dan Winship <danw@gnome.org>
Date:   Thu May 14 09:28:12 2009 -0400

    [cairo-texture] Document redrawing behavior
    
    Document that repeated calls to clutter_cairo_texture_create()
    continue drawing on the same cairo_surface_t. Add
    clutter_cairo_texture_clear() for when you don't want that behavior.
    
    http://bugzilla.openedhand.com/show_bug.cgi?id=1599
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-cairo-texture.c |   31 +++++++++++++++++++++++++++++++
 clutter/clutter-cairo-texture.h |    6 ++++--
 2 files changed, 35 insertions(+), 2 deletions(-)

commit 81a536238d539fb87b24b7815408c4916fa63da6
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 15:08:31 2009 +0100

    [text] fix problems with scrolling interaction
    
    The cursor x position is already translated, so we do not need to take the
    actors allocation into account when calculating scrolling.
    
    Additionally, we need to update the text_x value before running
    clutter_text_ensure_cursor_position.

 clutter/clutter-text.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

commit a3a5fe5594301778ec78f161dfeffac113d89901
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 13:31:51 2009 +0100

    [text] scroll to the cursor position if it is outside the allocation
    
    Adjust the text offset to keep the cursor within the allocation. This means
    the text will scroll per character

 clutter/clutter-text.c |   22 +++++++++++++---------
 1 files changed, 13 insertions(+), 9 deletions(-)

commit cf6c2d9721b96123f20c9ed26f8066dba502a035
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 10:55:25 2009 +0100

    [text] account for scrolling in text selections
    
    Account for any scrolling offset in single line mode when calculating the
    area that should be selected.

 clutter/clutter-text.c |    6 ++++++
 1 files changed, 6 insertions(+), 0 deletions(-)

commit e79fd1055d5d220a2460fc5ada0e74d7456aedf2
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 10:53:44 2009 +0100

    [text] account for scrolling in clutter_text_position_to_coords
    
    Add any scrolling offset to the x value when in single line mode.
    
    Now that the offset is taken into account in the position_to_coords
    function, we do not need to adjust the cursor x manually in
    clutter_text_paint.

 clutter/clutter-text.c |   10 +++++++++-
 1 files changed, 9 insertions(+), 1 deletions(-)

commit 16185c78fc59f8538f0a439908bd43ae8ee981fe
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 10:51:58 2009 +0100

    [text] take scrolling into account when calculating cursor position
    
    Account for the scrolling in single line more when calculating the cursor
    position from coordinates.

 clutter/clutter-text.c |    4 ++++
 1 files changed, 4 insertions(+), 0 deletions(-)

commit e162d0b0607e9221b360cfe7b0d61a2b4b44edd9
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 10:17:24 2009 +0100

    [text] position the cursor correctly in single line mode
    
    The position of the text should be increased by the value of TEXT_PADDING
    and the cursor offset by the same value as the text offset.

 clutter/clutter-text.c |    7 +++----
 1 files changed, 3 insertions(+), 4 deletions(-)

commit cd86e70f4150505a035ea074aed06e4bd3fbb9df
Author: Thomas Wood <thomas.wood@intel.com>
Date:   Thu May 14 09:53:41 2009 +0100

    [text] take text padding into account when in single line mode
    
    In single line mode, extra padding is added to the text which must be
    taken into account when reporting the natural size of the actor.

 clutter/clutter-text.c |    7 ++++++-
 1 files changed, 6 insertions(+), 1 deletions(-)

commit 92e439105697fe65d8c6dda08d1658774245e9cb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 12:05:57 2009 +0100

    [tests] Verify cursor position
    
    Print out the cursor and selection positions in order to verify
    the behaviour of the Text actor.
    
    This is a likely candidate for a conformance test unit as well.

 tests/interactive/test-text-field.c |    5 ++++-
 1 files changed, 4 insertions(+), 1 deletions(-)

commit 0d43d81ee04ea456edb3159aa0e0c71e2f869f62
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 12:00:51 2009 +0100

    [text] Maintain the cursor at the end when deleting
    
    If the cursor is already at the end of the Text contents then we
    need to maintain its position when deleting the previous character
    using the relative key binding.

 clutter/clutter-text.c |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

commit 8174f66cc60a70e60eb98b0097416f898e8df485
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 11:50:42 2009 +0100

    [text] Reset the cursor when setting empty text
    
    When setting the contents of Text to an empty string we should
    reset the cursor position and selection bound to -1.

 clutter/clutter-text.c |   10 ++++++++++
 1 files changed, 10 insertions(+), 0 deletions(-)

commit 608c3e3ab45ab262e9b89f8a78cdf2f057dca570
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 10:02:06 2009 +0100

    [build] Fix with --disable-introspection
    
    The required "fake" libclutter-cogl.la upon with the main clutter
    shared object depends is only built with introspection enabled
    instead of being built unconditionally.

 clutter/cogl/Makefile.am |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

commit 724e58a85a35e249490e54d27e7f9411033db3a9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu May 14 08:32:46 2009 +0100

    [build] Do not rebuild the conformance tests scripts
    
    Make the build output a little bit cleaner by not re-creating the
    small shell scripts that allow launching the test units separately.

 .gitignore                |    1 +
 tests/conform/Makefile.am |   10 +++++++---
 2 files changed, 8 insertions(+), 3 deletions(-)

commit d8aa6827ee310115b3f0a466c0798e4e5c1e5780
Author: Owen W. Taylor <otaylor@redhat.com>
Date:   Wed May 13 23:14:24 2009 +0100

    Don't build Cogl.gir against installed Clutter library
    
    Passing:
    
     --library=clutter-@CLUTTER_FLAVOUR@-@CLUTTER_API_VERSION@
    
    to g-ir-scanner, when building Cogl was causing g-ir-scanner to
    link the introspection program against the installed clutter library,
    if it existed or fail otherwise. Instead copy the handling from
    the json/ directory where we link against the convenience library
    to scan, and do the generation of the typelib later in the
    main clutter/directory.
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1594
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 .gitignore               |    5 +++--
 clutter/Makefile.am      |   30 ++++++++++++++++++++----------
 clutter/cogl/Makefile.am |   29 +++++++++++------------------
 3 files changed, 34 insertions(+), 30 deletions(-)

commit 447e04bdce9b95bb1fc544d4c931071fa3665825
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 13 23:04:25 2009 +0100

    [text] Return the correct minimum height
    
    If text is set, ClutterText should never return less than the layout
    height for minimum and preferred heights.
    
    This holds unless ellipsize and wrap are enabled, in which case the
    minimum height should be the height of the first line -- which is
    the height needed to at the very least show the ellipsization.
    
    Based on a patch by: Thomas Wood <thomas@openedhand.com>
    
    Fixes bug:
    
      http://bugzilla.openedhand.com/show_bug.cgi?id=1598
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-text.c |   24 +++++++++++++++++++-----
 1 files changed, 19 insertions(+), 5 deletions(-)

commit aa1246e8917f0977bd03b97c206d4c2a01ff8599
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed May 13 22:21:48 2009 +0100

    [backend] Abstract the GL context creation
    
    This is the another step into abstracting the backend operations
    that are currently spread all across the board back into the
    backend implementations where they belong.
    
    The GL context creation, for instance, is demanded to the stage
    realization which makes it a critical path for every operation
    that is GL-context bound. This usually does not make any difference
    since we realize the default stage, but at some point we might
    start looking into avoiding the default stage realization in order
    to make the Clutter startup faster.
    
    It also makes the code maintainable because every part is self
